/**
 *电影场景相关操作
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
/**
 * 电影场景相关
 */
.controller('MovieSceneDetailCtrl', function(ENV,$scope,$rootScope,$ionicScrollDelegate,NotifySvc,
                                             $state,$ionicPopup,Movies,User,Toast,$stateParams,$ionicLoading,$timeout){

    /*
     * 函数功能: 进入当前视图时, 无论缓存与否, 都设置买票教学提醒页面
     * */

        $scope.teachBuyTicket = {
            src1: "img/buyTicket_03.png",
            src2: "img/buyTicket_07.png"
        };
        $scope.isHideTeachPicture = false;
        if(!$scope.hideTeachPicture) {
            $scope.hideTeachPicture = function () {
                $scope.isHideTeachPicture = true;
            };
        }

    //电影院电影列表
  $scope.SceneMovieList= [];//movie的list
  $scope.SceneList = [];//场次list
  var SceneMovieList;
  var senceId;
  var defaultmovie = 0; //默认查询电影，和ui焦点index
  var mId;//默认查询电影的id
  var currentclickdata = 0; //点击今天的电影
  $scope.moviename;//电影名字
  var cId = $stateParams.id;//$stateParams.id;
  $scope.cinemaName = decodeURIComponent($stateParams.name);//电影院$stateParams.name;
  $scope.cinemaAddr = decodeURIComponent($stateParams.addr);//电影院$stateParams.addr;
  var  DateList=[{"date":""},{"date":""},{"date":""},];
  $scope.isLoading = false;
  function checkTime(i)
  {
  if (i<10)
    {i="0" + i}
    return i
  };
  var currentdata = new Date();
  var tomorrodata = new Date();
  var threedaydata = new Date();
  tomorrodata.setDate(currentdata.getDate()+1);
  threedaydata.setDate(currentdata.getDate()+2);
  // var cyear=currentdata.getFullYear()
  var cday = checkTime(currentdata.getDate());
  // var chours = currentdata.getHours();
  // var cminutes = currentdata.getMinutes();
  // var cmonth = checkTime(currentdata.getMonth()+1);

  var showDay = currentdata.getFullYear() + "-"+checkTime(currentdata.getMonth()+1) +"-"+checkTime(currentdata.getDate());
  var tomorowDay = tomorrodata.getFullYear() + "-" + checkTime(tomorrodata.getMonth()+1) + "-" + checkTime(tomorrodata.getDate());
  var houDay = threedaydata.getFullYear() + "-" + checkTime(threedaydata.getMonth()+1) + "-" + checkTime(threedaydata.getDate());
  // console.log(tomorowDay)
  // console.log(houDay)
  DateList[0].date = "今天"+checkTime(currentdata.getMonth()+1)+"月"+checkTime(currentdata.getDate())+"日";
  DateList[1].date = "明天"+checkTime(tomorrodata.getMonth()+1)+"月"+checkTime(tomorrodata.getDate())+"日";
  DateList[2].date = "后天"+checkTime(threedaydata.getMonth()+1)+"月"+checkTime(threedaydata.getDate())+"日";
  $scope.goToBmap = function(){
    var addr = $stateParams.addr
    var link = 'http://map.baidu.com/mobile/webapp/search/search/qt=s&wd='+addr+'&c=622&searchFlag=bigBox&version=5&exptype=dep&src_from=webapp_all_bigbox/vt=map&ecom=0/?fromhash=1'
    // varlink = ' http://map.baidu.com/mobile/webapp/index/index/#search/search/qt=s&wd='+addr+'&c=622&searchFlag=bigBox&version=5&exptype=dep&src_from=webapp_all_bigbox/vt=map&ecom=0';
    window.open(link,"_blank","location=yes");
  }
  //跳转进入三边页面
  var openComment = function(moviename,videoIdSide,startedTime,movieLength,startTime){
      $state.go('platform-side', {
          videoId:videoIdSide,  //跳转传入一个视频ID
          tvhelper:"tvhelper",
          startedTime:startedTime,
          movieLength:movieLength,
          moviename:encodeURIComponent(moviename),
          startTime:startTime,
          isSystemCountdown:true
      });
  }
  $scope.selectAmovie = function(session,moviename){
    var time = session.starttime;
    var endt = session.endtime;
    var showtimeId = session.showtimeId;
    var videoIdSide = session.videoId;  //传入三边页面视频id
    var currentD = new Date();

    

    //2.向服务器插入场次信息
    Movies.addAsenceNew(session.showtimeId,1,function(result){
      if(result.success){
        //1.添加推送信息，用于到了时间进行状态栏提示
      session.senceId=result.data;
      NotifySvc.addNotify(session);
        // Toast.show("该场次连接成功")
      }else{
        // Toast.show("该场次已经连接过了")
      }

    })
    if(currentclickdata==0){ //用户点击今天的
      if(session.showstatus==1){  //电影未开始播放
        var id = videoIdSide; //电影视频ID
        var beforetime = (session.startT - currentD);
        var movieLength = parseInt((session.endT - session.startT)/1000);
        if(beforetime<3600000){
            if(beforetime<60000){
                var sendtime = parseInt(second/1000) + "秒"
            }else{
                var minute = parseInt(beforetime/60000);
                var second = beforetime%60000;
                var  seconds = parseInt(second/1000)
                var sendtime = minute+"分"+seconds+"秒"
            }
        }else{
            var sendtime = parseInt(beforetime/3600000) + "小时"
        }
        // debugger
        $state.go('movie-'+'detail', {
            id: id,
            endtime:session.startT,
            movieLength:movieLength,
            isGoBackHome:true,
            isSystemCountdown:true,
            sceneId:session.showtimeId,
        });

      }else{ //电影正在播放 或播放后 跳入一个页面
        var startedTime = parseInt((currentD - session.startT)/1000);
        var movieLength = parseInt((session.endT - session.startT)/1000);
        // var startedTime = 100;
        // var movieLength = 1000;
        var videoIdSide = session.videoId;
        var moviename = session.movieName;
        // debugger
        openComment(moviename,videoIdSide,startedTime,movieLength,session.startT)

       }
    }else{  //用户点击的明后天的
        var beforetime = (session.startT - currentD)
        if(beforetime<86400000){
          var sendtime = parseInt(beforetime/3600000) + "小时"
        }else{
          var sendtime = currentclickdata+'天'
        }
        var id = mId;
        $state.go('movie-'+'detail', {
            id: id,
            endtime:session.startT,
            movieLength:movieLength,
            isGoBackHome:true,
            isSystemCountdown:true,
            sceneId:session.showtimeId,

        });
    }
  }
  var secenceisloading = true;
  //查询该电影院的某个电影的场次信息
  var getMovieScene = function(status,cid,mid,showDay){
    $scope.isLoading = true;
    var SceneMovieList= [];
    var SessionAllList = [];
    //$scope.SessionAllList = [];
    $scope.SessionTodayList = [];
    $scope.SessionTomorrowList = [];
    $scope.SessionThreedayList = [];
    if(secenceisloading){
      //调用查询电影场次接口
      secenceisloading = false;
      Movies.getShowSessionId(cId,mid,showDay,function(result){
        if (result.data && result.data.length > 0) {
            SceneList = result.data;
            filterList(SceneList,SessionAllList);// 将查询到的电影场次信息按需求过滤
            //$scope.SceneMovieList = SessionAllList;
            timefilter(status,SessionAllList);// 将过滤后端的场次信息按时间过滤（今天，明天，后天）
            $ionicScrollDelegate.resize();
            $scope.isLoading = false;
            secenceisloading = true;
        } else{
            //getMovieScene(1,cId,mId,2)
            //Toast.show("没有更多数据了")
            // console.log("没有更多的数据了")
            $ionicScrollDelegate.resize();
            $scope.isLoading = false;
            secenceisloading = true;
        }
      })
    }

  }
  var getShowTime = function(time){

    if(time!=""){
      var temp = time;
      temp = time.split(" ")[1];
      if(temp.length>5){
        temp = temp.slice(0,5);
        return temp;
      }else{
        return time;
      }
    }

  }
  // 将查询到的电影场次信息按需求过滤
  var filterList = function(scenelist,scenelistuse){
    angular.forEach(scenelist,function(data,index){
      var temp = {};
      if(data.realtime!=null&&data.movieEndTime!=null){

        temp.starttime = getShowTime(data.realtime);
        temp.endtime = getShowTime(data.movieEndTime);
      }
      temp.type = data.version+data.language;
      temp.room = data.hallName;
      temp.movieName = data.movieName;
      if(data.seatUrl==null){
        temp.ticketAddr = "https://www.baidu.com/";
      }else{
        temp.ticketAddr = data.seatUrl;
      }

      temp.showtime = data.realtime;

      temp.stoptime = data.movieEndTime;
      // if(temp.stoptime==""){
      //   debugger
      // }
      temp.videoId = data.videoId;
      temp.releaseTime = data.releaseTime;
      temp.showtimeId = data.showtimeId;//电影场次id
      scenelistuse.push(temp);
    })
  }
  // 将过滤后端的场次信息按时间过滤（今天，明天，后天）
  var timefilter = function (status,timescene){

    angular.forEach(timescene,function(item){
      // var timelist=item.showtime.split(" ");
      // var showday = timelist[0].split("-")[2];
      // var interval = showday - cday;
      var showday = new Date(item.showtime)
      var interval = parseInt((showday-currentdata)/1000/24/60/60)
      interval.toString();
      var currentD = new Date();
      // item.showtime = "2016-01-11 11:13:00";
      // item.stoptime = "2016-01-11 23:34:00";
      var startT = new Date(item.showtime.replace(/-/g,"/"));
      var endT = new Date(item.stoptime.replace(/-/g,"/"));
      if (status == 1 && item.showtime && item.stoptime){
        if(currentD<startT){
            item.buttonName = "精彩预约";
            item.showstatus =1
            item.startT = startT;
            item.endT = endT;
        }else if(currentD>endT){
            item.buttonName = "精彩回顾";
            item.showstatus =2
            item.startT = startT;
            item.endT = endT;
        }else{
            item.buttonName = "精彩互动";
            item.showstatus =3
            item.startT = startT;
            item.endT = endT;
        }
        $scope.SessionTodayList.push(item);
      }else if(status == 2){
        item.buttonName = "精彩预约"
        item.showstatus =1
        item.startT = startT;
        $scope.SessionTomorrowList.push(item);
      }else if(status == 3){
        item.buttonName = "精彩预约"
        item.showstatus =1
        item.startT = startT;
        $scope.SessionThreedayList.push(item);
      }else{
        console.log("日期数据不合格")
      }
    })
  }
  //查询电影院上映的电影
  Movies.getShowMovie(cId,function(result){
      if (result.data && result.data.length > 0) {
          SceneMovieList = result.data;
          angular.forEach(SceneMovieList,function(imgitem,index){
            imgitem.activated=index==defaultmovie?true:false;
          });
          mId = result.data[defaultmovie].videoId; //默认跳入页面查询的电影id

          $scope.SceneMovieList = result.data;
          if($stateParams.videoid){
            angular.forEach(result.data,function(item,index){
              if(item.videoId==$stateParams.videoid){
                defaultmovie =index
              }
            })
            if(defaultmovie == 0){
              mId = result.data[defaultmovie].videoId// 默认电影
            }else{
              mId = $stateParams.videoid// 选择的电影
            }
            $scope.moviename = result.data[defaultmovie].videoName;
            getMovieScene(1,cId,mId,showDay);//执行
            getMovieScene(2,cId,mId,tomorowDay);//执行
            getMovieScene(3,cId,mId,houDay);//执行
          }else{
            $scope.moviename = result.data[defaultmovie].videoName;
            getMovieScene(1,cId,mId,showDay);//执行
            getMovieScene(2,cId,mId,tomorowDay);//执行
            getMovieScene(3,cId,mId,houDay);//执行
          }
          var data={
            'nowImg':SceneMovieList[defaultmovie],
            'defaultmovie':defaultmovie
          }
          $scope.$broadcast("changeFocus",{video:SceneMovieList[defaultmovie]})
      } else{
          //Toast.show("没有更多数据了")
          // console.log("没有更多数据了")
      }

  });


   // 电影院日期列表
 $scope.showtoday=true;
 $scope.showtomorrow=false;
 $scope.showthreeday=false;
 $scope.DateList=DateList;
  angular.forEach(DateList,function(item,index){
    item.activated=index==0?true:false;
  });
  //日期切换对应场次切换
  $scope.SwitchDate=function(nowCLickedItem,index){
    if(nowCLickedItem.activated){

      }else{
        angular.forEach($scope.DateList,function(item){
          item.activated=false;
     })
        nowCLickedItem.activated=true;
        switch(index){
          case 0:
             {
              currentclickdata = 0;
              $scope.showtoday=true;
              $scope.showtomorrow=false;
              $scope.showthreeday=false;
              break;
             }
          case 1:
          {
             currentclickdata = 1;
             $scope.showtomorrow=true;
             $scope.showtoday=false;
             $scope.showthreeday=false;
             break;
          }
           case 2:
          {
             currentclickdata = 2;
             $scope.showthreeday=true;
             $scope.showtoday=false;
             $scope.showtomorrow=false;
             break;
          }

        }
      }
    $ionicScrollDelegate.resize();
  };

  $scope.buyAticket = function(session){
    // console.log(session);



    //这里需要处理一下使用手机版的页面，1.需要重定向到真实的地址，2.截取ID，拼接URL，
      $ionicLoading.show({template:'<p class="H_popbox-buyaticket">正在前往时光网购票</p>'});
      $timeout(function(){
        window.open(session.ticketAddr, '_blank', 'location=yes');
        $ionicLoading.hide();
        $timeout(function(){
          /*
             * 函数功能: 进入当前视图时, 无论缓存与否, 都设置买票教学提醒页面
             * */
            (function(){
                $scope.teachBuyTicket = {
                    src1: "img/buyTicket_03.png",
                    src2: "img/buyTicket_07.png"
                };
                $scope.isHideTeachPicture = false;
                if(!$scope.hideTeachPicture) {
                    $scope.hideTeachPicture = function () {
                        $scope.isHideTeachPicture = true;
                    };
                }
            })();
        },1000)
            },1000)

    //弹出框
    // var isBuyTicket = $ionicPopup.show({
    //     title: '系统提示',
    //     template: '是否已经购票？',
    //     scope: $scope,
    //     buttons: [
    //         {
    //             text: '确定',
    //             type: 'button-positive',
    //             onTap: function(){
    //               $scope.selectAmovie(session)
    //             }
    //         },
    //         {
    //             text: '取消'
    //         }
    //     ]
    // });
    // debugger
  }
  $rootScope.$on("videoChanged",function(e,data){

    $scope.moviename = data.video.videoName;
    getMovieScene(1,cId,data.video.videoId,showDay)
    getMovieScene(2,cId,data.video.videoId,tomorowDay);//执行
    getMovieScene(3,cId,data.video.videoId,houDay);//执行

  })
  $scope.$on( "$ionicView.enter", function( scopes, states ) {
      if(states.fromCache){
        angular.forEach($scope.SceneMovieList,function(item,index){
          if(item.activated){
            getMovieScene(1,cId,item.videoId,showDay)
            getMovieScene(2,cId,item.videoId,tomorowDay);//执行
            getMovieScene(3,cId,item.videoId,houDay);//执行
          }
        })

      }
  });


})