
// 'use strict';
/**
 * 娱乐列表相关操作、包含娱乐的搜索、筛选
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
    /**
     * 娱乐列表相关
     */
    .controller('PlayCtrl', function ($state, $scope, Toast, $ionicScrollDelegate, $rootScope, PlaySvc,MovieServe,
                                      $timeout, $ionicLoading, $location,User, ImageSvc) {
        /**
         * 筛选类型{全部、配音、配词}
         * @type {[type]}
         */
        /*跳转到成果管理页面*/
        $scope.PlayTelecom = function () {
            $state.go('play-telecom');
        }
        /*乐配导航栏*/
        var PlayNavList = [
            {"playtitle": "配音", "typeid": "1"},
            {"playtitle": "配词", "typeid": "3"},
            {"playtitle": "配图", "typeid": "2"},
        ];

    ImageSvc.calcItem($scope,2,16/9,0); //计算图片显示高宽
    //计算图片高宽结束
    $scope.playList = [];

        $scope.playvideo = {"list": [], "page": "1"};
        $scope.playhead = {"list": [], "page": "1"};
        $scope.playtext = {"list": [], "page": "1"};

        var playvideo = {"list": [], "page": "1"};
        var playhead = {"list": [], "page": "1"};
        var playtext = {"list": [], "page": "1"};
        var isLoading = false;
        $scope.noMoreData = false;
        $scope.PlayNavList = PlayNavList;
        $scope.noMoreData = false;
        $scope.noDatav = false;
        $scope.noDatah = false;
        $scope.noDatat = false;
        //var index = 0;
        var listcolumn = 2;
        $scope.noMoreItemsAvailable = false;
        angular.forEach(PlayNavList, function (item, index) {
            item.activated = index == 0 ? true : false;
        });

        //控制菜单栏的切换
        $scope.showplaydub = true;
        $scope.showplaysubtitles = false;
        $scope.showplayhead = false;

        $scope.SwitchPlayNav = function (nowPlayItem, index) {
            $ionicScrollDelegate.resize();
            $ionicScrollDelegate.resize();
            currentPageNo = 1;
            $scope.noData = false;
            isLoading = false;
            $scope.noMoreData = false;
            $scope.noMoreItemsAvailable = false;
            $scope.noMoreItemsAvailabledown = true;
            if (nowPlayItem.activated) {

            } else {
                angular.forEach($scope.PlayNavList, function (item, index) {
                    item.activated = false;
                })
                nowPlayItem.activated = true;
                switch (index) {
                    case 0:
                    {
                        $scope.showplaydub = true;
                        $scope.showplaysubtitles = false;
                        $scope.showplayhead = false;
                        break;
                    }
                    case 1:
                    {
                        $scope.showplaydub = false;
                        $scope.showplaysubtitles = true;
                        $scope.showplayhead = false;
                        break;
                    }
                    case 2:
                    {
                        $scope.showplaydub = false;
                        $scope.showplaysubtitles = false;
                        $scope.showplayhead = true;
                        break;
                    }

                }
            }
            if (nowPlayItem.typeid != "") {
                currentTypeId = nowPlayItem.typeid;
                if (isLoading == false) {
                    if (currentTypeId == 1 && $scope.playvideo && $scope.playvideo.list.length == 0) {
                        getList(true, playvideo,true, function (result) {
                            $scope.playvideo.list = result.list;
                            lazyloadimg($scope.playvideo.list); //延迟加载
                        });
                    } else if (currentTypeId == 3 && $scope.playtext && $scope.playtext.list.length == 0) {
                        getList(true, playtext,true, function (result) {
                            $scope.playtext.list = result.list;
                            lazyloadimg($scope.playtext.list); //延迟加载
                        });
                    } else if (currentTypeId == 2 && $scope.playhead && $scope.playhead.list.length == 0) {
                        getList(true, playhead,true, function (result) {
                            $scope.playhead.list = result.list;


                            lazyloadimg($scope.playhead.list); //延迟加载
                        });
                    }
                }

            } else {
                //不改变参数
            }
        }

        $scope.OnClick = function () {
            $state.go('result-management');
        }
        $scope.filterTypes = PlaySvc.getFilterTypes();
        //列表
        $scope.playList = [];
        var currentTypeId = "1"; //当前筛选的类型
        var currentPageNo = 1; //当前的页码
        /**
         * 用于添加数据
         * @param {[type]} arry [description]
         */
        var filterData = function (data, column) {
            var tempData = [];
            for (var i = 0; i < data.length; i++) {
                var index = parseInt(i / column);
                if (i % column == 0) {
                    tempData[index] = [];
                }
                var temp = data[i];
                switchDesign(temp);
                tempData[index].push(temp);
            }
            return tempData;
        }
        var switchDesign = function (temp) {
            //做一个转换操作
            switch (temp.recreationType) {
                case "1":
                    temp.recreationTypeText = "video";
                    break;
                case "2":
                    temp.recreationTypeText = "head";
                    break;
                case "3":
                    temp.recreationTypeText = "text";
                    break;
            }
            try {
                temp.content = JSON.parse(temp.content);
                //temp.content.videoSplashImg = "http://192.168.8.105/download/videoSplash.png"
                temp.content.SplashImg = ""
                //设置默认图片，延迟加载
            } catch (e) {
                console.log(e);
            }
        }
        /**
         * 筛选娱乐内容
         * @return {[type]} [description]
         */
        $scope.filterTypeEvent = function (typeId) {
            $scope.playList = [];
            currentTypeId = typeId;
            currentPageNo = 1;
            getList();
        }
        function getItem() {
            if (index == templist.length * listcolumn) {
                return null;
            }
            var firstIndex = parseInt(index / listcolumn);
            var secondIndex = index % listcolumn;
            if (templist[firstIndex][secondIndex] == undefined) {
                return null;
            }
            var item = templist[firstIndex][secondIndex];
            index++;
            return item;
        }
        //延迟加载，将item.content.SplashImg设置真实路径
        function loadImg(item) {
            if (item != null) {
                var img = new Image();
                var url;
                switch (item.recreationType) {
                    case "1":
                        url = item.content.videoSplashImg;
                        break;
                    case "2":
                        url = item.content.resultImg
                        break;
                    case "3":
                        url = item.content.resImgSrc;
                        break;
                }
                //这里需要替换图片为缩略图
                //
                url = ImageSvc.getPlayThumb(url);
                img.src = url;

                img.onload = function () {
                    item.content.loaded = true; //控制img的css属性

                    item.content.SplashImg = url;
                    $timeout(function () {
                        loadImg(getItem());
                    }, 10);
                };
                //错误处理
                img.onerror = function () {
                    item.content.SplashImg = "img/touming.png"
                    $timeout(function () {
                        loadImg(getItem());
                    }, 10);
                }
            } else {
                $ionicScrollDelegate.resize();
                isLoading = false;
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                $scope.noMoreItemsAvailable = false;

            }
        }
        var templist ;
        var index ;
        function lazyloadimg(list) {
            if(list!=undefined){
                templist = list;
                index = 0;





                loadImg(getItem());
            }

        }

        //延迟加载
        function getList(needTemp, playlist,isshowreload, callback) {
            // debugger
            var currentPageNo = playlist.page;
            if (!isLoading) {
                if (isshowreload) { //加载功能，初始化化状态值
                    $scope.loadingStatus = MovieServe.getLoadingStatus(1);
                }

                isLoading = true;
                $scope.noMoreItemsAvailable = true;

                //这里需要识别页面做出不同的查询规则
                //1.4K超高清里面的乐配专区使用的页面,tab.play这里要根据视频ID来查询
                //2.独立客户端里面使用的乐配页面，直接查全部的
                var videoId = -1;
                var type = -1;
                if ($state.current.name == 'tab.play') { //4K高清插件
                    videoId = JSON.parse(DataInterface.getString()).programid;
                    type = 2;//2：同视频下的成果
                } else if ($state.current.name == 'tab.playing') { //独立客户端
                    videoId = 0;
                    type = 0;
                }
                PlaySvc.getList(videoId, currentTypeId, -1, type, currentPageNo, 4, function (result) {
                    if (needTemp) { //需要清空
                        playlist.list = [];
                    }
                    if (isshowreload) { //加载成功
                        $scope.loadingStatus = MovieServe.getLoadingStatus(2);
                    }
                    if (result.data && result.data.resultList && result.data.resultList.length > 0) {
                        if (playlist.list.length > 0) {
                            var calc = listcolumn - playlist.list[playlist.list.length - 1].length;
                            if (calc > 0) {
                                for (var i = 0; i < calc; i++) {
                                    switchDesign(result.data.resultList[0]);
                                    playlist.list[playlist.list.length - 1].push(result.data.resultList.shift());
                                }
                            }
                        }
                        var temp = filterData(result.data.resultList, listcolumn);
                        playlist.list = playlist.list.concat(temp);
                        $scope.noMoreData = false;
                        if (!$scope.$$phase) {
                            $scope.$apply();
                        }
                        currentPageNo++;
                        playlist.page = currentPageNo;
                        $scope.noData = true;

                        callback && callback(playlist);return;

                        // debugger
                    } else {
                        //没有更多数据了
                        //$scope.noMoreData = true;
                        // $scope.noData = true;
                        // debugger
                        // var nomoredata = [];

                        if (!isshowreload) { //需要清空
                            Toast.show('没有更多数据了!');
                        }
                        // callback && callback(nomoredata);return;

                        // callback&&callback(nodata);
                        //$scope.noMoreItemsAvailable = true;
                        // isLoading = false;
                        // $scope.noMoreItemsAvailable = false;
                        // $scope.$broadcast('scroll.infiniteScrollComplete');
                        // $scope.$broadcast('scroll.refreshComplete');
                    }
                    if (currentPageNo == 1 && playlist.list.length == 0) { //如果配音第一页都没有数据，则认为无数据
                        $scope.noData = true;
                        if (isshowreload) { //加载失败
                            $scope.loadingStatus = MovieServe.getLoadingStatus(3);
                        }
                    }
                    //isLoading = false;
                    //$scope.noMoreItemsAvailable = false;
                    //$scope.$broadcast('scroll.infiniteScrollComplete');
                    //$scope.$broadcast('scroll.refreshComplete');
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                });
            } else {
                console.log('load....')
                $scope.noMoreItemsAvailable = true;
                //$scope.$broadcast('scroll.infiniteScrollComplete');
                //$scope.$broadcast('scroll.refreshComplete');
            }
        }

        /**
         * 上拉加载更多
         * @return {[type]} [description]
         */
        $scope.loadMore = function () {
            if (currentTypeId == 1) {
                getList(false, playvideo,false, function (result) {
                    $scope.playvideo.list = result.list;
                    lazyloadimg($scope.playvideo.list); //延迟加载
                });
            }
            if (currentTypeId == 3) {
                getList(false, playtext,false, function (result) {
                    $scope.playtext.list = result.list;
                    lazyloadimg($scope.playtext.list); //延迟加载

                });
            }
            if (currentTypeId == 2) {
                getList(false, playhead,false, function (result) {
                    $scope.playhead.list = result.list;
                    lazyloadimg($scope.playhead.list); //延迟加载

                });
            }

        }
        //打开详情页marktest
        $scope.openDetails = function (id, text) {
            //电信插件使用的配置
            if ($state.current.name == 'tab.playing') {
                $state.go('new-play' + '-details', {
                    id: id,
                    text: text
                });
                // $state.go('play-' + text + '-details', {
                //     id: id
                // });
            } else if (window.plugins && typeof window.plugins.webintent != 'undefined') {
                window.plugins.webintent.startActivity({
                        action: "com.handsight.tvhelper.PopoutActivity",
                        extras: {
                            url: "/play/" + text + "/detail/" + id
                        }
                    },
                    function () {
                    },
                    function () {
                    }
                );
            } else {
                $state.go('play-' + text + '-details', {
                    id: id
                });
            }
            // 独立APP使用下面的配置，网页调试也使用下面的配置
            // $state.go('play-' + text + '-details', {
            //     id: id
            // });
        }
        /**
         * 下拉刷新功能
         * @return {[type]} [description]
         */
        $scope.doRefresh = function () {
            //index = 0;
            $scope.noMoreData = false;
            isLoading = false;
            $scope.noMoreItemsAvailabledown = false;
            if (currentTypeId == 1) {
                $scope.playvideo.page = "1";
                playvideo.page = "1";
                getList(true, playvideo,false, function (result) {
                    $scope.playvideo.list = result.list;
                    lazyloadimg($scope.playvideo.list); //延迟加载
                });
            }
            if (currentTypeId == 3) {
                $scope.playtext.page = "1";
                playtext.page = "1";
                getList(true, playtext,false, function (result) {
                    $scope.playtext.list = result.list;
                    lazyloadimg($scope.playtext.list); //延迟加载
                });
            }
            if (currentTypeId == 2) {
                $scope.playhead.page = "1";
                playhead.page = "1";
                getList(true, playhead,false, function (result) {
                    $scope.playhead.list = result.list;
                    lazyloadimg($scope.playhead.list); //延迟加载
                });
            }
        }
        /**
         * 加载娱乐素材列表
         * @return {[type]} [description]
         */
        function loadDisportDataList() {
            var videoId = JSON.parse(DataInterface.getString()).programid;
            PlaySvc.getDisportDataList(videoId, 0, function (result) {
                console.log(result);
            })
        }


        //主动加载一次数据mark
        getList(true, playvideo, true,function (result) {
            $scope.playvideo.list = result.list;
            lazyloadimg($scope.playvideo.list); //延迟加载
        });
        var loadInfroAgain = function(){
            // debugger
            $scope.noMoreData = false;
            isLoading = false;
            $scope.noMoreItemsAvailabledown = false;

            //主动加载一次数据mark
            if (currentTypeId == 1) {
                $scope.playvideo.page = "1";
                playvideo.page = "1";
                getList(true, playvideo,true, function (result) {
                    $scope.playvideo.list = result.list;
                    lazyloadimg($scope.playvideo.list); //延迟加载
                });
            }
            if (currentTypeId == 3) {
                $scope.playtext.page = "1";
                playtext.page = "1";
                getList(true, playtext,true, function (result) {
                    $scope.playtext.list = result.list;
                    lazyloadimg($scope.playtext.list); //延迟加载

                });
            }
            if (currentTypeId == 2) {
                $scope.playhead.page = "1";
                playhead.page = "1";
                getList(true, playhead,true, function (result) {
                    $scope.playhead.list = result.list;
                    lazyloadimg($scope.playhead.list); //延迟加载

                });
            }
        }
        $scope.$on("loadAgainInfro",function(e,data){
          loadInfroAgain();
        })
        //这里仅用作测试视频是否可以播放用
        //loadDisportDataList();
    })
    /**
     * 乐配音查看详情
     * @param  {[type]} $scope){                 } [description]
     * @return {[type]}           [description]
     */
    .controller("PlayVideoDetailCtrl", function ($scope, ENV, $filter, $stateParams, PlaySvc, $timeout, $ionicHistory, Toast, User, $state, $ionicPopup, $ionicScrollDelegate, InterfaceSide, ImageSvc, Movies) {
        console.log('查看娱乐详情', $stateParams);
        $scope.playId = -1;
        var originalVideoUrl;
        var disportId = "";
        $scope.playResult;
        $scope.oneDisportDataList = []; //同素材其他作者乐配
        $scope.oneDisportDataList.loading = true;
        $scope.oneVideoDataList = []; //同视频其他乐配
        $scope.oneVideoDataList.loading = true;
        $scope.otherVideoList = []; //其他视频乐配
        $scope.otherVideoList.loading = true;
        $scope.praisetarget = $stateParams.id;//点赞数据id
        $scope.userPlayEvent = function () {
            //停止所有播放
            $scope.$broadcast('stopPlay');
            //识别用户是否登录
            if (User.getCurrentUser() != null) {
                //跳转页面
                $state.go('play-video-edit', {
                    id: $scope.playId
                })
            } else {
                //打开电信登录页面
                if (typeof LaunchMode != 'undefined') {
                    LaunchMode.log();
                }
                Toast.show('您还未登录')
            }
        }
        ImageSvc.calcItem($scope, 2, 16 / 9, 0.5); //计算图片显示高宽
        //计算图片高宽结束
        /**
         * 查询其他娱乐成果
         * @param  {[type]} type 域类型（0：所有成果；1：同素材下的成果；2：同视频下的成果； 3：作者；4：作者的某个素材的成果）
         * @param  {[type]} id   ID(
         *                   type为0时：ID为0；
         *                  type为1时：素材ID；
         *                   type为2时：视频ID；
         *                  type为3或4时：作者id；)
         * @return {[type]}      [description]
         */
        function getOthers(type, id, callback) {
            PlaySvc.getList(id, 1, -1, type, currentPlayPage, 4, function (result) {
                if (result.success) {
                    if (result.data && result.data.resultList) {
                        angular.forEach(result.data.resultList, function (temp) {
                            //做一个转换操作
                            switch (temp.recreationType) {
                                case "1":
                                    temp.recreationTypeText = "video";
                                    break;
                                case "2":
                                    temp.recreationTypeText = "head";
                                    break;
                                case "3":
                                    temp.recreationTypeText = "text";
                                    break;
                            }
                            try {
                                temp.content = JSON.parse(temp.content);
                                //temp.content.videoSplashImg = "http://192.168.8.105/download/videoSplash.png"
                            } catch (e) {
                                console.log(e);
                            }
                        })
                        callback && callback(result.data.resultList);
                        return;
                    }
                }
                callback && callback([]);
            });
        }

        /**
         * 查询当前娱乐成果信息
         * @return {[type]} [description]
         */
        function getSigleDisportInfo() {
            if ($stateParams.id) {
                PlaySvc.getSigleDisportInfo($stateParams.id, function (result) {
                    if (result.success) {
                        //通知开始初始化播放器
                        result.data.content = JSON.parse(result.data.content);
                        originalVideoUrl = result.data.content.compositeVideo; //设置合成的视频地址;
                        //2.通知视频播放器可以初始化播放器了，
                        $scope.$broadcast('__initVideoPlayer', {
                            url: originalVideoUrl,
                            videoSplashImg: result.data.content.videoSplashImg,
                            buffer: false //不使用本地缓冲
                        });
                        $scope.playResult = result.data;
                        disportId = result.data.disportId;
                        $scope.playId = result.data.disportDataId;
                        selectOther(result.data); //查询其他信息
                    }
                })
            }
        }

        /**
         * 同一视频下其他作品查询
         * @return {[type]} [description]
         */
        var playResultData = [];
        var currentPlayPage = 1;

        function selectorSameVideoOtherPlay(data) {
            //2.同视频其他乐配,这里的视频ID应该是当前成果的视频ID
            getOthers(2, data.vid, function (resultData) {
                //绑定到页面上
                //相同素材排除掉，相同ID排除掉
                //
                if (resultData != null && resultData.length > 0) {
                    for (var i = 0; i < resultData.length; i++) {
                        if (resultData[i].disportDataId != data.disportDataId) { //如果相等，排除掉相同的成果
                            playResultData.push(resultData[i]);
                        }
                    }
                    if (playResultData.length < 3 && resultData.length > 0) {
                        currentPlayPage++;
                        selectorSameVideoOtherPlay(data);
                    } else {
                        //查询结束
                        $scope.oneVideoDataList = playResultData;
                        $scope.oneVideoDataList.loading = false;
                        currentPlayPage = 1;
                        //
                        selectOtherVideoPlayList(data);
                    }
                } else {
                    $scope.oneVideoDataList.loading = false;
                    selectOtherVideoPlayList(data);
                }
            });
        }

        /**
         * 查询其他影片
         * @param  {[type]} data [description]
         * @return {[type]}      [description]
         */
        var otherVideoList = [];

        function selectOtherVideoPlayList(data) {
            //3.其他电影当前分类乐配
            getOthers(0, 0, function (resultData) {
                //绑定到页面上
                //排除掉当前电影
                if (resultData != null && resultData.length > 0) {
                    for (var i = 0; i < resultData.length; i++) {
                        if (resultData[i].vid != data.vid) { //排除掉相同
                            otherVideoList.push(resultData[i]);
                        }
                    }
                }
                if (otherVideoList.length < 3 && resultData.length > 0) {
                    currentPlayPage++;
                    selectOtherVideoPlayList(data);
                } else {
                    //查询结束
                    $scope.otherVideoList = otherVideoList;
                    $scope.otherVideoList.loading = false;
                }
            });
        }

        var otherUserVideoList = [];

        /**
         * 查询其他娱乐
         * @param  {[type]} data 当前成果详细信息
         * @return {[type]}      [description]
         */
        function selectOther(data) {
            //1.查询同素材的其他乐配
            getOthers(1, data.disportDataId, function (resultData) {

                //绑定到页面上
                //排重，去掉当前这一个乐配作品，去掉当前作者的作品
                //
                if (resultData != null && resultData.length > 0) {
                    for (var i = 0; i < resultData.length; i++) {
                        if (resultData[i].authorId != data.authorId && resultData[i].disportId != data.disportId) { //排除掉相同
                            otherUserVideoList.push(resultData[i]);
                        } else {

                        }
                    }
                }
                if (otherUserVideoList.length < 3 && resultData.length > 0) {
                    currentPlayPage++;
                    selectOther(data);
                } else {
                    //查询结束
                    $scope.oneDisportDataList = otherUserVideoList;
                    $scope.oneDisportDataList.loading = false;
                }
                $scope.oneDisportDataList = otherUserVideoList;
                $scope.oneDisportDataList.loading = false;
                selectorSameVideoOtherPlay(data)
            });
        }

        $scope.getOriginalVideoUrl = function () {
            return originalVideoUrl;
        }
        /**
         * 初始化
         * @return {[type]} [description]
         */
        function __init() {
            //加载播放器
            getSigleDisportInfo();
        }

        //分享到第三方平台
        /*
         下面是传入的参数的格式及字段的意义：
         platform      : 分享平台，可以取值为 wxfriend(微信好友)、wxcircle(微信朋友圈)、weibo(新浪微博)、qzone(QQ空间)、qfriend(QQ好友)

         contentType   : 数据类型，可以取值为 link(网页链接)、text(文本)、img(图片)
         content       : 分享的内容对象

         contentString : 除QQ空间外分享的内容，取值可以是网页链接、文本、图片链接
         linkImgUrl    : 和网页链接一起分享的图片

         qzText        : QQ空间分享的文本
         qzLink        : QQ空间分享的网页链接
         qzImgUrl      : QQ空间分享的图片链接

         */
        $scope.shareDatas = function () {
            return {
                type: "img",
                title: $scope.playResult ? $scope.playResult.disportTitle : "",
                text: $scope.playResult ? $scope.playResult.disportTitle : "",
                link: ENV.shareApi + "?id=" + disportId,
                linkImgUrl: $scope.playResult ? $scope.playResult.content.videoSplashImg : "",
                imgSrc: $scope.playResult ? $scope.playResult.content.videoSplashImg : "",
                title: $scope.playResult ? $scope.playResult.disportTitle : ""
            };
        };

        $scope.closeAPP = function () {
            //判断是否有backview
            if ($ionicHistory.backView()) {
                $ionicHistory.goBack();
            } else {
                ionic.Platform.exitApp();
            }
        }
        $scope.$on("$destroy", function () {
            //通知需要停止播放
            $scope.$broadcast('stopPlay');
        });
        $timeout(function () {
            __init();
        }, 0)
        // 评论功能，通过滚动控制输入框是否显示<mark3>
        $timeout(function () {
            var commentheigth = document.getElementById('playvideodetail').offsetTop - window.screen.height + 105;

            if (commentheigth < 0) {
                $scope.$broadcast("playvideodetail", {"status": true})
            } else {
                $scope.$broadcast("playvideodetail", {"status": false})
            }
        }, 100)
        var lastvalue = 0;
        $timeout(function () {
            var commentheigth = document.getElementById('playvideodetail').offsetTop - window.screen.height + 105;
            if (commentheigth <= 0) {
                $scope.$broadcast("playvideodetail", {"status": true})
            }
            document.querySelector("#content-scroll").onscroll = function () {
                var commentheigth = document.getElementById('playvideodetail').offsetTop - window.screen.height + 105; //comment的高度
                var currentvalue = this.scrollTop;
                var sl = Math.abs(currentvalue - lastvalue)
                if (sl > 15) {
                    if (this.scrollTop >= commentheigth) {
                        $scope.$broadcast("playvideodetail", {"status": true})
                    } else {
                        $scope.$broadcast("playvideodetail", {"status": false})
                    }
                    if (this.scrollTop >= commentheigth + window.screen.height) {
                        $scope.$broadcast("playvideodetailback", {"status": true})
                    } else {
                        $scope.$broadcast("playvideodetailback", {"status": false})
                    }
                    lastvalue = currentvalue;
                }
            }
        }, 100)

        //打开其它乐配电影详情页
        $scope.openDisportDetail = function (play) {
            var id;
            id = play.disportId;  //跳转到哪里去?
            $state.go('play-' + 'video-' + 'details', {
                id: id
            });
            // $state.go('play-'+text+'-details', {
            //     id: id
            // });
        }
        //markget
        /**查询乐配详情页面信息数据，传入disportId**/
        Movies.getDisportDetail($stateParams.id, function (result) {
            // debugger
        })
    })
    /**
     * 我来配页面操作Ctrl
     * @param  {[type]} $scope                [description]
     * @param  {[type]} PlayVideoSvc          [description]
     * @param  {[type]} MediaSvc              [description]
     * @param  {[type]} PlaySvc               [description]
     * @param  {[type]} $ionicPopup           [description]
     * @param  {[type]} Toast                 [description]
     * @param  {[type]} $stateParams          [description]
     * @param  {[type]} $timeout              [description]
     * @param  {[type]} $filter               [description]
     * @param  {[type]} $state                [description]
     * @param  {[type]} $ionicLoading         [description]
     * @param  {[type]} $state                [description]
     * @param  {[type]} $interval             [description]
     * @param  {[type]} $ionicScrollDelegate) {                   var recordStatus [description]
     * @return {[type]}                       [description]
     */
    .controller('PlayVideoEditCtrl', function (
        $scope,ENV,$rootScope, PlayVideoSvc, MediaSvc, PlaySvc,
        $ionicPopup, Toast, $http, $stateParams, $timeout, $filter,
        $ionicLoading, $state, User, $interval, $ionicScrollDelegate) {
        var recordStatus = 1; // 1.还未开始录，2.正在录音，3.暂停，4.停止
        $scope.recordStatusText = {
            1: "点击下面键开始配音",
            2: "点击下面键停止配音",
            3: "",
            4: "",
            5: "点击下面键可以预览你的配音",
            6: "点击下面键停止预览"
        }
        $scope.recordStatus = recordStatus;
        $scope.disportData = {};
        $scope.originalVideoUrl = '';
        $scope.userStatus = 0; // 用户当前操作状态  0:查看配音成果，1.我来配
        var originalVideoUrl, playSrc, realAudioUrl;
        var isVideoReady = false;
        var videoSplashImg = "";
        //查询出娱乐素材
        var disportDataId = $stateParams.id;

        /**
         * 查询娱乐素材
         * @param  {[type]}   disportDataId 娱乐素材ID
         * @param  {Function} callback      [description]
         * @return {[type]}                 [description]
         */
        function getDisportData(disportDataId, callback) {
            PlaySvc.getDisportData(disportDataId, function (result) {
                if (result.success) {
                    result.data.content = JSON.parse(result.data.content);
                    $scope.disportData = result.data;
                    videoSplashImg = result.data.content.videoSplashImg;
                    realAudioUrl = result.data.content.originalAudio;
                    callback(result.data);
                } else {
                    Toast.show('获取素材失败');
                }
            });
        }

        /**
         * 配音按钮
         * @return {[type]} [description]
         */
        $scope.recordEvent = function () {
            $scope.$broadcast('setPreview', {
                show: false
            });
            switch (recordStatus) {
                case 1: //开始录音
                    //这里需要视频加载完成才能开始配音
                    $ionicLoading.show();
                    $scope.$broadcast('startToBuffer');
                    var it = $interval(function () {
                        if (isVideoReady) {
                            $ionicLoading.hide();
                            $scope.$broadcast('setMuted', {
                                muted: true
                            })
                            $scope.$broadcast('resetPlayer');
                            $scope.$broadcast('startPlay');
                            PlayVideoSvc.startRecord();
                            recordStatus = 2;
                            $scope.recordStatus = recordStatus;
                            $interval.cancel(it);
                        }
                    }, 100)
                    break;
                case 2: //如果正在录音，再次点击则停止录音
                    stopMediaRecord();
                    break;
                case 4:
                    recordStatus = 5;
                    break;
                case 5: //如果当前已经停止播放，再次几点则为播放语音
                    if (playSrc && playSrc != '') {
                        $scope.$broadcast('setMuted', {
                            muted: true
                        })
                        $scope.$broadcast('__initVideoPlayer', {
                            url: originalVideoUrl,
                            videoSplashImg: videoSplashImg,
                            userPlayAudio: playSrc,
                            realAudioUrl: realAudioUrl
                        });
                        $scope.$broadcast('previewUserAudio');
                    }
                    $scope.$broadcast('resetPlayer');
                    recordStatus = 6;
                    break;
                case 6:
                    $scope.$broadcast('previewUserAudioStop');
                    $scope.$broadcast('resetPlayer');
                    recordStatus = 5;
                    break
            }
            $scope.recordStatus = recordStatus;
            event.stopPropagation();
            return false;
        }
        /**
         * 停止录音
         * @return {[type]} [description]
         */
        function stopMediaRecord() {
            $scope.$broadcast('stopPlay')
            PlayVideoSvc.stopRecord(function (recordUrl) {
                playSrc = recordUrl;
            });
            recordStatus = 5;
        }

        /**
         * 视频准备好了
         * @param  {[type]} ){                     } [description]
         * @return {[type]}     [description]
         */
        $scope.$on('videoReady', function () {
            isVideoReady = true;
        })
        /**
         * 监听视频播放完成事件
         * @param  {[type]} ){                     } [description]
         * @return {[type]}     [description]
         */
        $scope.$on('videoEnd', function () {
            if (recordStatus == 2) {
                stopMediaRecord();
            } else if (recordStatus == 6) {
                $scope.$broadcast('previewUserAudio');
                recordStatus = 5;
            }
            $scope.recordStatus = recordStatus;
        })
        /**
         * 重录按钮事件
         * @return {[type]} [description]
         */
        $scope.reRecordEvent = function () {
            recordStatus = 1;
            $scope.recordStatus = recordStatus;
            //这里将时间重置
            $scope.$broadcast('resetPlayer');
            $scope.$broadcast('setPreview', {
                show: true
            });
            $scope.recordText = "点击下面键开始配音";
        }
        /**
         * 配音完成按钮事件
         * @return {[type]} [description]
         */
        $scope.playEndEvent = function () {
            if (typeof playSrc != 'undefined' && playSrc != '') {
                //这里需要停止当前预览的内容
                stopNowPlayVideo();
                recordStatus = 5;
                $scope.recordStatus = recordStatus;
                $scope.data = {}
                $scope.data.thisplayName = '配音' + $filter('date')(new Date(), 'yyyyMMddHHmmss');
                $ionicPopup.show({
                    title: '请输入乐配名称',
                    template: '<input type="text" class="popup-text" placeholder="请输入乐配名称" autofocus ng-model="data.thisplayName">',
                    scope: $scope,
                    buttons: [{
                        text: '取消',
                        onTap: function(e){
                            if (window.cordova && window.cordova.plugins.Keyboard) {
                                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                cordova.plugins.Keyboard.disableScroll(true);
                            }
                        }
                    }, {
                        text: '完成',
                        onTap: function () {
                            if (window.cordova && window.cordova.plugins.Keyboard) {
                                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                                cordova.plugins.Keyboard.disableScroll(true);
                            }
                            var name = $scope.data.thisplayName;
                            //这里来组织数据，保存到服务器
                            saveDataToServer(name);
                        }
                    }]
                })
            } else {
                Toast.show('还没有配完一次音哟~');
            }
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(false);
            }
        }
        /**
         * 将数据保存到服务器
         * @return {[type]} [description]
         */
        function saveDataToServer(disportTitle) {
            if (typeof playSrc != 'undefined' && playSrc != '') {
                $scope.uploadPercent = "0%";
                $ionicLoading.show({
                    template: '<ion-spinner icon="ios"></ion-spinner><div>正在上传{{uploadPercent}}</div>',
                    scope: $scope
                });
                //1.将录制的音频上传到服务器,sign:0失败，1.成功
                PlayVideoSvc.uploadRecordAudio(playSrc, function (result) {
                    console.log(result)
                    if (result.success) {
                        //2.组织数据保存到服务器
                        var content = {
                            originalVideoUrl: originalVideoUrl,
                            userPlayAudio: result.data,
                            videoSplashImg: videoSplashImg
                        }
                        console.log(content);
                        //3.将内容数据保存到服务器上
                        PlaySvc.addRecreation(disportDataId, disportTitle, JSON.stringify(content), function (data) {
                            if (data.success) {
                                //切换页面
                                $scope.userStatus = 0;
                                //加载完成，
                                playSrc = "";
                                //重新加载数据
                                //重新加载列表
                                page = 1;
                                getDisoportDataList(page, function (resultList) {
                                    $scope.resultPlayList = resultList;
                                })
                            } else {
                                Toast.show('保存配音失败！')
                            }
                        })
                    } else {
                        Toast.show('配音上传失败')
                    }
                    $ionicLoading.hide();
                }, function (error) {
                    //这里上传文件失败
                    Toast.show('服务器错误：配音文件上传失败');
                    $ionicLoading.hide();
                }, function (percent) {
                    $scope.uploadPercent = (percent * 100).toFixed(2) + "%";
                });
            } else {
                Toast.show('还没有配音哟~')
            }
        }

        window.uploadTest = function (path) {
            PlayVideoSvc.uploadRecordAudio(path, function (result) {
                console.log(result);
            })
        }
        /**
         * 初始化页面
         * @return {[type]} [description]
         */
        function __init() {
            if (disportDataId != '') {
                //1.查询素材
                getDisportData(disportDataId, function (data) {
                    originalVideoUrl = data.content.data; //设置原始的视频地址;
                    videoSplashImg = data.content.videoSplashImg;
                    realAudioUrl = data.content.originalAudio;
                    // debugger
                    //2.通知视频播放器可以初始化播放器了，
                    $scope.$broadcast('__initVideoPlayer', {
                        url: originalVideoUrl,
                        videoSplashImg: videoSplashImg,
                        realAudioUrl: realAudioUrl,
                        buffer: true
                    });
                })
            }
        }

        $scope.getOriginalVideoUrl = function () {
            return originalVideoUrl;
        }
        ///初始化,测试用$timeout
        $timeout(function () {
            __init();
        }, 0)
        $scope.$on("$destroy", function () {
            //通知需要停止播放
            $scope.$broadcast('stopPlay');
        });
        $rootScope.$on("appPauseEvent",function(){
            //暂停播放
            $scope.$broadcast('stopPlay');
        })
        /**
         * 用户点击我来配按钮事件
         * @return {[type]} [description]
         */
        $scope.playEvent = function () {
            $scope.userStatus = 1;
            $scope.recordStatus = 1;
            recordStatus = 1;
            //这里需要停止当前预览的内容
            stopNowPlayVideo();
            //计算透明层距离顶部的距离
           $timeout(function() { if (device.platform == 'iOS') {
                $scope.playWarpperStyle = {
                    top: document.querySelector('#play-title').offsetTop + 63 + "px"
                }
            } else {
                $scope.playWarpperStyle = {
                    top: document.querySelector('#play-title').offsetTop + 43 + "px"
                }
            }
        },100)

        }

        /**
         * 停止当前正在播放的视频音频
         * @return {[type]} [description]
         */
        function stopNowPlayVideo() {
            $scope.$broadcast('stopPlay');
            $scope.$broadcast('previewUserAudioStop');
            if (typeof nowPlayItem != 'undefined' && nowPlayItem.isPlay) { //停止
                nowPlayItem.isPlay = false;
            }
        }

        /**
         * 用户取消配音
         * @return {[type]} [description]
         */
        $scope.cancelPlayEvent = function () {
            $scope.userStatus = 0;
            playSrc = "";
            //停止配音
            stopMediaRecord();
        }
        //*********管理历史成果。。。。***************/
        var disportDataId = $stateParams.id;
        $scope.disportDataId = disportDataId;
        var originalVideoUrl;
        var videoSplashImg = "";
        $scope.resultPlayList = [];
        /**
         * 查询娱乐素材
         * @param  {[type]}   disportDataId 娱乐素材ID
         * @param  {Function} callback      [description]
         * @return {[type]}                 [description]
         */
        function __getDisportData(disportDataId, callback) {
            PlaySvc.getDisportData(disportDataId, function (result) {
                if (result.success) {
                    result.data.content = JSON.parse(result.data.content);
                    videoSplashImg = result.data.content.videoSplashImg;
                    $scope.disportData = result.data;
                    $scope.playEvent();
                    callback(result.data);
                } else {
                    Toast.show('获取素材失败');
                }
            });
        }

        $scope.playResult = {};
        //分享到第三方平台
        /*
         下面是传入的参数的格式及字段的意义：
         platform      : 分享平台，可以取值为 wxfriend(微信好友)、wxcircle(微信朋友圈)、weibo(新浪微博)、qzone(QQ空间)、qfriend(QQ好友)

         contentType   : 数据类型，可以取值为 link(网页链接)、text(文本)、img(图片)
         content       : 分享的内容对象

         contentString : 除QQ空间外分享的内容，取值可以是网页链接、文本、图片链接
         linkImgUrl    : 和网页链接一起分享的图片

         qzText        : QQ空间分享的文本
         qzLink        : QQ空间分享的网页链接
         qzImgUrl      : QQ空间分享的图片链接
         */
        $scope.shareDatas = function (play) {
            if (play) {
                play = angular.fromJson(play);
                return {
                    type: "img",
                    title: play ? play.disportTitle : "",
                    text: play ? play.disportTitle : "",
                    link: ENV.shareApi + "?id=" + play.disportId,
                    linkImgUrl: play ? play.content.videoSplashImg : "",
                    imgSrc: play ? play.content.videoSplashImg : ""
                };
            }
        };


        //当前正在编辑的成果ID
        //var curEditDisportId = "";

        /**
         * 获取成果列表
         * @return {[type]} [description]
         */
        function getDisoportDataList(page, callback) {
            var userId = User.getCurrentUser().userId;
            PlaySvc.getList(userId, 1, disportDataId, 4, page, 0, function (result) {
                if (result.success) {
                    if (result.data && result.data.resultList) {
                        if (parseInt(result.data.totalCount) <= $scope.resultPlayList.length + parseInt(result.data.pageSize)) {
                            $scope.isShowLoadMore = false;
                           if(parseInt(result.data.totalCount)>10){
                               $scope.isShowNoData = true;
                           }
                           $timeout(function() {
                                 Toast.show('没有更多数据了!');
                             }, 500);
                        } else {
                            $scope.isShowLoadMore = true;
                            $scope.isShowNoData = false;
                        }
                        //这里做循环添加数据
                        angular.forEach(result.data.resultList, function (item) {
                            item.isPlay = false;
                            item.content = JSON.parse(item.content);
                        })
                        callback && callback(result.data.resultList);

                        //处理刚才编辑的成果背景显示
                        // 添加背景色
                        /*angular.forEach($scope.resultPlayList, function (item) {
                         item.isActive = false;
                         if (item.disportId == curEditDisportId) {
                         item.isActive = true;
                         curEditDisportId = "";
                         }
                         });*/

                        return;
                    } else {
                        Toast.show('查询成果列表失败')
                    }
                }
                callback && callback([]);
            });
        }

        /**
         * 根据成果ID查询成果
         * @param  {[type]} disportId [description]
         * @return {[type]}           [description]
         */
        function getDisportById(disportId) {
            var itemResult;
            angular.forEach($scope.resultPlayList, function (item) {
                if (item.disportId == disportId) {
                    itemResult = item;
                    return false;
                }
            })
            return itemResult;
        }

        var page = 1;

        /**
         * 初始化当前页面
         * @return {[type]} [description]
         */
        function __init() {
            //查询素材
            __getDisportData(disportDataId, function (result) {
                originalVideoUrl = result.content.data; //设置原始的视频地址;
                realAudioUrl = result.content.originalAudio;
                //2.通知视频播放器可以初始化播放器了，
                $scope.$broadcast('__initVideoPlayer', {
                    url: originalVideoUrl,
                    videoSplashImg: videoSplashImg,
                    realAudioUrl: realAudioUrl
                });
            });
            $scope.resultPlayList = [];
            $scope.noMoreData = false;
            //查询成果列表
            getDisoportDataList(page, function (resultList) {
                //初始化成果列表
                if (resultList.length == 0) { //暂时没有数据则需要提示
                    $scope.noMoreData = true;
                    Toast.show('没有更多数据了！')
                } else {
                    $scope.noMoreData = false;
                    $scope.resultPlayList = $scope.resultPlayList.concat(resultList);
                    $timeout(function () {
                        $ionicScrollDelegate.resize();
                    }, 100);
                }
            })
        }

        $scope.isShowLoadMore = false;
        //加载更多成果
        $scope.loadMoreDisport = function () {
            page++;
            $scope.isShowLoadMore = false;
            getDisoportDataList(page, function (resultList) {
                //初始化成果列表
                $scope.resultPlayList = $scope.resultPlayList.concat(resultList);
                if (resultList.length <= 0) {
                    isShowLoadMore = false;
                   // $scope.isShowNoData=true;
                }
            })
        }

        //修改名字
        $scope.changeName = function (disport) {
            //添加背景色
            angular.forEach($scope.resultPlayList, function (item) {
                item.isActive = false;
                if (item.disportId == disport.disportId) {
                    item.isActive = true;
                }
            });
            //修改我的成果名字
            if (disport.isRelease == "1") {
                Toast.show('已发布的成果不能编辑');
                return;
            }
            if ($scope.displayInfo) {
                $scope.displayInfo.title = disport.disportTitle;
            } else {
                $scope.displayInfo = {
                    title: disport.disportTitle
                }
            }
            var myPopup = $ionicPopup.show({
                template: '<input type="text" class="popup-text" ng-model="displayInfo.title">',
                title: '确定要修改吗？',
                scope: $scope,
                buttons: [{
                    text: '取消',
                    onTap: function (e){
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                            cordova.plugins.Keyboard.disableScroll(true);
                        }
                    }
                }, {
                    text: '<b>确定</b>',
                    type: 'button-positive',
                    onTap: function (e) {
                        if (window.cordova && window.cordova.plugins.Keyboard) {
                            cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                            cordova.plugins.Keyboard.disableScroll(true);
                        }
                        if (!$scope.displayInfo.title) {
                            e.preventDefault();
                        } else {
                            return $scope.displayInfo.title;
                        }
                    }
                }]
            });
            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(false);
            }
            myPopup.then(function (res) {
                if (res && res != "") {
                    $ionicLoading.show();
                    httpModifyResult(function (data) {
                        $ionicLoading.hide();
                        if (data) {
                            //重新加载列表
                            page = 1;
                            //$scope.isShowLoadMore = true;
                            $scope.resultPlayList.noData = false;
                            getDisoportDataList(page, function (resultList) {
                                $scope.resultPlayList = resultList;
                            })
                        }
                    }, disport);
                } else {

                }
            });
        }
        //修改当前成果
        function httpModifyResult(callback, disport) {
            $ionicLoading.show();
            $http.post(ENV.api + "/recreation/update", param({
                json: JSON.stringify({
                    disportId: disport.disportId,
                    disportTitle: $scope.displayInfo.title,
                    content: JSON.stringify(disport.content)
                })
            })).success(function (response) {
                $ionicLoading.hide();
                if (!response.success) {
                    if (response.code == "50005") {
                        Toast.show("名字重复!");
                        return;
                    }
                    Toast.show(response.msg);
                    callback(false);
                    return;
                }


                callback(true);
            });
        }

        //删除事件
        $scope.deleteEvent = function (disportId) {
            //添加背景色
            angular.forEach($scope.resultPlayList, function (item) {
                item.isActive = false;
                if (item.disportId == disportId) {
                    item.isActive = true;
                }
            });
            $ionicPopup.show({
                title: '确认删除？',
                buttons: [{
                    text: '取消'
                }, {
                    text: '确定',
                    onTap: function () {
                        //这里需要停止当前预览的内容
                        stopNowPlayVideo();
                        //开始执行删除
                        PlaySvc.deleteRecreation(disportId, function (result) {
                            if (result.success) {
                                Toast.show('删除成功')
                                //重新加载列表
                                page = 1;
                                $scope.resultPlayList.noData = false;
                                getDisoportDataList(page, function (resultList) {
                                    $scope.resultPlayList = resultList;
                                })
                            } else {
                                Toast.show('删除失败')
                            }
                        })
                    }
                }]
            })
        }
        //发布事件
        $scope.publishEvent = function (disportId) {
            //添加背景色
            angular.forEach($scope.resultPlayList, function (item) {
                item.isActive = false;
                if (item.disportId == disportId) {
                    item.isActive = true;
                }
            });
            var disportItem = getDisportById(disportId);
            if (disportItem.isRelease == 0) {
                $ionicPopup.show({
                    title: '立即发布？',
                    buttons: [{
                        text: '取消'
                    }, {
                        text: '确定',
                        onTap: function () {
                            //这里需要停止当前预览的内容
                            stopNowPlayVideo();
                            //开始执行发布
                            PlaySvc.releaseRecreation(disportId, 1, function (result) {
                                if (result.success) {
                                    Toast.show('发布成功');
                                    //直接关闭
                                    //ionic.Platform.exitApp();
                                    //$state.go('tab.play')
                                    //重新加载列表
                                    page = 1;
                                    //$scope.isShowLoadMore = true;
                                    $scope.resultPlayList.noData = false;
                                    getDisoportDataList(page, function (resultList) {
                                        $scope.resultPlayList = resultList;
                                    })
                                } else {
                                    Toast.show('发布失败！')
                                }
                            })
                        }
                    }]
                })
            } else {
                Toast.show('已经发布了哟~');
            }
        }
        /*//分享样式
        $scope.shareEvent = function (disport) {
            //添加背景色
            angular.forEach($scope.resultPlayList, function (item) {
                item.isActive = false;
                if (item.disportId == disport.disportId) {
                    item.isActive = true;
                }
            });
        }*/
        $scope.getOriginalVideoUrl = function () {
            return originalVideoUrl;
        }
        var nowPlayItem;
        /**
         * 预览作者自己的作品
         * @param  {[type]} disportId [description]
         * @return {[type]}           [description]
         */
        $scope.previewEvent = function (disportId) {
            //添加背景色
            angular.forEach($scope.resultPlayList, function (item) {
                item.isActive = false;
                if (item.disportId == disportId) {
                    item.isActive = true;
                }
            });
            //预览我的视频
            var disportItem = getDisportById(disportId);
            disportItem.isPlay = !disportItem.isPlay;
            if (!disportItem.isPlay) { //如果当前正在播放，再次点击则为停止播放
                $scope.$broadcast('stopPlay');
                $scope.$broadcast('previewUserAudioStop')
            } else { //播放
                //1.需要给当前播放器发送一个停止指令，防止当前正在播放
                $scope.$broadcast('stopPlay');
                var playSrc = disportItem.content.userPlayAudio;
                $scope.$broadcast('__initVideoPlayer', {
                    url: originalVideoUrl,
                    videoSplashImg: videoSplashImg,
                    userPlayAudio: playSrc,
                    realAudioUrl: realAudioUrl
                });
                //将所有的状态恢复
                angular.forEach($scope.resultPlayList, function (item) {
                    if (disportItem != item) {
                        item.isPlay = false;
                    }
                });
                nowPlayItem = disportItem;
                $scope.$broadcast('previewUserAudio');
            }
            event.stopPropagation();
        }
        $scope.$on('videoEnd', function () {
            //修改预览状态。
            if (typeof nowPlayItem != 'undefined') {
                nowPlayItem.isPlay = false;
            }
        })
        $scope.$on("$destroy", function () {
            //通知需要停止播放
            $scope.$broadcast('stopPlay');
        });
    })