rootModule
	.controller('PlayTextEditSelect', function($scope, $http, $ionicScrollDelegate, ENV, $stateParams, $state) {

		function createNewConf(old) {
			var newConf = {};
			for (var p in old) {
				newConf[p] = old[p];
			}
			return newConf;
		}
		var originEffect = {
			imgSrc: "",
			imgMod: "0",
			originContent: "",
			en: "",
			jp: "",
			kor: "",
			fontSize: 30,
			targetLang: "en",
		};

		//hide the modified picture
		$scope.popupcontentClick = function() {
			return $scope.popupcontentStyle = {visibility: "hidden"};
		};

		$http.post(ENV.api_12 + "/recreation/get", param({
				id: $stateParams.id,
				appId: "ca72edf62f370a57989f5a9bb0d8beaf"
			})).success(function(response) {
				if (response.success) {
					var resultData = response.data;
					$scope.backtoWords = function() {
						$state.go('play-text-edit', {
							id: resultData.disportId
						});
					};

					$http.post(ENV.api_12 + "/recreation/getlist", param({
						id: resultData.authorId,
						disportDataId: resultData.disportDataId,
						appId: "ca72edf62f370a57989f5a9bb0d8beaf",
						recreationType: 3,
						type: 4,
						isApproved: 0
					})).success(function(response) {
						if (response.success) {
							var resultList = response.data.resultList;
							var originPic = new Image();
							var curPictureConfs = new Array(); //当前图片的所有配置信息

							//加载新图片
							var wordsOnScreen = createNewConf(originEffect); //当前图片的当前配置信息
							wordsOnScreen.imgSrc = JSON.parse(resultData.content).imgSrc;
							originPic.src = wordsOnScreen.imgSrc;

							if (resultList && resultList.length > 0) {
								//加载成果图片
								var wordsOnScreen = createNewConf(JSON.parse(resultList[0].content)); //当前图片的当前配置信息
								originPic.src = wordsOnScreen.imgSrc;
								curPictureConfs = curPictureConfs.concat(resultList);
							}

							originPic.onload = function() {
								$scope.contentPic = "#";
								var myCanvas = document.getElementById("myCanvass");
								var bottomBar = document.getElementsByClassName("scrnWordBar")[0];

								//	var allPicturesConfs = null; //所有图片的配置信息

								//刷新画布
								//refresh(originPic, myCanvas.width, myCanvas.height);
								scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);

								function createConfOptions() {
									var length = curPictureConfs.length;
									for (var i = 0; i < length; ++i) {
										createConfOption(curPictureConfs[i], i + 1);
									}
								}

								function createConfOption(pictureConf, num) {
									var newElement = bottomBar.cloneNode(true);
									newElement.firstElementChild.children[0].value = pictureConf.disportTitle;
									newElement.style.display = "flex";
									wordsOptionList.appendChild(newElement);
									//预览
									newElement.children[1].onclick = function() {
										wordsOnScreen = createNewConf(JSON.parse(pictureConf.content));
										//refresh(originPic, myCanvas.width, myCanvas.height);
										scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);


										var url = myCanvas.toDataURL();
										$scope.contentPic = url;
										$scope.popupcontentStyle = {left: 200, visibility: "visible"};
										$ionicScrollDelegate.$getByHandle('mainScrnWordsScroll').scrollTop();
									};
									//发布
									newElement.children[2].onclick = function() {
										var url = ENV.api_12 + "/recreation/release";
										$http.post(url, param({
											disportId: pictureConf["disportId"],
											isRelease: 1,
											appId: "ca72edf62f370a57989f5a9bb0d8beaf"
										})).success(function(response) {
											console.log(response);
										});
									};
									//删除
									newElement.children[3].onclick = function() {
										var url = ENV.api_12 + "/recreation/delete";
										$http.post(url, param({
											disportId: pictureConf["disportId"],
											appId: "ca72edf62f370a57989f5a9bb0d8beaf"
										})).success(function(response) {
											wordsOnScreen = createNewConf(originEffect);
											//refresh(originPic, myCanvas.width, myCanvas.height);
											scrnWordsCanvas(myCanvas, originPic, wordsOnScreen);
											newElement.parentElement.removeChild(newElement);
											console.log(response);
										});
									};
								}

								createConfOptions();
							}
						}
					});


				}
			});
	});