'use strict';
/**
 * 点赞
 */
rootModule
 .directive('addPraise', function($compile,Movies,Toast,$rootScope){
  var linker = function(scope,elem,attrs){
      var praisetargetId = attrs.targetid;//点赞数据id
      // console.log(praisetargetId)
      scope.likeNumber=0;
      elem[0].children[0].classList.add("ion-praise");
      var praisetype = attrs.typeid ;//1.对评论2.对视频3.对主题
      var isPraise;

      //查询点赞
      Movies.getPraise(praisetargetId,praisetype,function(result){
        if(result.data&&result.data.praises){
          scope.likeNumber = result.data.sum;
          if(result.data.data=="1" ||result.data.data==1){
            elem[0].children[0].classList.add("ion-praise-full","positive");

            elem[0].setAttribute("style","color:#FF9600 !important");
            //elem[0].children[0].setAttribute("style","color:#FF9600 !important");
            // elem[0].disabled = true;
            elem[0].style.opacity ="1";
            isPraise = true
          }else{
            isPraise = false
            elem[0].children[0].classList.add("ion-praise");
          }
        }else{
          scope.likeNumber = 0;
          isPraise = false;
          elem[0].children[0].classList.add("ion-praise");
        }

      })
      elem.on("click", function(){
        if($rootScope.globalUserIsLogin){
          if(!isPraise){
            // debugger
            elem[0].children[0].classList.add("ion-praise-full","positive");
            elem[0].setAttribute("style","color:#FF9600 !important");
            //elem[0].children[0].setAttribute("style","color:#FF9600 !important");
            elem[0].disabled = true;
            isPraise = true
            elem[0].style.opacity ="1";
            scope.likeNumber++
            Movies.addPraise(praisetargetId,praisetype,function(result){
              if(result.data!=null||result.success){
                  console.log("已点赞")
              }else{
                  console.log("点赞失败")
                  elem[0].children[0].classList.add("ion-praise");
              }
            })
          }else{
            elem[0].children[0].classList.add("ion-praise-full","positive");
            elem[0].setAttribute("style","color:#FF9600 !important")
            elem[0].disabled = true;
            elem[0].style.opacity ="1";
            //Toast.show("已经点赞过了，不能再点了")
          }
        }else{
          Toast.show("登陆后再来点赞")
        }
      })

      $compile(elem.contents())(scope);
  }
  return {
    restrict: 'A',
    link: linker
  }
 })