'use strict';
/**
 * 三边评论框
 */
rootModule
    .directive('chatCommentlist',function(MediaSvc,$timeout){
      var currentPlayComment;
      var mediaPlayer=null;
      var linker = function(scope,element,attrs){
           /**
         * 语音播放功能
         * @param  {[type]} comment     评论
         * @return {[type]}           [description]
         */
        function playAudioVoice(comment) {
            if (currentPlayComment) {
                currentPlayComment.playing = false;
            }
            if(mediaPlayer!=null){
                mediaPlayer.pause();
            }
            if (comment && comment.voice) {
                var url = comment.voice;
                if (url && url.indexOf('m4a') > -1) {
                    comment.playing = true; //修改当前状态
                    MediaSvc.play(url, function() {
                      //开始播放
                      console.log('play success end')
                      $timeout(function(){comment.playing = false});
                    }, function(err) {
                        $timeout(function(){comment.playing = false});
                    },function(player){
                        mediaPlayer=player;
                    },function(status){
                      if(status==4){
                        $timeout(function(){comment.playing = false});
                      }
                    })
                }
            }
            currentPlayComment = comment;
        }
        scope.playAudioEvent = playAudioVoice;
        scope.$on('$destroy',function(){
            if(mediaPlayer!=null){
                mediaPlayer.pause();
            }
        })
      }
      return{
            restrict: "AE",
            templateUrl: 'templates/commentlist.html',
            replace: true,
            link:linker,
              scope: {
               dotmsgs: '='
            }
      }

    })