'user strict';
/**
 * @description 自动检测版本更新
 */
rootModule
    .directive('iframeElement', function ($ionicModal, $sce) {

        return {
            replace: false,
            transclude: false,
            restrict: 'AE',
            link: function (scope, element, attrs) {
                var height = document.getElementsByTagName("ion-view")[0].offsetHeight-44;
                if(typeof device!='undefined'&&device.platform=='iOS'){
                    height-=20;
                }
                scope.contentHeight = height;
                scope.trustSrc = function (url) {
                    return $sce.trustAsResourceUrl(url);
                }
                element.bind("click", function () {
                    scope.contentUrl = "" + attrs.iframeElement;
                    $ionicModal.fromTemplateUrl('templates/Iframe.html', {
                        scope: scope,
                        animation: 'slide-in-up'
                    }).then(function (modal) {
                        scope.modal = modal;
                        modal.show();
                    });
                    scope.openModal = function () {
                        scope.modal.show();
                    };
                    scope.closeModal = function () {
                        scope.modal.hide();
                    };
                    //Cleanup the modal when we're done with it!
                    scope.$on('$destroy', function () {
                        scope.modal.remove();
                    });
                    // Execute action on hide modal
                    scope.$on('modal.hidden', function () {
                        // Execute action
                    });
                    // Execute action on remove modal
                    scope.$on('modal.removed', function () {
                        // Execute action
                    });
                });

            }

        }
    })