'use strict';
/**
 * 显示海报，花絮视频
 */
rootModule
    .directive('showFeature', function($compile, $ionicModal, $templateCache,$ionicSlideBoxDelegate,$timeout) {
        var linker = function($scope, element, attrs) {
            var imageTemplate = '<ion-view style="background:black">' +
                '<ion-content id="scroll" on-scroll="scrollToTop(scrollTop,scrollLeft)">' +
                '<ion-slide-box  style="width:100%;overflow:visible;" active-slide="model.activeIndex"  on-slide-changed="slideHasChanged($index)">'+
                '<ion-slide  style="height:{{windowheight}}px;width:{{windowwidth}}px;" ng-repeat="item in allsrc">'+
                '<div  class="slide-box-middle" style="height:{{windowheight}}px;width:{{windowwidth}}px;" >'+
                '<div  class="H_slide-box-img" style="width:100%">'+
                '<img ng-if="item.isImg" style="width:100%" lazy-load src imgtype="featureBigImg" realsrc="{{item.url}}" nothumb="true" on-tap="closeModal()"></img>'+
                '<div ng-if="!item.isImg">'+
                '<video-player  isShowPreview="false" video-url="{{item.url}}" poster-url="{{item.posterurl}}"></video-player>' +
                '</div>'+
                '</div>'+
                '</div>'+
                '<div ng-if="!item.isImg">' +
                '<button  on-tap="closeModal()" class="button button-clear H_vedio-close H_icon-ion-size">关闭视频</button>'+
                '</div>'+
                '</ion-slide>'+
                '</ion-content>' +
                '<div style="position:absolute;z-index:10;top:10px;left:50%">'+
                '<span style="color:#fff;font-size:18px">{{_index+1}}/{{allsrc.length}}</span>'+
                '</div>'+
                '</ion-view>';

            $templateCache.put('image-template.html', imageTemplate);
            $scope.regimg = /\.(jpg|png|jpeg|gif)$/i;
            var regimg = /\.(jpg|png|jpeg|gif)$/i;
            $scope.regvideo = /\.(mp4)$/i;
            var regvideo = /\.(mp4)$/i;
            $scope.allsrc =[];

            // debugger
            element.on("click", function() {
                $scope.imgtype = attrs.imgtype
                //判断加载类型
                var templateId; //加载的模板类型
                $scope.allsrc =[];
                $scope.allsrc =  $scope.allsrc.concat(JSON.parse(attrs.allsrc))
                templateId = 'image-template.html';

                // if(attrs.ngsrc&&attrs.allsrc){
                //     $scope.allsrc =  $scope.allsrc.concat(JSON.parse(attrs.allsrc))
                //     templateId = 'image-template.html';
                // }else{
                //     templateId = 'image-template.html';
                // }

                $ionicModal.fromTemplateUrl(templateId, {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $scope.modal = modal;
                    modal.show();
                });
                $scope.modalshow = {
                    posterUrl: attrs.ngsrc
                };;
                 //当图片切换时下标显示出来
                 $scope.slideHasChanged = function(index){
                    $scope.$broadcast("stopPlay")
                    $scope._index=index;
                     //重新计算滑动框大小
                 $timeout(function(){
                    $ionicSlideBoxDelegate.update();

                },50)
                 }
                function scrollToTop(scrollTop,scrollLeft){
                      var scroll=element[0].querySelector('#scroll');
                    if(scrollLeft>10){
                        scroll.overflowScroll='true';
                        scroll.style.overflowY='hidden';
                    }

                }
                 $scope.scrollToTop= scrollToTop;
                 //获取屏幕宽高
                 var windowheight = window.screen.height;
                 $scope.windowheight=windowheight;
                 var windowwidth = window.screen.width;
                 $scope.windowwidth=windowwidth;

                 //获取当前图片index并将改index绑定给滑动块

                angular.forEach($scope.allsrc,function(item,index){
                    if (regimg.test(item.url)) {
                        item.isImg = true;
                    } else if (regvideo.test(item.url)) {
                        item.isImg = false
                    }
                    if(item.url==attrs.ngsrc){
                       var nowindex=index;
                       $scope._index = index;
                       $scope.model = {
                         activeIndex: nowindex
                       };
                    }
                    // debugger
                    // console.log($scope.allsrc)

                })

            })

            $scope.closeModal = function() {
                $scope.modal.remove();

            };
            $scope.$on('modal.hidden', function() {
              $scope.$broadcast("stopPlay")//暂停
            });
            $compile(element.contents())($scope);
        }

        return {
            restrict: "AE",
            link: linker,
            replace: true
        }

    })
