'user strict';
/**
 * @description 数据管理服务
 */
rootModule
    .factory('Storage', function() {
        return {
            set: function(key, data) {
                return window.localStorage.setItem(key, window.JSON.stringify(data));
            },
            get: function(key) {
                var item=window.localStorage.getItem(key);
                if(item!='undefined'){
                    return window.JSON.parse(item);
                }else{
                    return null;
                }
            },
            remove: function(key) {
                return window.localStorage.removeItem(key);
            }
        }
    })