'user strict';
rootModule
    .factory('ENV', function() {
        /*********内网服务器*******/
        var localServer = {
            api: 'http://service12.handsight.com.cn', //主服务地址
            uploadApi: "http://service.handsight.com.cn", //上传服务地址
            shareApi: "http://share.handsight.com.cn", //分享的服务器地址
            campApi: "http://game.handsight.com.cn",//活动的服务器地址
            longPoll: 'http://192.168.8.22:1235', //长连接服务地址
            posterScannerServer: "192.168.1.1:1234", //海报识别的服务器地址,不需要加http
            videoScannerServer: "192.168.1.1:1234", //视频识别的服务器地址,不需要加http
            ticketTailor:"http://123.59.97.6:4802/tailor/http://m.mtime.cn/#!/onlineticket/"
        }
        /*********公网服务器（阿里云）*******/
        var publicServer = {
            api: 'http://service15.handsight.cn', //主服务地址
            uploadApi: "http://upload15.handsight.cn", //上传服务地址
            shareApi: "http://share.handsight.cn", //分享的服务器地址
            campApi: "http://game.handsight.cn",//活动的服务器地址
            longPoll:'http://123.59.97.6:1235', //长连接服务地址
            posterScannerServer: "123.59.97.6:4303", //海报识别的服务器地址,不需要加http
            videoScannerServer: "123.59.97.6:4303", //视频识别的服务器地址,不需要加http
            ticketTailor:"http://123.59.97.6:4802/tailor/http://m.mtime.cn/#!/onlineticket/"
        }
        /*********公网Beta服务器（阿里云）*******/
        var betaServer = {
            api: 'http://servicebeta15.handsight.cn', //主服务地址
            uploadApi: "http://uploadbeta15.handsight.cn", //上传服务地址
            shareApi: "http://share.handsight.cn", //分享的服务器地址
            campApi: "http://game.handsight.cn",//活动的服务器地址
            longPoll:'http://123.59.97.6:7474', //长连接服务地址
            posterScannerServer: "123.59.97.6:4303", //海报识别的服务器地址,不需要加http
            videoScannerServer: "123.59.97.6:4303", //视频识别的服务器地址,不需要加http
            ticketTailor:"http://123.59.97.6:4802/tailor/http://m.mtime.cn/#!/onlineticket/"
        }
        var config = {
                version: '1.5.0116A',
                platform:"101",
                debug: true,
                userServer:'public', //local:内网服务器，public：公网服务器
                loadingTemplate: '',
                thumbImageLoadTime: 30000,
                timeRange: 2, //取时间范围,
                scanner: 1, //1.使用barCodeScanner   2.使用zbar Scanner,
                descKey: "()*&(*JLKWJEF2&(*&(*&9812osidhfoi123898hoih039", //加密的Key
                APPID: ''
            }
            if(config.userServer=='local'){
                config.servers=localServer;
                angular.extend(config,localServer);
            }else if(config.userServer=='public'){
                config.servers=publicServer;
                angular.extend(config,publicServer);
            }else if(config.userServer=='beta'){
                config.servers=betaServer;
                angular.extend(config,betaServer);
            }

            //这里主要用作测试
            // if (typeof DataInterface == 'undefined') {
            //     config.APPID = "ed60a4c24aa39bfe41cc74bce62fe5390c552aeddbcf2b11"; //当前设备的APPID
            //     //这里来模拟调试电信插件
            //     window.DataInterface = {
            //         data: {
            //             timeshift: 2000, //当前播放的时间进度
            //             relTime: 200, //当前播放的时间进度
            //             programid: 289, //当前播放的视频ID（电信的ID），324:王牌特工，494：冰川时代，289：速度与激情7，495：杨家将
            //             programname:"未定义",
            //             programtype: 0, //0,点播，1，直播，2，录播
            //             programitem:"一",
            //             status: 0, //当前播放的状态
            //             play_screen: 1, //当前在什么屏幕进行播放，全屏、半屏、甩屏到电视
            //           //  itvid: "0283354099693@ITV", //当前登录的用户ITV账号
            //             video_start_time: '20150930193400' //当前播放节目的开始时间，主要用于直播和回看
            //         },
            //         get:function(key){
            //             return this.data[key];
            //         },
            //         getString: function() {
            //             return JSON.stringify(this.data);
            //         }
            //     }
            // }
        return config;
    });
//open -a "Google Chrome" --args --disable-web-security