/**
 * @description 选择电视台Controller
 * @author SuperK
 * @date 2016-01-07
 */
rootModule
.controller('TvStationDetailCtrl', function($scope,$state,$stateParams,MovieServe,Movies,$ionicPopup) {
  //判断是不是正在播放
  function fundShowProgram(item){
    var currentDate = new Date();
    if(currentDate>item.startShowDate && currentDate<item.endShowDate){
      return 1;//正在播放
    }else if(currentDate<item.startShowDate){
      return 0;//未开始
    }else if(currentDate>item.endShowDate){
      return 2;//结束
    }
  }
  var dateList =[
      // {"date":"前天","status":0},
      // {"date":"昨天","status":1},
      // {"date":"今天","status":2},
      // {"date":"明天","status":3},
  ]
  var tvstationid = $stateParams.tvstationid;





   //导航栏切换样式
  $scope.switchdatenav =function(nowitem,index){
      $scope.tvstationdetaillist = nowitem.programList;
      if(nowitem.activated){

      }else{
        angular.forEach($scope.dateList,function(item,_index){
          item.activated=false;
     })
      nowitem.activated=true;
    }
  }
  //跳转进入三边页面
  var openComment = function(moviename,videoIdSide,startedTime,movieLength,startTime){
      $state.go('platform-side', {
          videoId:videoIdSide,  //跳转传入一个视频ID
          tvhelper:"tvhelper",
          startedTime:startedTime,
          movieLength:movieLength,
          moviename:encodeURIComponent(moviename),
          startTime:startTime,
          isSystemCountdown:true
      });
  }
   //导航栏切换样式
  $scope.openforum =function(nowitem,index){
      if(nowitem.activated){

      }else{
        angular.forEach($scope.tvstationdetaillist,function(item,_index){
          item.activated=false;
        })
          nowitem.activated=true;
      }
      if(nowitem.isPlaying == 2){//回顾
        var movieLength = parseInt((nowitem.endShowDate - nowitem.startShowDate)/1000);
        // 电视节目预约连接，type = 5，电视节目
        Movies.addAsenceNew(nowitem.pid,5,function(result){
          if(result.success){
            // Toast.show("该场次连接成功")
          }else{
            // Toast.show("该场次已经连接过了")
          }

        })
        openComment(nowitem.vName,nowitem.vid,"",movieLength,nowitem.starttime)
      }
      var leftTime = MovieServe.getLeftTime(nowitem.startShowDate);//获取剩下的时间
      if(leftTime.isNotShow){
        // 电视节目预约连接，type = 5，电视节目
        Movies.addAsenceNew(nowitem.pid,5,function(result){
          if(result.success){
            // Toast.show("该场次连接成功")
          }else{
            // Toast.show("该场次已经连接过了")
          }

        })
        if(leftTime.isNotShow){
          var hours = leftTime.day*24+leftTime.hour
          var promptWords = '距离电视开始:还有'+hours+'小时'+leftTime.minute+'分';
        }else{
          var promptWords = "已经开始了，快去互动吧！";
        }
        //预约弹出框
        var programpredictone = $ionicPopup.alert({
            title: promptWords,
            scope: $scope
        });
      }

  }
  function initInfro(){
    $scope.loadingStatus = MovieServe.getLoadingStatus(1);
    MovieServe.getTvprogramList(tvstationid,function(result){
      if(result.status){
        if(result.programList.length>0){
          angular.forEach(result.programList,function(item){
            if(item.status == 2){
              $scope.tvstationdetaillist = item.tvProgramList;
              dateList.push({"showDate":item.startDate,"date":"今天","status":2,"programList":item.tvProgramList})
            }else if(item.status == 0){dateList.push({"showDate":item.startDate,"date":"前天","status":0,"programList":item.tvProgramList})}
             else if(item.status == 1){dateList.push({"showDate":item.startDate,"date":"昨天","status":1,"programList":item.tvProgramList})}
             else if(item.status == 3){dateList.push({"showDate":item.startDate,"date":"明天","status":3,"programList":item.tvProgramList})}
             else if(item.status == 4){dateList.push({"showDate":item.startDate,"date":item.showDay,"status":4,"programList":item.tvProgramList})}
            //列表栏默认样式
            angular.forEach($scope.tvstationdetaillist,function(item,index){
               var isShowing = fundShowProgram(item)
               item.isPlaying = isShowing;
               if(isShowing == 1){
                 item.activated = true;
               }
             })
          });
        }else{
          $scope.tvstationdetaillist = [];
        }

        //按时间排序
        dateList.sort(function(a,b){
          return a.showDate - b.showDate
        })
        $scope.dateList = dateList;
        //导航栏默认样式
         angular.forEach($scope.dateList,function(item,index){
             if(item.status == 2){
               // item.activated=index==2?true:false;
               item.activated = index = true;//默认停在今天
             }

           })
        $scope.loadingStatus = MovieServe.getLoadingStatus(2);
      }else{
        $scope.loadingStatus = MovieServe.getLoadingStatus(3);
      }


    })
  }
  initInfro();
  $scope.$on("loadAgainInfro",function(e,data){
    initInfro();
  })


})
