'use strict';
/**
 * @description 直播相关Controller
 * @author SuperK
 * @date 2015-04-02
 */
rootModule
/**
 * 乐配音查看详情
 * @param  {[type]} $scope){                 } [description]
 * @return {[type]}           [description]
 */
.controller("newPlayVideoDetailCtrl", function($scope,$rootScope,$ionicLoading, ENV, $filter, $stateParams,PlaySvc, MovieServe,$timeout, $ionicHistory, Toast, User, $state, $ionicPopup, $ionicScrollDelegate, InterfaceSide,ImageSvc,Movies,$location) {
    // console.log('查看娱乐详情', $stateParams);
    $scope.playId = -1;
    var originalVideoUrl;
    var disportId = "";//成果Id
    var disportDataId = "";//素材Id
    $scope.playResult;
    $scope.oneDisportDataList = []; //同素材其他作者乐配
    $scope.oneDisportDataList.loading = true;
    $scope.oneVideoDataList = []; //同视频其他乐配
    $scope.oneVideoDataList.loading = true;
    $scope.otherVideoList = []; //其他视频乐配
    $scope.otherVideoList.loading = true;
    $scope.praisetarget = $stateParams.id;//点赞数据id
    var scrollTag = "play"+$stateParams.text+"detail"+$stateParams.id;//与指令通信
    $scope.scrollTag = scrollTag;
    var scrollName = scrollTag+"name"+$stateParams.id;
    $scope.scrollName = scrollName;

    var linkImgUrl;
    var imgSrc;
    var isGetInfro = false;
    $scope.isGetInfro = false;
    $ionicLoading.show({'duration':5000,'delay':0,'noBackdrop':false});
    //配
    $scope.userPlayEvent = function() {
        //停止所有播放
        $scope.$broadcast('stopPlay');
        //识别用户是否登录
        if (User.getCurrentUser() != null) {
            //跳转页面
            $state.go('play-'+$stateParams.text+'-edit', {
                id: $scope.playId
            })
        } else {
            $state.go('login')
            // //打开电信登录页面
            // if (typeof LaunchMode != 'undefined') {
            //     LaunchMode.log();
            // }
            // Toast.show('您还未登录')
        }
    }
    ImageSvc.calcItem($scope,2,16/9,0); //计算图片显示高宽

    $scope.getOriginalVideoUrl = function() {
        return originalVideoUrl;
    }
    //
    var filterData = function (data, column) {
        var tempData = [];
        for (var i = 0; i < data.length; i++) {
            var index = parseInt(i / column);
            if (i % column == 0) {
                tempData[index] = [];
            }
            var temp = data[i];
            // switchDesign(temp);
            tempData[index].push(temp);
        }
        return tempData;
    }

    //分享到第三方平台
    /*
     下面是传入的参数的格式及字段的意义：
     platform      : 分享平台，可以取值为 wxfriend(微信好友)、wxcircle(微信朋友圈)、weibo(新浪微博)、qzone(QQ空间)、qfriend(QQ好友)

     contentType   : 数据类型，可以取值为 link(网页链接)、text(文本)、img(图片)
     content       : 分享的内容对象

     contentString : 除QQ空间外分享的内容，取值可以是网页链接、文本、图片链接
     linkImgUrl    : 和网页链接一起分享的图片

     qzText        : QQ空间分享的文本
     qzLink        : QQ空间分享的网页链接
     qzImgUrl      : QQ空间分享的图片链接

     */
    //配音
    $scope.shareDatas = function(){
        // console.log(linkImgUrl);
        // console.log(imgSrc);
        // debugger
        return {
            type: "img",
            title: $scope.playResult ? $scope.playResult.disportTitle : "",
            text: $scope.playResult ? $scope.playResult.disportTitle : "",
            link: ENV.shareApi + "?id=" + disportId,
            linkImgUrl: linkImgUrl,
            imgSrc: imgSrc
        };
    };

    $scope.closeAPP = function() {
        //判断是否有backview
        if ($ionicHistory.backView()) {
            $ionicHistory.goBack();
        } else {
            ionic.Platform.exitApp();
        }
    }
    $scope.$on("$destroy", function() {
        //通知需要停止播放
        $scope.$broadcast('stopPlay');
    });
    // 评论功能，通过滚动控制输入框是否显示<mark3>
    // $timeout(function(){
    //     var commentheigth = document.getElementById(scrollTag).offsetTop - window.screen.height+105;

    //     if(commentheigth<0){
    //           $scope.$broadcast(scrollTag,{"status":true})
    //     }else{
    //         $scope.$broadcast(scrollTag,{"status":false})
    //     }
    // },100)
    // var lastvalue=0;
    // $timeout(function(){
    //   // var commentheigth = document.getElementById(scrollTag).offsetTop - window.screen.height+105;
    //   // if(commentheigth<=0){
    //   //   $scope.$broadcast(scrollTag,{"status":true})
    //   // }
    //   document.querySelector("#"+scrollName).onscroll=function(){
    //     // debugger
    //     var commentheigth = document.getElementById(scrollTag).offsetTop - window.screen.height+105; //comment的高度
    //      // console.log(document.getElementById(scrollTag).offsetTop)
    //       var currentvalue = this.scrollTop;
    //       var sl = Math.abs(currentvalue-lastvalue)
    //       if(sl>15){
    //         if (this.scrollTop >= commentheigth) {
    //             $scope.$broadcast(scrollTag,{"status":true})
    //         } else {
    //             $scope.$broadcast(scrollTag,{"status":false})
    //         }
    //         if (this.scrollTop >= commentheigth+window.screen.height) {
    //             $scope.$broadcast(scrollTag+"back",{"status":true})
    //         } else {
    //             $scope.$broadcast(scrollTag+"back",{"status":false})
    //         }
    //         lastvalue = currentvalue;
    //       }
    //   }
    // },100)
    var lastvalue=0;
    function showInputBoxPlay() {
        var position=$ionicScrollDelegate.getScrollPosition();
        var scrollTop=position.top;
        var scrollLeft=position.left;
        $scope.$broadcast($location.path(),{
                'scrollTop':scrollTop,
                'scrollLeft':scrollLeft,
                'showbrainrepair':true
            });//默认加载一次图片
        $timeout(function(){
            var commentheigth = document.getElementById(scrollTag).offsetTop - window.screen.height+105;
            if(commentheigth<0){
                $scope.$broadcast(scrollTag,{"status":true})
            }else{
                var currentvalue = scrollTop;
                var sl = Math.abs(currentvalue-lastvalue)
                if(sl>15){
                  if (scrollTop >= commentheigth) {
                      $scope.$broadcast(scrollTag,{"status":true})
                  } else {
                      $scope.$broadcast(scrollTag,{"status":false})
                  }
                  if (scrollTop >= commentheigth+window.screen.height) {
                      $scope.$broadcast(scrollTag+"back",{"status":true})
                  } else {
                      $scope.$broadcast(scrollTag+"back",{"status":false})
                  }
                  lastvalue = currentvalue;
                }

            }
        },100)


    }
    $scope.showInputBoxPlay = showInputBoxPlay;
    $scope.$on("$ionicView.beforeLeave", function() {
        //通知需要停止播放
        $scope.$broadcast('stopPlay');
        $scope.$broadcast('resetPlayer');
    });
    $rootScope.$on("appPauseEvent",function(){
        //暂停播放
        $scope.$broadcast('stopPlay');
    })
   //打开其它乐配电影详情页
   $scope.openDisportDetail = function(play) {
     var id;
         id=play.disportId;  //跳转到哪里去?recreationType
         switch (play.recreationType) {
             case "1":
                 var text = "video";
                 break;
             case "2":
                 var text = "head";
                 break;
             case "3":
                 var text = "text";
                 break;
         }
        $state.go('new-play-'+'details', {
            id: id,
            text:text
        });
     // $state.go('play-'+text+'-details', {
     //     id: id
     // });
   }

    //将字符串转换成对象
    var filterJson = function(list){
        var templist = list;
        angular.forEach(templist,function(item){//该电影其他作品列表
            item.content = JSON.parse(item.content)
            switch (item.recreationType) {
                case "1":
                    item.content.url = item.content.videoSplashImg;
                    break;
                case "2":
                    item.content.url = item.content.resultImg
                    break;
                case "3":
                    item.content.url = item.content.resImgSrc;
                    break;
            }
        })
        if(list==null){
            templist = [];
            return templist
        }else{
            return templist;
        }
    }
    //markget
    /**转换时间格式**/
    var switchTime = function(time){
        var newTime;
        if(/-/g.test(time)){
            newTime = time.replace(/-/g, "/")
            newTime = new Date(Date.parse(newTime))
            return newTime;
        }else{
            newTime = new Date(Date.parse(time))
            return newTime;
        }
    }
    /**查询乐配详情页面信息数据，传入disportId**/
    var getDetailInfor = function(){
        if(!isGetInfro){
            $scope.loadingStatus = MovieServe.getLoadingStatus(1);
            Movies.getDisportDetail($stateParams.id,function(result){
             if(result.success){
                 isGetInfro =true;
                 $scope.otherVideoList = filterJson(result.data.otherMovieList); //其他同类电影作品
                 $scope.oneDisportDataList = filterJson(result.data.otherAuthorList);//同素材其他作者乐配
                 $scope.oneVideoDataList = filterJson(result.data.movieOtherList);//该电影其他作品
                 result.data.content = JSON.parse(result.data.content);
                 $scope.playResult = result.data;
                 if(/\.\d/.test(result.data.releaseTime)){
                    result.data.releaseTime = result.data.releaseTime.replace(/\.\d/g,"")
                    result.data.releaseTime = switchTime(result.data.releaseTime)
                 }else{
                    if(result.data.releaseTime==""){
                        result.data.releaseTime = switchTime(result.data.updateTime)
                    }else{
                        result.data.releaseTime = switchTime(result.data.releaseTime)
                    }
                 }
                 $scope.otherVideoList = filterData($scope.otherVideoList,2);
                 $scope.oneDisportDataList = filterData($scope.oneDisportDataList,2);
                 $scope.oneVideoDataList = filterData($scope.oneVideoDataList,2);
                 // debugger
                 disportId = result.data.disportId;
                 $scope.playId = result.data.disportDataId;
                 disportDataId = result.data.disportDataId;
                 // debugger
                 if (result.data.recreationType == "1"|| result.data.recreationType == 1) {
                     //通知开始初始化播放器
                     originalVideoUrl = result.data.content.compositeVideo; //设置合成的视频地址;
                     //2.通知视频播放器可以初始化播放器了，
                     $scope.$broadcast('__initVideoPlayer', {
                         url: originalVideoUrl,
                         videoSplashImg: result.data.content.videoSplashImg,
                         buffer:false //不使用本地缓冲
                     });
                     $scope.isVideo = true;
                     $ionicLoading.hide();
                     $scope.isGetInfro = true;
                     $scope.pagetilte="配音";
                     linkImgUrl = $scope.playResult ? $scope.playResult.content.videoSplashImg : "";
                     imgSrc = $scope.playResult ? $scope.playResult.content.videoSplashImg : "";
                 }else if(result.data.recreationType == "2"|| result.data.recreationType == 2){
                     $scope.detailImageSrc = result.data.content.resultImg;
                     $scope.isHead = true;
                     $ionicLoading.hide();
                     $scope.isGetInfro = true;
                     $scope.pagetilte="配图";
                     linkImgUrl = $scope.playResult ? $scope.playResult.content.resultImg : "";
                     imgSrc = $scope.playResult ? $scope.playResult.content.resultImg : ""
                 }else if(result.data.recreationType == "3"|| result.data.recreationType == 3){
                     $scope.detailImageSrc = result.data.content.resImgSrc;
                     $scope.isText = true;
                     $ionicLoading.hide();
                     $scope.isGetInfro = true;
                     $scope.pagetilte="配词";
                     linkImgUrl = $scope.playResult ? $scope.playResult.content.resImgSrc : "";
                     imgSrc = $scope.playResult ? $scope.playResult.content.resImgSrc : ""
                 }
                 $scope.loadingStatus = MovieServe.getLoadingStatus(2);
             }else{
                isGetInfro = false;
                $ionicLoading.hide();
                $scope.isGetInfro = true;
                $scope.loadingStatus = MovieServe.getLoadingStatus(3);
             }
            })
        }
    }
    // getDetailInfor();

    $scope.$on('$ionicView.enter', function() {
        if(!isGetInfro){
            // debugger
            getDetailInfor();
        }
    });
    $scope.init = function(){
        getDetailInfor();
    }
    $scope.$on("loadAgainInfro",function(e,data){
      isGetInfro = false;
      getDetailInfor();
    })
  // $scope.imgindex = 5;


})