'use strict';
/**
 *首页的相关操作
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
/**
 * 首页列表相关
 */

.controller('HomeCtrl', function(
  $scope, $state, $rootScope, $timeout, $stateParams, $ionicModal, Movies, Toast,
    MovieServe, ENV, InterfaceDotInfo, $ionicSlideBoxDelegate,$location,
     ImageSvc, $ionicLoading, $http,$ionicScrollDelegate,$interval,$ionicPopup) {
    var noMoreItemsAvailabledown=false;
    //这里给页面提供图片显示大小的数据
    //首页默认放置3.5张图片，每张图片的比例为3:4
    var movie=ImageSvc.calcItem($scope, 3, 3/4 ,0);
        $scope.moviewidth=movie.itemWidth;
        $scope.movieheight=movie.itemHeight;
         /*娱乐板块图片显示*/
    var tv=ImageSvc.calcItem($scope,3,16/9,0);
        $scope.tvwidth=tv.itemWidth;
        $scope.tvheight=tv.itemHeight;
        $scope.versionStatus = 2;//默认2电影，1电视
    var  versionStatus = 2;//默认2电影，
    //页面上可以直接访问itemWidth,itemHeight 属性
    // $scope.isHotNew = false;
    // $rootScope.userlocation.isCinema = false;
    // console.log($rootScope.userlocation)

    // $scope.entertv= function(){
    //     $state.go('TV-' + 'detail', {
    //         id: 268611369
    //     })
    // }
    /*
     * 函数功能: 进入当前主页时, 判断用户是否已看过并关闭过该提示,若是则不显示,否则显示
     * */
    $scope.$on("$ionicView.loaded", function () {
        if (!localStorage.hasOwnProperty("isShowHomeTipPicture") || localStorage["isShowHomeTipPicture"] != "false") {
            $rootScope.$broadcast("teachPicture1-home",{
                teachBuyTicket:{
                    src1: "img/homeTipPicture1.png",
                    src2a: "img/homeTipPicture2b.png",
                    src2b: "img/homeTipPicture2a.png",
                    src3: "img/homeTipPicture3.png",
                },
                isHideTeachPicture: false,
                hideTeachPicture: function () {
                    this.isHideTeachPicture = true;
                    localStorage["isShowHomeTipPicture"] = "true";
                },
                dontMention: function () {
                    this.isHideTeachPicture = true;
                    localStorage["isShowHomeTipPicture"] = "false";
                }
            });
        } else {
            $rootScope.$broadcast("teachPicture1-home",{
                isHideTeachPicture: true
            });
        }
    });
       $scope.entertvstationdetail = function (item){
         var tvstationid = item.menuId;//电视台id
         $state.go('TV-station-detail',{
           tvstationid:tvstationid
         })
       }
       var homenavlist = [
           {"title":"电影","status":"0"},
           {"title":"电视","status":"1"}
       ]
       $scope.homenavlist = homenavlist;
       $scope.showmovielist = true;  //电影列表默认显示
      angular.forEach($scope.homenavlist,function(item,index){
           item.activated=index==0?true:false;
      })
      //电影点击事件
      var showmovieClickTime = false;//切换电视点击事件
      $scope.showmovie =function(nowitem,nowindex){
          if(nowindex == 0){
            $scope.versionStatus = 2;//电影状态值
            versionStatus = 2;//电影状态值
          }else if(nowindex==1){
            $scope.versionStatus = 1;//电视的状态值
            versionStatus = 1;//电视的状态值
          }

          $ionicScrollDelegate.resize();//滚动条risize
          if(nowitem.activated){
          }else{
            angular.forEach($scope.homenavlist,function(item){
                 item.activated=false;

         })
                 nowitem.activated=true;
        }
        if(nowindex==0){
            $scope.showmovielist = true;
        }else if(nowindex==1){
            if(!showmovieClickTime){
                init(false,false,1);//第一次拉去电视版本的数据
                showmovieClickTime = true;
            }else{
                // $scope.showmovielist =! $scope.showmovielist;
            }
            $scope.showmovielist = false;

        }
      }




      $scope.entertv= function(){
        $state.go('TV-station')

      }


    //跳转到详情页面（新版）
    $scope.goVideoDetail = function(item){
        var id = item.videoId
        $state.go('TV-detail',{
            id:id
        })
    }
     //预约弹出框样式1
     var programpredictone = function(item){
       // 电视节目预约连接，type = 5，电视节目
       Movies.addAsence(item.tvProgramId,5,function(result){
         if(result.success){
           // Toast.show("该场次连接成功")
         }else{
           // Toast.show("该场次已经连接过了")
         }

       })
       var leftTime = MovieServe.getLeftTime(item.startDate);//获取剩下的时间
       if(leftTime.isNotShow){
         var hours = leftTime.day*24+leftTime.hour
         var promptWords = '距离电视开始:还有'+hours+'小时'+leftTime.minute+'分';
       }else{
         var promptWords = "已经开始了，快去互动吧！";
       }

       var programpredictone = $ionicPopup.alert({
           title: promptWords,
           scope: $scope,
           // buttons: [
           //     {
           //         text: '取消',
           //     },
           //     {
           //         text: '前往',
           //         type: 'button-balanced',
           //         onTap: function(){
           //           $state.go('platform-side', {
           //               videoId:$stateParams.id,  //跳转传入一个视频ID

           //           });
           //         }
           //     }
           // ]
       });
     }
    //预约弹出框样式2
    var programpredict = function(){
      var programpredict = $ionicPopup.show({
          title: '电视开始,是否立即参与互动?',
          template: '<div class="H_tv-predict-popbox">意甲年度50大精彩进球</div>',
          scope: $scope,
          buttons: [
              {
                  text: '取消',
              },
              {
                  text: '前往',
                  type: 'button-balanced',
                  onTap: function(){
                    $state.go('platform-side', {
                        videoId:$stateParams.id,  //跳转传入一个视频ID

                    });
                  }
              }
          ]
      });
    }
    $scope.programpredict=programpredictone;
    /*菜单栏*/
    var movieTitles = ["即将上映", "正在热映", "历史热映"];
    var movieNavs = [{
        "width": "55",
        "index": 0
    }, {
        "width": "25",
        "index": 1
    }, {
        "width": "20",
        "index": 2
    }]
    $scope.movieNavs = movieNavs;
    $scope.movieTitles = movieTitles;
    $scope.currentLocation = [];

    $scope.goMovie = function(e,showmovielist) {
        var moreid=Math.ceil(Math.random()*10);
        var id = e.target.attributes.statusid.value;
        if(showmovielist){
            var versiontype = 2;//电影
        }else{
            var versiontype = 1//电视
        }
        switch (id){
            case "1":
            var textname = "new";
            break;
            case "2":
            var textname = "hot";
            break;
            case "3":
            var textname = "past";
            break;
        }
        $state.go('movie-more', {
            id: id,
            textname:textname,
            versiontype:versiontype,
            moreid:moreid
        });
    };

    $scope.openDetail = function(movieitem) {
        var id = movieitem.vId;
        $state.go('movie-' + 'detail', {
            id: id
        });
    }
    $scope.openredpacket = function(){
        $state.go('red-packet');
    }
    var appId = ENV.APPID
        //console.log(appId)
    $scope.getClicky = function(id) {
        /*$ionicLoading.show();
        $http.get(ENV.api + "/active/get_active?activeId="+id+"&appId="+ENV.APPID)
            .success(function(response) {
                $ionicLoading.hide();
                if (!response.success || !response.data) {
                    Toast.show("出错了！");
                    return;
                }*/

                /*if (response.data.type == 1 || response.data.type == 2 ||
                    response.data.type == 5 || response.data.type == 3) { //大转盘 百宝箱 砸金蛋 刮刮卡*/
                    window.open(ENV.campApi + "/campaign/index.html?deviceType=0&campId=" + id + "&t=" + new Date().getTime()
                        + "&appId=" + ENV.APPID, '_blank', 'location=yes');
               /* }else if(response.data.type == 4){ //答题
                    window.open(ENV.campApi + "/question/index.html?deviceType=0&campId=" + id + "&t=" + new Date().getTime()
                        + "&appId=" + ENV.APPID, '_blank', 'location=yes');
                }*/
            /*})
            .error(function(err){
                throw new Error(err);
            });*/
        //var host = window.open(ENV.campApi + "/index.html?deviceType=0&campId=" + id + "&t=" + new Date().getTime()
        //    + "&appId=" + ENV.APPID, '_blank', 'location=yes');
        //var host = window.open("http://game.handsight.com.cn/index.html?deviceType=0&campId="+id+"&t="+new Date().getTime()
        //    +"&appId="+ENV.APPID, '_blank', 'location=yes');
        //console.log(host);
        //setInterval(function(){
        //    host.postMessage(message,domain);
        //}, 5000);
        // var link = 'http://game.handsight.com.cn/index.html?deviceType=0&campId='+id+"&appId="+appId;
        // window.open(link, '_blank', 'location=yes');
        //var activeId = id
        //$state.go('lucky-wheel',{
        //    activeId:activeId
        //});
        // var index=$ionicSlideBoxDelegate.currentIndex();

    }
    //滚动时间
    var lastvalue = 0;
    var showbrainrepair = true;
    $scope.onContentScroll = function(){
        var position=$ionicScrollDelegate.getScrollPosition();
        var scrollTop=position.top;
        var scrollLeft=position.left;
        var data = {
            'scrollTop':scrollTop,
            'scrollLeft':scrollLeft,
            'showbrainrepair':true,
        }
        var currentvalue = scrollTop;
        var sl = Math.abs(currentvalue-lastvalue)
        if(sl>25){
          // debugger
          $scope.$broadcast($location.path(),data);//mark1
          // debugger
          lastvalue = currentvalue;
        }
    }

    $scope.openComment = function(movieitem) {
        id = 289
        $state.go('platform-' + 'side', {
            videoId: id,
            tvhelper: "tvhelper",
            startedTime: 50000,
            movieLength: 8,
            //movieId:id
        });
        //$state.go('lucky-wheel');
    }
    $scope.gomoviesence = function() {
        $state.go('movie-scene');
    }
    $scope.goMoviehome = function() {
        $state.go('home1');
    }
    // $scope.curentpage={status:1};
    // view status
    // $scope.pages = {
    //     "new": "新线上映",
    //     "now": "正在热播",
    //     "history": "历史播放"
    // }
    // $scope.currentPage = "new";
    var clickNo = 0;
    var moviestatus = 0;
    var indexlist = [];
    $scope.shownewmovie = true;
    $scope.showhotmovie = false;
    $scope.showhistorymovie = false;
    var currentindex = 0;
    $scope.goSwitch = function(movieitem, index) {
        if (currentindex == index) {
            return;
        }
        currentindex = index;
        if (clickNo == 0) {
            getHomeTheme($scope.homeVideoListH, function(themeList) {
                $scope.mvInfro.themeListH = themeList;
            })
            //clickNo++
        } else if (clickNo == 1) {
            getHomeTheme($scope.homeVideoListP, function(themeList) {
                $scope.mvInfro.themeListP = themeList;
            })
            //clickNo++
        }
        clickNo++

        if (index==1) {
            $scope.isHotNew = true;
        } else {
            $scope.isHotNew = false;
        }
        // var pageStatus=$scope.curentpage.status;
        // $scope.curentpage.status++;
        //console.log(pageStatus)
        // if(pageStatus>2){
        //     $scope.curentpage.status=1;
        switch (index) {
            case 0:
                $scope.shownewmovie = true;
                $scope.showhotmovie = false;
                $scope.showhistorymovie = false;
                break;
            case 1:

                $scope.shownewmovie = false;
                $scope.showhotmovie = true;
                $scope.showhistorymovie = false;
                break;
            case 2:
                $scope.shownewmovie = false;
                $scope.showhotmovie = false;
                $scope.showhistorymovie = true;
                break;

        }
        //1.第一步，将当前点击的放置到第一的位置
        $scope.movieNavs[0].index = index;
        //2.第二步，设置后面的数据
        //3.这里后面的数据实际上是根据前一个数据的index计算出来的，所以计算的时候是去获取上一个Item的index来计算
        //如果计算结果大于数组的长度，那么说明当前点击的Item的下标已经是最大的了。应该将它置为0
        for (var i = 1; i < $scope.movieNavs.length; i++) {
            var result = $scope.movieNavs[i - 1].index + 1;
            if (result >= $scope.movieNavs.length) {
                $scope.movieNavs[i].index = 0;
            } else {
                $scope.movieNavs[i].index = result;
            }
        }

    }

    //查询首页视频
    $scope.homeVideoListN = [];
    $scope.homeVideoListH = [];
    $scope.homeVideoListP = [];
    var typeh = 7 //脑补主题
    $scope.isHotNew = false; //控制附近电影院是否显示
    var vIdN = []; //new页面的主题查询id数组
    var vIdH = []; //hot页面的主题查询id数组
    var vIdP = []; //past页面的主题查询id数组
    $scope.isData = false;
    /**
     * 显示话题详细信息
     * @param  {[type]} dotId [description]
     * @return {[type]}       [description]
     */
    var descEvent = function(themeItem) {
        // debugger
        if(typeof(themeItem.content == "array")){
          $timeout(function(){
              var commentheigth = document.getElementById('movitedetail').offsetTop - window.screen.height+105;
              if(commentheigth<0){
                    $scope.$broadcast("movitedetail",{"status":true})
              }else{
                  $scope.$broadcast("movitedetail",{"status":false})
              }
          }, 100)
          themeItem.allContent = InterfaceDotInfo.createAllContent(themeItem);
          $scope.tempInfo = themeItem
        }
        $scope.motiveId = themeItem.motiveId;

        Movies.getHeadThemeDetail(themeItem.motiveId,function(result){
            themeItem.allContent = InterfaceDotInfo.createAllContent(result.data);
            // debugger
            $scope.tempInfo = themeItem;
            //评论功能，通过滚动控制输入框是否显示<mark3>
            $timeout(function(){
                var commentheigth = document.getElementById('movitedetail').offsetTop - window.screen.height+105;
                if(commentheigth<0){
                      $scope.$broadcast("movitedetail",{"status":true})
                }else{
                    $scope.$broadcast("movitedetail",{"status":false})
                }
            }, 100)
        })
        //评论功能，通过滚动控制输入框是否显示<mark3>

        // var dot = getShowDotByid(dotId);
        // console.log(themeItem)

        $ionicModal.fromTemplateUrl('templates/subjectme/movite-details.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
            modal.show();

        });

        //显示评论框
        function showInputBox(scrollTop, scrollLeft) {
            var commentheigth = document.getElementById('movitedetail').offsetTop - window.screen.height+105;
            if(commentheigth<0){
                $scope.$broadcast("movitedetail",{"status":true})
                if (scrollTop >= commentheigth+window.screen.height) {
                    $scope.$broadcast("movitedetail"+"back",{"status":true})
                } else {
                    $scope.$broadcast("movitedetail"+"back",{"status":false})
                }
            }else{
                if (scrollTop >= commentheigth) {
                    $scope.$broadcast("movitedetail",{"status":true})
                } else {
                    $scope.$broadcast("movitedetail",{"status":false})
                }
                if (scrollTop >= commentheigth+window.screen.height) {
                    $scope.$broadcast("movitedetail"+"back",{"status":true})
                } else {
                    $scope.$broadcast("movitedetail"+"back",{"status":false})
                }
            }

        }

        $scope.showInputBox = showInputBox;

        $scope.scrollTop = function() {
            $ionicScrollDelegate.scrollTop();
        }
        $scope.openModal = function() {
            $scope.modal.show();
        };
        $scope.closeModal = function() {
            $scope.modal.remove();
        };
        $rootScope.$on("closeModal",function(e,data){
            // debugger
            if(data){
                $scope.closeModal()
            }
        })
    }
    $scope.descEventTheme = descEvent
    /**查询脑补信息**/
    var getHomeTheme = function(videolist, callback) {
        var themelist = [];
        var vidlist = [];
        angular.forEach(videolist, function(data, index, array) {
            vidlist.push(data.videoId)
        });
        Movies.getHeadThemeByIds(typeh, vidlist).then(function(result) {
            angular.forEach(result, function(item) {
                if (item.data != null) {
                    themelist = themelist.concat(item.data)
                }

            })


            callback && callback(themelist);
            //console.log(themelist)
        }, function() {
            // console.log("nodata")
        })

    }


    function checkTime(i) {
        if (i < 10) {
            i = "0" + i
        }
        return i
    };

    var activityTime = MovieServe.getAtime(30,30); //获取前30天和后30天的时间
    var starttime = activityTime.starttime;
    var endtime = activityTime.endtime;
    var mark = 2; //活动状态（0：所有，1：强推2：首页显示，3：下架，5：已删除）
    var type = 0; //活动类型(1:大转盘 2：百宝箱 3：其他活动 0:全部 6:抢红包)



    //打开电影详情页面
    $scope.openDetail = function(movieitem) {
        var id = movieitem.videoId;
        $state.go('movie-' + 'detail', {
            id: id
        });
    }

    /*设定轮播图片的高度*/
    $timeout(function() {
    //var imgHeight = document.getElementById('imgheight');
    var screenwidth = document.body.clientWidth;
    var screenHidth = document.body.clientHeight;
    var imgwidth = screenwidth;
    var imgheight = imgwidth * (42 / 72);
    $scope.imgheight = imgheight;
    $scope.imgwidth = imgwidth;
    //imgHeight.style.height = imgheight + "px";
    //imgHeight.style.overflow = 'hidden';
   },200)

    /**
     * 监听页面加载完成了
     * @param  {[type]} )
     * @return {[type]}     [description]
     */
    // assuming the slides are static cache this to save DOM lookups
    // var firstSlide = $('.container .slide').first();
    $scope.$on('$ionicView.enter', function() {
        fixedSlideBug();
    });

    /**
     * 开启缓存后SlideBox 不能滚动的问题
     * @return {[type]}
     */
    function fixedSlideBug(){
        //修复返回主页有可能不刷新Silder的Bug
        var count=0;
        var fixedIt=$interval(function() {
            $ionicSlideBoxDelegate.$getByHandle('homeAcitiveList').update();
            //$ionicSlideBoxDelegate.$getByHandle("homeAcitiveList").loop(true);
            //$ionicSlideBoxDelegate.$getByHandle('homeAcitiveList').start();
            console.log('fixed slide bug');
            if(count>2){
                $interval.cancel(fixedIt);
            }
            count++;
        },500);
    }
    var switchactivity = function(nowitem, nowindex) {
        angular.forEach($scope.homeAcitiveList, function(item) {
            item.isactivated = false;
        })
        nowitem.isactivated = true;
    }

    noMoreItemsAvailabledown = false;//控制下拉刷新
    function init(pushDown,isByClick,versiontype){

        if(!pushDown){//不是下拉刷新

            // $rootScope.$broadcast("loadingcall",{"isLoadingAgain":true,"isLoading":true})
            $scope.loadingStatus = MovieServe.getLoadingStatus(1);

            if(isByClick){
                MovieServe.locationInit(false);//再获取一次地理位置信息，并且不是第一次
            }
        }else{
            // debugger
        }

        if(versiontype == 2){
            //查询首页视频 老接口；
            $scope.mvInfro = {};
            $scope.mvInfro.homeVideoListN = []//new
             $scope.mvInfro.homeVideoListN.loading=true;  //加载中的状态
            $scope.mvInfro.homeVideoListN.nodate=false;  //没有数据时的状态
            $scope.mvInfro.homeVideoListP = []//past
             $scope.mvInfro.homeVideoListP.loading=true;  //加载中的状态
            $scope.mvInfro.homeVideoListP.nodate=false;  //没有数据时的状态
            $scope.mvInfro.homeVideoListH = []//hot
            $scope.mvInfro.homeVideoListH.loading=true;  //加载中的状态
            $scope.mvInfro.homeVideoListH.nodate=false;  //没有数据时的状态
            var homeVideoListN = [];
            var homeVideoListH = [];
            var homeVideoListP = [];
            var homeAcitiveList = [];
            var typeh = 7 //脑补主题
            $scope.isHotNew = false; //控制附近电影院是否显示

            if(!noMoreItemsAvailabledown){
                noMoreItemsAvailabledown = true;
                Movies.getActiveList(mark, starttime, endtime, type, function(result) { //第一步：查询首页显示活动视频
                    $ionicScrollDelegate.resize();
                    if (result.data && result.data.length > 0) {

                        angular.forEach(result.data, function(item) {
                            if (item.bigimg != "") {
                                if(item.content!=""){
                                    item.content = JSON.parse(item.content)
                                }
                                homeAcitiveList.push(item)
                            } else {
                                item.bigimg = "img/home01.png"
                                //item.content = JSON.parse(item.content)
                                //item.content[0].content= decodeURIComponent(item.content[0].content)
                                homeAcitiveList.push(item)
                            }
                        })
                        if (homeAcitiveList.length = result.data.length) {
                            $scope.homeAcitiveList = homeAcitiveList;

                            // $ionicSlideBoxDelegate.$getByHandle("homeAcitiveList").loop(true);
                            $scope.isData = true;

                            /*设置轮播原点样式和圆点切换*/
                            angular.forEach($scope.homeAcitiveList, function(item, index) {
                                item.isactivated = index == 0 ? true : false;
                            })
                            $scope.slideHasChanged = function(index) {
                                var _index = index;
                                if (_index == $scope.homeAcitiveList.length + 1) {
                                    _index = $scope.homeAcitiveList.length - 1;
                                } else if (_index == $scope.homeAcitiveList.length) {
                                    _index = 0;
                                }
                                angular.forEach($scope.homeAcitiveList, function(item, index) {
                                    if (_index == index) {
                                        switchactivity(item, index);
                                    }
                                })
                            }

                            $scope.switchactivity = switchactivity;
                            $ionicScrollDelegate.resize();
                            /*设置轮播原点样式和圆点切换结束*/
                        }

                    } else {
                        // Toast.show("没有更多数据了")
                        // console.log("没有更多数据了")
                    }
                    fixedSlideBug();
                    Movies.getHomeMovies(function(result) { //第二步：查询首页显示视频
                        $timeout(function() {
                            $scope.$broadcast($location.path(),{
                                    'scrollTop':0,
                                    'scrollLeft':0,
                                    'showbrainrepair':true
                                });//默认加载一次图片
                        }, 500);
                        noMoreItemsAvailabledown = false;
                        $scope.$broadcast('scroll.refreshComplete');
                        $ionicScrollDelegate.resize();
                        if (result.data && result.data.length > 0) {
                            if(!pushDown){
                                $scope.loadingStatus = MovieServe.getLoadingStatus(2);
                                $rootScope.$broadcast("loadingcall",{"isLoadingAgain":true,"isLoading":false})
                            }

                            for (var i = 0; i < result.data.length; i++) {
                                if (result.data[i].status == "1") { //new

                                    homeVideoListN.push(result.data[i]);
                                     $scope.mvInfro.homeVideoListN.loading=false;  //加载中的状态

                                } else if (result.data[i].status == "2") { //hot
                                    if (result.data[i].videoName == "天才眼镜狗") {
                                    }

                                    homeVideoListH.push(result.data[i]);
                                    $scope.mvInfro.homeVideoListH.loading=false;

                                } else { //past

                                    homeVideoListP.push(result.data[i]);
                                     $scope.mvInfro.homeVideoListP.loading=false;  //加载中的状态

                                }
                            }
                            $scope.mvInfro.homeVideoListN = MovieServe.filterInArray(homeVideoListN,3);
                            $scope.mvInfro.homeVideoListH = MovieServe.filterInArray(homeVideoListH,3);
                            $scope.mvInfro.homeVideoListP = MovieServe.filterInArray(homeVideoListP,3);
                            //第三步：查脑补
                            getHomeTheme(homeVideoListN, function(themeList) {
                                $scope.mvInfro.headThemeListN = themeList;
                            });
                            getHomeTheme(homeVideoListH, function(themeList) {
                                $scope.mvInfro.headThemeListH = themeList;
                            })
                            getHomeTheme(homeVideoListP, function(themeList) {
                                $scope.mvInfro.headThemeListP = themeList;
                            })
                            // debugger

                        } else {
                            if(!pushDown){
                                // $rootScope.$broadcast("loadingcall",{"isLoadingAgain":false,"isLoading":false})
                                $scope.loadingStatus = MovieServe.getLoadingStatus(3);
                            }
                           $scope.mvInfro.homeVideoListN.nodate=true;
                           $scope.mvInfro.homeVideoListH.nodate=true;
                           $scope.mvInfro.homeVideoListP.nodate=true;
                           $scope.mvInfro.homeVideoListN.loading=false;
                           $scope.mvInfro.homeVideoListH.loading=false;
                           $scope.mvInfro.homeVideoListP.loading=false;
                            // Toast.show("没有更多数据了")
                            // console.log("没有更多数据了")
                        }
                        //第三步：红包活动
                        Movies.getActiveList(1, starttime, endtime, 6, function(result) { //查询抢红包
                            $ionicScrollDelegate.resize();
                            // debugger
                            if (result.data) {
                                var activeId =result.data[0].activeId;//活动id
                                // debugger
                                Movies.getActivetyPlaytime(activeId,function(resulttime){//查询剩余抽奖次数
                                    if(resulttime.data!=0){
                                        $state.go('red-packet',{
                                            activeId:activeId
                                        });
                                    }else{
                                        // console.log("没有抽奖次数了")
                                    }
                                })
                            }else{
                                // console.log("no redactivity")
                            }
                        });
                    });
                });

            }
        }else if(versiontype == 1){
            if(!noMoreItemsAvailabledown){
                noMoreItemsAvailabledown = true;
                var homeAcitiveList = [];
                Movies.getActiveList(mark, starttime, endtime, type, function(result) { //第一步：查询首页显示活动视频
                    $ionicScrollDelegate.resize();
                    if (result.data && result.data.length > 0) {

                        angular.forEach(result.data, function(item) {
                            if (item.bigimg != "") {
                                if(item.content!=""){
                                    item.content = JSON.parse(item.content)
                                }
                                homeAcitiveList.push(item)
                            } else {
                                item.bigimg = "img/home01.png"
                                //item.content = JSON.parse(item.content)
                                //item.content[0].content= decodeURIComponent(item.content[0].content)
                                homeAcitiveList.push(item)
                            }
                        })
                        if (homeAcitiveList.length = result.data.length) {
                            $scope.homeAcitiveList = homeAcitiveList;

                            // $ionicSlideBoxDelegate.$getByHandle("homeAcitiveList").loop(true);
                            $scope.isData = true;

                            /*设置轮播原点样式和圆点切换*/
                            angular.forEach($scope.homeAcitiveList, function(item, index) {
                                item.isactivated = index == 0 ? true : false;
                            })
                            $scope.slideHasChanged = function(index) {
                                var _index = index;
                                if (_index == homeAcitiveList.length + 1) {
                                    _index = homeAcitiveList.length - 1;
                                } else if (_index == homeAcitiveList.length) {
                                    _index = 0;
                                }
                                angular.forEach($scope.homeAcitiveList, function(item, index) {
                                    if (_index == index) {
                                        switchactivity(item, index);
                                    }
                                })
                            }

                            var switchactivity = function(nowitem, nowindex) {
                                angular.forEach($scope.homeAcitiveList, function(item) {
                                    item.isactivated = false;
                                })
                                nowitem.isactivated = true;
                            }
                            $scope.switchactivity = switchactivity;
                            $ionicScrollDelegate.resize();
                            /*设置轮播原点样式和圆点切换结束*/
                        }

                    } else {
                        // Toast.show("没有更多数据了")
                        // console.log("没有更多数据了")
                    }
                    fixedSlideBug();
                });
                MovieServe.homeInfoInit(versionStatus,function(result){
                  if(result.success){
                    noMoreItemsAvailabledown = false;
                    if(versionStatus==2){
                      $scope.mvInfro = result;
                    }else if(versionStatus==1){
                      $scope.tvInfro = result;
                    }

                    $scope.$broadcast('scroll.refreshComplete');
                    $ionicScrollDelegate.resize();
                    if(!pushDown){
                        $rootScope.$broadcast("loadingcall",{"isLoadingAgain":true,"isLoading":false})
                        $scope.loadingStatus = MovieServe.getLoadingStatus(2);
                    }
                    $timeout(function(){
                      $scope.$broadcast($location.path(),{
                              'scrollTop':0,
                              'scrollLeft':0,
                              'showbrainrepair':true
                          });//默认加载一次图片
                    },500)

                  }else{
                    $scope.tvInfro = {};
                    $scope.tvInfro.goingLiveList = []//即将直播的节目
                    $scope.tvInfro.headThemeListN = []//脑补列表new
                    $scope.tvInfro.headThemeListP = []//脑补列表past
                    $scope.tvInfro.headThemeListH = []//脑补列表hot
                    $scope.tvInfro.homeVideoListN = []//new
                    $scope.tvInfro.homeVideoListP = []//past
                    $scope.tvInfro.homeVideoListH = []//hot
                    $scope.tvInfro.liveList = []//正在直播的节目
                    $scope.tvInfro.hotTvstationList = []//正在直播的节目
                    if(!pushDown){
                        // $rootScope.$broadcast("loadingcall",{"isLoadingAgain":true,"isLoading":false})
                        $scope.loadingStatus = MovieServe.getLoadingStatus(3);
                    }
                  }

                  // showmovieClickTime = true
                })
            }

        }
    }
    init(false,false,versionStatus);
    $scope.init = init;
    $scope.loadAgainInfro = function(pushDown,isByClick,versiontype){
      noMoreItemsAvailabledown = false;//控制下拉刷新
      init(pushDown,isByClick,versiontype);
    }
    $scope.$on("loadAgainInfro",function(e,data){
      noMoreItemsAvailabledown = false;//控制下拉刷新
      init(false,true,versionStatus);
    })

    $scope.$on( "$ionicView.enter", function( scopes, states ) {
      if(states.fromCache){
        $timeout(function(){
          $scope.$broadcast($location.path(),{
                  'scrollTop':0,
                  'scrollLeft':0,
                  'showbrainrepair':true
              });//默认加载一次图片
        },500)
      }
    });
    // var resizeslidebox=document.getElementById('resizeslidebox');
    // resizeslidebox.style.resize=357'';
})