/**
 *电影相关操作
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
/**
 * 电影列表相关
 */
.controller('MovieMoreCtrl', function($scope,$state,$stateParams,$ionicScrollDelegate,$timeout,$ionicLoading,Movies,Toast,ImageSvc,MovieServe,$location) {

    //这里给页面提供图片显示大小的数据
    //首页默认放置3.5张图片，每张图片的比例为3:4
    ImageSvc.calcItem($scope,3,3/4,0);
    //页面上可以直接访问itemWidth,itemHeight 属性

  var noMoreData = false;
  var isLoading = false;
  var index = 0;
  var listcolumn = 3; //排列每行个数
  $scope.moreMovies = []; //页面显示
  $scope.scrollimmediate = false;
  var currentPageNo = 1; //当前的页码
  var area = 0; //查询电影列表参数
  var type = 0; //查询电影列表参数
  var year = 0; //查询电影列表参数
  var status = $stateParams.id; //默认样式
  var versiontype = parseInt($stateParams.versiontype);
  $scope.fixedshowstyle; //导航条样式参数
  $scope.fixeddefaultstyle; //导航条样式参数
  $scope.fixedheightstyle; //导航条样式参数
  $scope.fixednavonestyle; //导航条样式参数
  $scope.fixedhasheaderstyle; //导航条样式参数

  $scope.oneshowstyle; //导航条样式参数
  $scope.onedefaultstyle; //导航条样式参数
  $scope.oneheightstyle; //导航条样式参数
  $scope.onenavonestyle; //导航条样式参数
  $scope.onehasheaderstyle; //导航条样式参数
  $scope.onestatus = $stateParams.id; //查询电影列表参数
  $scope.onscrollMessage = "nav"+$stateParams.textname;
  $scope.isCinema = true;
  $scope.isHotNew = false;
  $scope.noMoreItemsAvailable = false;
  var sendParameter = {};
  //  var movieClassLabel = [[
  //     {"labelname":"全部","statusid":"0"},
  //     {"labelname":"即将上映","statusid":"1"},
  //     {"labelname":"正在热映","statusid":"2"},
  //     {"labelname":"历史热映","statusid":"3"},
  // ],[
  //     {"labelname":"全部","areaid":"0"},
  //     {"labelname":"内地","areaid":"1"},
  //     {"labelname":"港台","areaid":"2"},
  //     {"labelname":"日韩","areaid":"3"},
  //     {"labelname":"欧美","areaid":"4"},
  //     {"labelname":"其他","areaid":"5"}
  // ],[
  //     {"labelname":"全部","typeid":"0"},
  //     {"labelname":"爱情","typeid":"1"},
  //     {"labelname":"战争","typeid":"2"},
  //     {"labelname":"喜剧","typeid":"3"},
  //     {"labelname":"科幻","typeid":"4"},
  //     {"labelname":"恐怖","typeid":"5"},
  //     {"labelname":"动画","typeid":"6"}
  // ],[
  //     {"labelname":"全部","yearid":"0"},
  //     {"labelname":"2015","yearid":"2015"},
  //     {"labelname":"2014","yearid":"2014"},
  //     {"labelname":"2013","yearid":"2013"},
  //     {"labelname":"2012","yearid":"2012"},
  //     {"labelname":"2011","yearid":"2011"},
  //     {"labelname":"2010","yearid":"2010"}
  // ]]
  var movieClassLabel = [];
  MovieServe.getMoreList(versiontype,function(result){
    angular.forEach(result,function(item,index){
      movieClassLabel.push(item.classificationList);
      sendParameter[item.classificationName] = 0;
      if(item.classificationName == "status"){
        sendParameter[item.classificationName] = $stateParams.id; //设置默认跳入的请求参数
      }
    });
    sendParameter.currentPageNo = 1;
    getList(false);
    // debugger
    $scope.movieClassLabel=movieClassLabel;
     /*设置菜单栏样式*/
     angular.forEach($scope.movieClassLabel,function(items,_index){
       angular.forEach(items,function(item,index){
              item.activated=index==0?true:false;
        })
       items.index=_index;
    });
    /*设置逃入页面电影状态筛选的默认样式*/
     angular.forEach($scope.movieClassLabel[0],function(items,itIndex){
        if(itIndex==status){
          items.activated=true;
          var movienavtitle=items.labelname;
          $scope.movienavtitle=movienavtitle;
        }else{
          items.activated=false;
        }
        if(itIndex==1&&status==1||itIndex==2&&status==2){
          if(itIndex==1&&status==1){
            $scope.isHotNew =false;
          }else{
            $scope.isHotNew = true;
          }
          $scope.fixeddefaultstyle = true;
        }else{
        }
     });
  })

  $scope.isScroll = "false"
     //导航栏的收缩与展开
  var movienavfixed=document.getElementById('movie-nav-fixed');
  var movienav=document.getElementById('movie-nav');
  var movienavone=document.getElementById('movie-nav-one');
  // movienavfixed.style.display='none';
  // movienavone.style.display='none';
  var lastvalue = new Date();
  function scrollToTop() {
    var position=$ionicScrollDelegate.getScrollPosition();
    var scrollTop=position.top;
    var scrollLeft=position.left;
    $scope.$broadcast($location.path(),{
            'scrollTop':scrollTop,
            'scrollLeft':scrollLeft,
            'showbrainrepair':true
        });//默认加载一次图片
     var scrollHeight=scrollTop;
     var navHeight=document.getElementById('movie').offsetTop;
     var currentvalue = new Date();
     var sl = parseInt(currentvalue - lastvalue);
     // if(sl>300){
       if(scrollHeight>navHeight){
            $scope.$broadcast($scope.onscrollMessage,{"status":true})

       }else{
             $scope.$broadcast($scope.onscrollMessage,{"status":false})
       }
       lastvalue = currentvalue;
     // }

  };

  $scope.scrollToTop=scrollToTop;
  $scope.gomoviesence=function(){
       $state.go('movie-scene');
  }
  //控制页面每行显示视频个数
  var filterData = function(data, column) {
          var tempData = [];
          for (var i = 0; i < data.length; i++) {
              var index = parseInt(i / column);
              if (i % column == 0) {
                  tempData[index] = [];
              }
              var temp = data[i];
              temp.SplashImg = ""
              //做一个转换操作
              tempData[index].push(temp);
          }
          return tempData;
      }

  //获取$scope.moreMovie中的每个item；
  function getItem() {
   if (index == $scope.moreMovies.length*listcolumn) {
     return null;
   }
   var firstIndex = parseInt(index/listcolumn);
   var secondIndex = index%listcolumn;
   if ($scope.moreMovies[firstIndex][secondIndex] == undefined){
     return null;
   }
   var item = $scope.moreMovies[firstIndex][secondIndex];
   index++;
   return item;
  }
  //延迟加载，将item.content.SplashImg设置真实路径
  function loadImg(item) {
      if (item != null) {
          var realurl = item.img;
          var img = new Image();
          realurl = ImageSvc.getVideoPoster(realurl)
          img.src = realurl;
          img.onload = function() {
              item.SplashImg = realurl;
              $timeout(function() {
                  loadImg(getItem());
              }, 10);
          }
          img.onerror = function(){
              $timeout(function() {
                  loadImg(getItem());
              }, 10);
          }
      }
  }

  function getList(isByClick) {
      if (!noMoreData && !isLoading) {
         isLoading = true;
          Movies.getMoviesList(sendParameter,function(result){ //查询视频列表
              if (result.data && result.data.videoList.length > 0) {
                  if($scope.moreMovies.length>0){
                  var calc = listcolumn-$scope.moreMovies[$scope.moreMovies.length-1].length;
                  if(calc>0){
                      for(var i = 0;i < calc;i++){
                          $scope.moreMovies[$scope.moreMovies.length-1].push(result.data.videoList.shift());
                      }
                  }}
                  var temp = filterData(result.data.videoList,listcolumn);
                  if(isByClick){
                    $scope.moreMovies = temp;
                  }else if(!isByClick){
                    $scope.moreMovies = $scope.moreMovies.concat(temp);
                  }

                  loadImg(getItem());//延迟加载

                  noMoreData = false;
                  $scope.isMoreData = false;

              } else{
                  noMoreData = true;
                  // Toast.show("没有更多数据了");
                  $scope.isMoreData = true;//控制更多数据显示影藏
                  $scope.noMoreItemsAvailable = true;
              }
              currentPageNo++;
              sendParameter.currentPageNo++
              isLoading = false;
              $ionicScrollDelegate.resize();
              if (!$scope.$$phase) {
                  $scope.$apply();
              }
              $scope.$broadcast('scroll.infiniteScrollComplete');
          })
      }else{
          console.log("加载完成");
          noMoreData = false;
          isLoading = false;

          $scope.$broadcast('scroll.infiniteScrollComplete');
      }
  }
  $scope.loadMore = function() {
     getList(false);
  }


  //页面点击调用查询电影分类函数
  $scope.fiterMovies = function(e,itemIndex,_index,classitem){
    // debugger
    sendParameter[classitem[_index][itemIndex].classificationName] = classitem[_index][itemIndex].labelId
    $scope.scrollimmediate = false;
    var movienavtitle=e.target.innerHTML;
      $scope.movienavtitle=movienavtitle;
      currentPageNo = 1;
      sendParameter.currentPageNo = 1
      $scope.moreMovies = [];
      index = 0;
      $scope.noMoreItemsAvailable = false;
      noMoreData = false;
      isLoading = false;
      getList(true);

      angular.forEach($scope.movieClassLabel[_index],function(items,itIndex){
        if(itIndex==itemIndex){
          items.activated=true;
        }else{
          items.activated=false;
        }
        /*只有全部和历史热播需要菜单栏筛选*/
        if(_index==0){
                      if(itemIndex==1||itemIndex==2){
                          if(itemIndex==1){
                            $scope.isHotNew =false;
                          }else{
                            $scope.isHotNew = true;
                          }
                          $scope.fixeddefaultstyle = true;
                          $scope.fixedheightstyle = false;
                          // movienavfixed.style.height='32'+'px';
                          // movienavfixed.style.overflow='hidden';
                          // movienav.style.height='32'+'px';
                          // movienav.style.overflow='hidden';

                      }else {
                          $scope.fixedheightstyle = true;
                          $scope.fixeddefaultstyle = false;
                          // movienavfixed.style.height='138'+'px';
                          // movienavfixed.style.overflow='show';
                          // movienav.style.height='138'+'px';
                          // movienav.style.overflow='show';
                          $scope.isHotNew = false;
                      }
                    }
      });

  }
  //打开电影详情页面
  $scope.openDetail = function(movieitem){
      var id = movieitem.videoId;
      $state.go('movie-'+'detail', {
          id: id
      });
  }

})