/**
 * 娱乐列表相关操作、包含娱乐的搜索、筛选
 * @param  {[type]}
 * @return {[type]}
 */
rootModule
/**
 * 娱乐列表相关
 */
.controller('PlayingCtrl', function($scope, Toast, $rootScope, PlaySvc, $ionicLoading, $location, $state, $timeout, User) {
    /**
     * 筛选类型{全部、配音、配词}
     * @type {[type]}
     */
     /*跳转到成果管理页面*/
     /*乐配导航栏*/
     var PlayNavList=[
        {"playtitle":"配音","typeid":"1"},
        {"playtitle":"配词","typeid":"3"},
        {"playtitle":"配图","typeid":"2"},
        ];
    $scope.playList = [];
    $scope.PlayNavList=PlayNavList;
    angular.forEach(PlayNavList,function(item,index){
        item.activated=index==0?true:false;
    });



    $scope.SwitchPlayNav=function (e,nowPlayItem,index){
        if(nowPlayItem.activated){

        }else{
        angular.forEach($scope.PlayNavList,function(item){
            item.activated=false;
         })
        nowPlayItem.activated=true;
        }
        if(e.currentTarget.attributes.typeid.value != ""){
           currentTypeId  = e.currentTarget.attributes.typeid.value;
        }else{
            //不改变参数
        }
        currentPageNo = 1;
        $scope.noData = false;
        $scope.noMoreData = false;
        getList(true);
    }

    $scope.OnClick=function(){
        $state.go('result-management');
    }
    $scope.filterTypes = PlaySvc.getFilterTypes();
    //列表
    $scope.playList = [];
    var currentTypeId = 1; //当前筛选的类型
    var currentPageNo = 1; //当前的页码
    /**
     * 用于添加数据
     * @param {[type]} arry [description]
     */
    var filterData = function(data, column) {
        var tempData = [];
        for (var i = 0; i < data.length; i++) {
            var index = parseInt(i / column);
            if (i % column == 0) {
                tempData[index] = [];
            }
            var temp = data[i];
            switchDesign(temp);
            tempData[index].push(temp);
        }
        return tempData;
    }
    var switchDesign = function(temp) {
            //做一个转换操作
            switch (temp.recreationType) {
                case "1":
                    temp.recreationTypeText = "video";
                    break;
                case "2":
                    temp.recreationTypeText = "head";
                    break;
                case "3":
                    temp.recreationTypeText = "text";
                    break;
            }
            try {
                temp.content = JSON.parse(temp.content);
                //temp.content.videoSplashImg = "http://192.168.8.105/download/videoSplash.png"
                temp.content.SplashImg = "img/black.png"
                //设置默认图片，延迟加载
            } catch (e) {
                console.log(e);
            }
        }
        /**
         * 筛选娱乐内容
         * @return {[type]} [description]
         */
    $scope.filterTypeEvent = function(typeId) {
        $scope.playList = [];
        currentTypeId = typeId;
        currentPageNo = 1;
        getList();
    }
    $scope.noMoreData = false;
    $scope.noDatav = false;
    $scope.noDatah = false;
    $scope.noDatat = false;
    var isLoading = false;
    var index = 0;
    var listcolumn = 2;

    function lazyloadimg(list){
        var templist = list;
        var index = 0;
        function getItem() {
            if (index == templist.length * listcolumn) {
                return null;
            }
            var firstIndex = parseInt(index / listcolumn);
            var secondIndex = index % listcolumn;
            if (templist[firstIndex][secondIndex] == undefined) {
                return null;
            }
            var item = templist[firstIndex][secondIndex];
            index++;
            return item;
        }
        //延迟加载，将item.content.SplashImg设置真实路径
        function loadImg(item) {
            if (item != null) {
                var img = new Image();
                var url;
                switch (item.recreationType) {
                    case "1":
                        url = item.content.videoSplashImg;
                        break;
                    case "2":
                        break;
                    case "3":
                        url = item.content.resImgSrc;
                        break;
                }
                img.src = url;
                img.onload = function() {
                    item.content.loaded = true; //控制img的css属性

                    item.content.SplashImg = url;
                    $timeout(function() {
                        loadImg(getItem());
                    }, 10);
                };
                //错误处理
                img.onerror = function(){
                    $timeout(function() {
                        loadImg(getItem());
                    }, 10);
                }
            }
        }
        loadImg(getItem());
    }
    //延迟加载
    function getList(needTemp) {
        if (!$scope.noMoreData && !isLoading) {
            isLoading = true;
            //这里要根据视频ID来查询
            var videoId = JSON.parse(DataInterface.getString()).programid;
            // var videoId = 289;
            PlaySvc.getList(videoId, currentTypeId, -1, 2, currentPageNo, 4, function(result) {
                if (needTemp) { //需要清空
                    $scope.playList = [];
                }
                if (result.data && result.data.resultList && result.data.resultList.length > 0) {
                    if ($scope.playList.length > 0) {
                        var calc = listcolumn - $scope.playList[$scope.playList.length - 1].length;
                        if (calc > 0) {
                            for (var i = 0; i < calc; i++) {
                                switchDesign(result.data.resultList[0]);
                                $scope.playList[$scope.playList.length - 1].push(result.data.resultList.shift());
                            }
                        }
                    }
                    var temp = filterData(result.data.resultList, listcolumn);
                    $scope.playList = $scope.playList.concat(temp);
                    lazyloadimg($scope.playList); //延迟加载
                    $scope.noMoreData = false;
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                } else {
                    //没有更多数据了
                    $scope.noMoreData = true;
                    Toast.show('没有更多数据了');
                }
                if (currentPageNo == 1 && $scope.playList.length == 0 ) { //如果配音第一页都没有数据，则认为无数据
                    $scope.noData = true;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                $scope.$broadcast('scroll.refreshComplete');
                currentPageNo++;
                isLoading = false;
                if (!$scope.$$phase) {
                    $scope.$apply();
                }
            });
        } else {
            $scope.$broadcast('scroll.infiniteScrollComplete');
            $scope.$broadcast('scroll.refreshComplete');
        }
    }
    /**
     * 上拉加载更多
     * @return {[type]} [description]
     */
    $scope.loadMore = function() {
        getList();
    }

    // $rootScope.shoudHideTab = true;
    //打开详情页marktest
    $scope.openDetails = function(id, text) {
        //电信插件使用的配置
       /* if (window.plugins && typeof window.plugins.webintent != 'undefined') {
            window.plugins.webintent.startActivity({
                    action: "com.handsight.tvhelper.PopoutActivity",
                    extras: {
                        url: "/play/" + text + "/detail/" + id
                    }
                },
                function() {},
                function() {}
            );
        } else {
            $state.go('play-' + text + '-details', {
                id: id
            });
        }*/
        // 独立APP使用下面的配置，网页调试也使用下面的配置
         $state.go('play-' + text + '-details', {
             id: id
         });
    }
    /**
     * 下拉刷新功能
     * @return {[type]} [description]
     */
    $scope.doRefresh = function() {
        currentPageNo = 1;
        index = 0;
        $scope.noMoreData = false;
        getList(true);
    }
    /**
     * 加载娱乐素材列表
     * @return {[type]} [description]
     */
    function loadDisportDataList() {
        var videoId = JSON.parse(DataInterface.getString()).programid;
        PlaySvc.getDisportDataList(videoId, 0, function(result) {
            console.log(result);
        })
    }
    //主动加载一次数据
    getList();
    //这里仅用作测试视频是否可以播放用
    //loadDisportDataList();
})