/**
 * @description 活动相关Controller
 * @author SuperK
 * @date 2015-04-02
 */
rootModule
.controller('RedPacketCtrl', function($scope,User, $stateParams,$ionicLoading,$state, Active,Movies,$timeout,$ionicSlideBoxDelegate,$ionicPopup,$rootScope) {
    var screenwidth = window.innerWidth;
    var screenheidth = window.innerHeight;
    var redpacketbg = document.getElementById('redpacketopen');
        redpacketbg.style.width = screenwidth + 'px';
        redpacketbg.style.height = screenheidth -44 + 'px';
    var activeId = $stateParams.activeId;
    var serialId;
    var rewards=[];
    var isRewards = false;//中奖状态
    $scope.activeResult = {};//中奖结果；
    $scope.rewarduser = {};//中奖结果；
    // console.log($scope.activeResult)
    Movies.getRedPacket(activeId,function(result){//查询抢红包活动的详情
        // debugger
        if(result.data){
            result.data.content = JSON.parse(result.data.content)
            result.data.content[0].content = decodeURIComponent(result.data.content[0].content);
            if(result.data.content[0].content!=""){
              var deschtml = angular.element(result.data.content[0].content);
            }

            // $scope.activeIntroduce = '';
            //   for(var i=0;i<deschtml.length; i++){
            //   $scope.activeIntroduce +=  deschtml[i].innerText;//活动详情内容复制给页面
            // }
            $scope.activeIntroduce = result.data.content[0].content;
            rewards = result.data.rewards//奖品信息列表
        }
    })
    $scope.gobackhome = function(){
        $state.go('tab.home');
    }
     $scope.showenterredpacketpage = true;   //第一个抢红包活动页面显示
     $scope.showredpacketpage = false;       //第二个抢红包活动页面隐藏
     //进入抢红包页面
     $scope.enterredpacketpage = function(){
         if($rootScope.globalUserIsLogin){//判断用户登录没有
            Movies.getRedPacketResult(activeId,function(result){//查询抽奖结果
                // debugger
                // console.log(result.data.rewardsId)
                if(result.data){
                    angular.forEach(rewards,function(item){
                        if(item.rewardId==result.data.rewardsId){
                            serialId = result.data.serialId;
                            $scope.activeResult = {
                                "result": item.rewardName,//奖品信息
                                "isRewards":true
                            }
                            isRewards = true;
                        }
                    })
                }else{
                    console.log("没查到数据")
                }
                if(!isRewards){
                    $scope.activeResult = {
                        "result": "抱歉未中奖!",//奖品信息
                        "isRewards":false
                    }
                }
                $scope.showenterredpacketpage = false ;
                $scope.showredpacketpage = true;
                $scope.showopenredpacketpage = true;
                var H_redpacketbgone = document.getElementById('H_redpacketbgone');
                    H_redpacketbgone.style.height = (screenwidth-104) / 0.62 + 'px';
            });
        }else{
            $state.go('login');//跳转登录页面
        }


     }
     //进入获得红包页面
     $scope.entergetredpacketpage = function(){
         $scope.showenterredpacketpage = false ;
         $scope.showredpacketpage = true;
         $scope.showopenredpacketpage = false;
         $scope.showgetredpacketpage = true;
     }
     //进入填写号码页面
      $scope.enterinputtelephonepage = function(){
        if(isRewards){
            $scope.showenterredpacketpage = false ;
            $scope.showredpacketpage = true;
            $scope.showopenredpacketpage = false;
            $scope.showgetredpacketpage = false;
            $scope.showinputtelephonepage = true;
        }else{
            $state.go('tab.home');
        }
     }
     //进入完成领奖页面
     $scope.enterfinishpage = function(){
        var pattern = /[^0-9]/g;
        if(pattern.test($scope.rewarduser.telephone) || $scope.rewarduser.telephone[0] != "1" || $scope.rewarduser.telephone.length != 11){
            //"电话号码格式错误！"
            $ionicPopup.alert({
                title: '系统提示',
                template: '电话号码格式错误！'
            });
            return;
        }else{
            if(User.getCurrentUser().nickName!=""&&User.getCurrentUser().nickName!=null){
                var username = User.getCurrentUser().nickName;
            }else{
                var username = "默认"
            }

            mailCode = "123456";
            addr = "默认";
            tel = $scope.rewarduser.telephone;
            //上传幸运用户信息
            // console.log(serialId)
            Movies.sendRedpacketUserInfro(activeId,serialId,username,tel,mailCode,addr,function(result){
                // debugger
                $scope.uploadInfro= result.data
            })
            $scope.showenterredpacketpage = false ;
            $scope.showredpacketpage = true;
            $scope.showopenredpacketpage = false;
            $scope.showgetredpacketpage = false;
            $scope.showinputtelephonepage = false;
            $scope.showfinishpage = true;
        }

     }

     //活动介绍弹出框
     $scope.popbox =function (){
        $scope.showpopbox = true;
        var popbox = document.getElementById('Popbox');
            popbox.style.height = screenheidth-44 + 'px';
             // var  introduce= document.getElementById('H_redpacket-introduce');
             //      introduce.style.height = (screenwidth-104) /1.6 + 'px';

     }
     //关闭活动弹出页面
     $scope.closepopbox = function (){
        $scope.showpopbox = false;
     }
})