'use strict';
/**
 * @description 电视终端相关功能Controller
 * @author SuperK
 * @date 2015-04-02
 */
rootModule
    .controller('TVCtrl', function ($ionicPlatform,MovieServe,Toast,$ionicHistory,$scope, ENV, Movies,$location, $ionicPopup, TV, User, barCodeScannerUtil, $ionicLoading, $rootScope, $state, $ionicScrollDelegate, photoService, uploadImg, dateTime) {
        //查询电影场景连接
        //隐藏TV连接
        document.getElementById("lianjies").style.display="none";

        $scope.senceList =[];
        $scope.isLoading=true;
        var sceneIds=[];
        var SessionAllList = [];
        var SceneMovieList= [];
        // Movies.getSenceInfroList(0,function(result){
        //     $scope.senceList = result;
        //     //引导图的显示隐藏
        //     var senceList = result;
        //     if(senceList && senceList.length > 0){
        //           $scope.isShowGuideImg = false;
        //     }else{
        //          document.getElementById("movie-scense").style.display="none";
        //          document.getElementById("yindaotu").style.display="block";
        //          $scope.isShowGuideImg = true;

        //     }

        //     $ionicLoading.hide()
        // })

        $rootScope.$on("addnewsence",function(e,data){
            $scope.isShowGuideImg = false;
            document.getElementById("movie-scense").style.display="block";
            // $scope.senceList = data.data;
            // debugger
            if(data.programList){
                $scope.senceList = data.movieSenceList;
                $scope.programList = data.programList;
            }else{
                $scope.programList = [];
                $scope.senceList = data.movieSenceList;
            }

            // console.log($scope.senceList)

        })
        $rootScope.$on("onChangeStatus",function(e,data){
            doRefreshtv();
            // debugger
        })
        var noMoreItemsAvailabledown = false;
        var doRefreshtv = function(){
            if(!noMoreItemsAvailabledown){
                noMoreItemsAvailabledown = true;
                Movies.getSenceInfroList(0,function(result){
                    $scope.senceList = result.movieSenceList;
                    // debugger
                    if(result.programList){
                        $scope.programList = result.programList;
                        var programList = result.programList;
                    }else{
                        $scope.programList = [];
                        var programList = [];
                    }

                    //引导图的显示隐藏
                    var senceList = result.movieSenceList;

                    if(senceList.length > 0 || programList.length > 0){
                          $scope.isShowGuideImg = false;
                    }else{
                         document.getElementById("movie-scense").style.display="none";
                         document.getElementById("yindaotu").style.display="block";
                         $scope.isShowGuideImg = true;

                    }
                    $scope.noMoreItemsAvailabledown = true;
                    noMoreItemsAvailabledown = false;
                    $scope.$broadcast('scroll.refreshComplete');
                    $ionicScrollDelegate.resize();
                    $scope.isLoading=false;
                })
            }

        }
        $scope.doRefreshtv = doRefreshtv;
        doRefreshtv();
        var openComment = function(moviename,videoIdSide,startedTime,movieLength,startTime){
            $state.go('platform-side', {
                videoId:videoIdSide,  //跳转传入一个视频ID
                tvhelper:"tvhelper",
                startedTime:startedTime,
                movieLength:movieLength,
                moviename:encodeURIComponent(moviename),
                startTime:startTime,
                isSystemCountdown:true

            });
        }
        //选择一个场次，跳入合适的页面
        function selectAscence(scene){
            if(scene.videoType == 2){
                var currentD = new Date();
                var startedTime = parseInt((currentD - scene.startT)/1000);
                var movieLength = parseInt((scene.endT - scene.startT)/1000);
                var videoIdSide = scene.videoId;
                var moviename = scene.movieName;
                if(scene.showstatus==1){  //电影未开始播放
                  var id = scene.videoId; //电影视频ID
                  var beforetime = (scene.startT - currentD)
                  if(beforetime<86400000){
                    if(beforetime<3600000){
                        if(beforetime<60000){
                            var sendtime = parseInt(second/1000) + "秒"
                        }else{
                            var minute = parseInt(beforetime/60000);
                            var second = beforetime%60000;
                            var  seconds = parseInt(second/1000)
                            var sendtime = minute+"分"+seconds+"秒"
                        }
                    }else{
                        var sendtime = parseInt(beforetime/3600000) + "小时"
                    }
                  }else{
                    var sendtime = parseInt(beforetime/86400000) + "天"
                  }
                  $state.go('movie-'+'detail', {
                      id: id,
                      // realtime:sendtime,
                      endtime:scene.startT,
                      movieLength:movieLength,
                      isTv:true,
                      isSystemCountdown:true,
                      sceneId:scene.sceneId,
                  });
                }else{ //电影正在播放 或播放后 跳入一个页面
                  // var movieLength = endT - showT;
                  openComment(moviename,videoIdSide,startedTime,movieLength,scene.startT)
                }
            }else if(scene.videoType == 1){
                if(scene.showstatus == 2){
                    var movieLength = parseInt((scene.endT - scene.startT)/1000);
                    openComment(scene.vName,scene.vid,"",movieLength,scene.starttime)
                }else if(scene.showstatus == 1){
                    var leftTime = MovieServe.getLeftTime(scene.startT);//获取剩下的时间
                    if(leftTime.isNotShow){
                      // 电视节目预约连接，type = 5，电视节目
                      if(leftTime.isNotShow){
                        var hours = leftTime.day*24+leftTime.hour
                        var promptWords = '距离电视开始:还有'+hours+'小时'+leftTime.minute+'分';
                      }else{
                        var promptWords = "已经开始了，快去互动吧！";
                      }
                      //预约弹出框
                      var programpredictone = $ionicPopup.alert({
                          title: promptWords,
                          scope: $scope
                      });
                    }
                }
            }

        }
        $scope.selectAscence = selectAscence;

        $scope.ownerDevices = []; //我家里的电视终端
        $scope.friendDevices = []; //朋友家里的电视终端
        $scope.friendUserInfo = [];//朋友的个人信息
        // $scope.isShowGuideImg = false;//设置是否显示引导图片
        function loadDevices() {
            TV.get_devices().$promise.then(function (data) {
                /*处理返回的数据*/
                if (data.success) {

                    if (data.data && data.data.length> 0) {
                        if(document.getElementById("lianjies")){
                            document.getElementById("lianjies").style.display="";
                        }
                        if(document.getElementById("yindaotu")){
                            document.getElementById("yindaotu").style.display="none";
                        }

                        $scope.ownerDevices = []; //我家里的电视终端
                        $scope.friendDevices = []; //朋友家里的电视终端
                        $scope.isShowGuideImg = false;//隐藏引导图

                        //分组
                        angular.forEach(data.data, function (device) {
                            device.deviceId = parseInt(device.deviceId);
                            if (device.dstatus == 1) {//显示绑定状态的设备
                                if (device.isOwner == 1) { //自己家
                                    $scope.ownerDevices.unshift(device);
                                } else if (device.isOwner == 0) { //朋友家
                                    $scope.friendDevices.unshift(device);
                                }
                            }
                        });

                        //获取自己家设备信息
                        angular.forEach($scope.ownerDevices, function (device) {
                            TV.get_device_info(device.deviceId).$promise.then(function (data) {
                                if (data.success) {
                                    device.users = [];
                                    device.users = data.data.users;
                                } else {
                                    device.users = [];
                                    console.log("获取终端详情失败!");
                                }
                            });
                        });
                        //获取朋友家设备信息
                        angular.forEach($scope.friendDevices, function (device) {
                            TV.get_device_userInfo({deviceId: device.deviceId}).$promise.then(function (data) {
                                if (data.success) {
                                    device.owner = [];
                                    device.owner = data.data;
                                } else {
                                    device.owner = [];
                                    console.log("获取用户信息失败!");
                                }
                            });
                        });
                    } else {
                        // if(document.getElementById("lianjies")){
                        //     document.getElementById("lianjies").style.display="none";
                        // }
                        // if(document.getElementById("yindaotu")){
                        //     document.getElementById("yindaotu").style.display="inline-block";
                        // }
                        // $scope.isShowGuideImg = true;//用户没有添加设备，显示引导图
                    }
                    // $ionicLoading.hide();
                } else if (!data.success) {
                    $scope.isLoading=false;
                    // $scope.isShowGuideImg =false;
                    //  document.getElementById("tv-scense").style.display='none';
                } else {
                    Toast.show('获取终端列表失败')
                    $scope.isLoading=false;
                    // $ionicLoading.show({
                    //     template: '',
                    //     noBackdrop: true,
                    //     duration: 1000
                    // });
                    console.log("获取终端列表失败!");
                    // $scope.isShowGuideImg =false;
                }

            });
        }

        $scope.reload_devices = function () {
            $ionicLoading.show();
            $ionicScrollDelegate.resize();
            loadDevices();
        };
        loadDevices();
        $rootScope.$on('reload_devices', function (event, args) {
            loadDevices();
        });
        //根据id刷新box状态isOpen
        function loadState(device_id) {
            TV.get_device_info(device_id).$promise.then(function (data) {
                if (data.success) {
                    if (data.data.isOwner == '1') {
                        angular.forEach($scope.ownerDevices, function (item) {
                            if (parseInt(data.data.deviceId) == item.deviceId) {
                                item.isOpen = data.data.isOpen;
                            }
                        })
                    } else if (data.data.isOwner == '0') {
                        angular.forEach($scope.friendDevices, function (item) {
                            if (parseInt(data.data.deviceId) == item.deviceId) {
                                item.isOpen = data.data.isOpen;
                            }
                        })
                    }
                }
            })
        }

        // loadState(device_id);
        // $rootScope.$on('reload_state',function(event,args){
        //     loadState(device_id);
        // })
        $scope.shareToFriend = function (device_id) {
            $ionicLoading.show();
                    //新版本
                    var img_src = ENV.api + "/interface/zzqj/get_device_img?deviceId="+device_id+"";
                    if(img_src){
                        $ionicLoading.hide();
                        var myPopup = $ionicPopup.show({
                            title: '朋友扫描二维码即可完成连接',
                            cssClass: "dialog-theme",
                            // template: '<img class="qr-img" src="' + data.data + '">',
                            template: '<img class="qr-img" src="' + img_src + '">',
                            scope: $scope,
                            buttons: [
                                {
                                    text: '关闭'
                                }
                            ]
                        });
                    }else{
                        $ionicLoading.hide();
                        $ionicLoading.show({
                            template: '获取二维码失败',
                            noBackdrop: true,
                            duration: 1000
                        });
                    }
                    //旧版本
                //     TV.get_qrcode_img(device_id).$promise.then(function(data) {
                //     if (data.success) {
                //         $ionicLoading.hide();
                //         var myPopup = $ionicPopup.show({
                //             title: '朋友扫描二维码即可完成连接',
                //             template: '<img class="qr-img" src="' + data.data + '">',
                //             scope: $scope,
                //             buttons: [{
                //                 text: '关闭'
                //             }]
                //         });
                //     } else {
                //         $ionicLoading.hide();
                //         $ionicLoading.show({
                //             template: '获取二维码失败',
                //             noBackdrop: true,
                //             duration: 1000
                //         });
                //     }
            //旧版本
            //     TV.get_qrcode_img(device_id).$promise.then(function(data) {
            //     if (data.success) {
            //         $ionicLoading.hide();
            //         var myPopup = $ionicPopup.show({
            //             title: '朋友扫描二维码即可完成连接',
            //             template: '<img class="qr-img" src="' + data.data + '">',
            //             scope: $scope,
            //             buttons: [{
            //                 text: '关闭'
            //             }]
            //         });
            //     } else {
            //         $ionicLoading.hide();
            //         $ionicLoading.show({
            //             template: '获取二维码失败',
            //             noBackdrop: true,
            //             duration: 1000
            //         });
            //     }

            event.stopPropagation();
            // return false;
        }
        /**
         * 打开三边信息页面
         * @param  {[type]} device_id [description]
         * @return {[type]}           [description]
         */
        $scope.openSide = function (device_id, isOpen) {
            if (isOpen == 2) {
                $ionicLoading.show({
                    template: '设备未开机',
                    noBackdrop: true,
                    duration: 1000
                });
                loadState(device_id);
                return;
            } else if (isOpen == 1) {
                $rootScope.$broadcast('init_side');
                $location.path('side/tv/' + device_id);
            }

        }


        $scope.settingNickName = function (index) {
            $scope.device = {};
            var settingPopup = $ionicPopup.show({
                title: '设置终端别名',
                template: '<label class="item item-input">' +
                '<input type="text" ng-model="device.nickname" placeholder="填写一个终端别名">' +
                '</label>',
                scope: $scope,
                buttons: [
                    {
                        text: '设置',
                        type: 'button-positive',
                        onTap: function (e) {
                            if (!$scope.device.nickname) {
                                e.preventDefault();
                                $ionicLoading.show({
                                    template: '请输入别名',
                                    noBackdrop: true,
                                    duration: 1000
                                });
                            } else {
                                TV.set_device_name({
                                    deviceId: $scope.ownerDevices[index].deviceId,
                                    dname: $scope.device.nickname
                                }).$promise.then(function (data) {
                                        if (data.success) {
                                            $scope.ownerDevices[index].dname = $scope.device.nickname;
                                        } else {
                                            e.preventDefault();
                                        }
                                    });
                            }
                        }
                    },
                    {
                        text: '关闭'
                    }
                ]
            });
            event.stopPropagation();
            return false;
        }
        var moviescene = function(scenceitem){
            if(scenceitem.videoType == 2){//电影
                    var sceneId = scenceitem.sceneId;
                    angular.forEach($scope.senceList,function(data,index){

                        if(data.sceneId==sceneId){
                            // console.log(data.sceneId)
                            // console.log(index)
                            $scope.senceList.splice(index,1)
                            if($scope.programList.length==0 && $scope.senceList.length==0){
                                $scope.isShowGuideImg = true;
                                document.getElementById("movie-scense").style.display="none";
                            }
                            Movies.deleteAsence(sceneId,function(result){
                                // debugger
                            })
                        }
                    })
            }else if(scenceitem.videoType == 1){//电视
                    var sceneId = scenceitem.sceneId;
                    angular.forEach($scope.programList,function(data,index){
                        if(data.sceneId==sceneId){
                            // console.log(data.sceneId)
                            // console.log(index)
                            $scope.programList.splice(index,1)
                            if($scope.programList.length==0 && $scope.senceList.length==0){
                                $scope.isShowGuideImg = true;
                                document.getElementById("movie-scense").style.display="none";
                            }
                            Movies.deleteAsence(sceneId,function(result){
                                // debugger
                            })
                        }
                    })

            }
        }

        var device = function (e,deviceId) {
                        $scope.userinfo = User.getCurrentUser();
                        TV.delete_device(deviceId, $scope.userinfo.userId).$promise.then(function (data) {
                            if (data.success) {
                                /*移除已经删除的设备*/
                                angular.forEach($scope.friendDevices, function (device, index) {
                                    if (device.deviceId == deviceId) {
                                        $scope.friendDevices.splice(index, 1);
                                    }
                                });
                            }
                        }, function (data) {
                            console.log("删除出错啦！");
                        });
                    }

        /*
         * 删除设备
         * */
        $scope.delDevices = function (scene) {
            // console.log(scene)


            var deleteDevicePopup = $ionicPopup.show({
                title: '系统提示',
                template: '确定要删除此连接？',
                scope: $scope,
                buttons: [
                    {
                        text: '确定',
                        type: 'button-positive',
                        onTap: function(){
                            if(scene.videoType){
                                moviescene(scene)
                            }else{
                                device(e,scene)
                            }
                        }
                    },
                    {
                        text: '取消'
                    }
                ]
            });

        }

        /*
         *我的电视
         */
        $scope.manageDevice = function (device_id, dstatus) {
            // debugger;
            console.log("state" + dstatus);
            if (dstatus == 0) {
                statusError();
            } else {
                $location.path('tv/manage/' + device_id);
                event.stopPropagation();
                return false;
            }

        }
        /*
         *拍照电视上传
         */
        $scope.openCameraforTv = function () {
            photoService.takePhoto();
        }
        /*
         *录制视频
         */
        $scope.startRecordVideo = function () {

            captureVideo();
        }
        function captureSuccess(mediaFiles) {
            var i, len, fileName = mediaFiles.name, path;
            console.log(fileName);
            for (i = 0, len = mediaFiles.length; i < len; i += 1) {
                // uploadFile(mediaFiles[i]);
                // UploadSvc.upload(fileName,);
                path = mediaFiles[i].fullPath;
            }
            uploadImg.uploadEvent(path, {dataType: 3, fileType: 'video', data: ''}, function (response) {
                var data = JSON.parse(response.data);
                var playTime, playVideo;
                if (data != 'undefined') {
                    playVideo = data.videoName;
                    playTime = data.playTime;
                    var settingPopup = $ionicPopup.show({
                        title: '返回数据',
                        template: '<p>影片播放到："' + dateTime.formatSeconds(playTime) + '"</p><p>影片名称："' + playVideo + '"</p>',
                        buttons: [
                            {
                                text: '关闭'
                            }
                        ]
                    })
                } else if (data == 'undefined') {
                    var settingPopup = $ionicPopup.show({
                        title: '返回数据',
                        template: '<p>"' + response + '"</p>',
                        buttons: [
                            {
                                text: '关闭'
                            }
                        ]
                    })
                }

                $ionicLoading.hide();
            });
        }

        // Called if something bad happens.
        //
        function captureError(error) {
            var msg = 'An error occurred during capture: ' + error.code;
            // navigator.notification.alert(msg, null, 'Uh oh!');
        }

        // A button will call this function
        //
        function captureVideo() {
            navigator.device.capture.captureVideo(captureSuccess, captureError, {limit: 1, duration: 1});
        }

        /*打开系统摄像头扫描二维码*/
        $scope.openSysCamera = barCodeScannerUtil.openSysCamera;
    })
    .controller('TVManageCtrl', function ($scope, $rootScope, $stateParams, $state, $ionicPopup, User, $ionicLoading, $log, ENV, TV) {
        TV.get_device_info($stateParams.deviceId).$promise.then(function (data) {
            if (data.success) {
                angular.forEach(data.data.users, function (user) {
                    if (user.status == 0) {
                        user.status = false;
                    } else if (user.status == 1) {
                        user.status = true;
                    }
                    if (user.nickname && typeof(user.nickname) == "undefined")
                        user.nickname = "";
                });
                $scope.tvInfo = data.data;
            } else {
                $scope.tvInfo = [];
                $ionicLoading.hide();
                $ionicLoading.show({
                    template: '获取终端详情失败',
                    noBackdrop: true,
                    duration: 1000
                });
                console.log("获取终端详情失败!");
            }
        });
        $scope.toggleEvent = function (index) {
            var user = $scope.tvInfo.users[index];
            var type = user.status ? 1 : 0;
            TV.on_off_friend(user.userId, type, $scope.tvInfo.deviceId).$promise.then(function (data) {
                if (data.success) { //                $scope.tvInfo.users[index].status = !user.status;
                    console.log("设置成功！");
                } else {
                    $scope.tvInfo.users[index].status = !user.status;
                    $ionicLoading.show({
                        template: '设置失败',
                        noBackdrop: true,
                        duration: 1000
                    });
                    console.log("设置失败！");
                }
            });
        }
        $scope.settingNickName = function (index) {
            $scope.device = {};
            var settingPopup = $ionicPopup.show({
                title: '设置终端别名',
                template: '<label class="item item-input">' +
                '<input type="text" ng-model="device.nickname" placeholder="填写一个终端别名">' +
                '</label>',
                scope: $scope,
                buttons: [
                    {
                        text: '设置',
                        type: 'button-positive',
                        onTap: function (e) {
                            if (!$scope.device.nickname) {
                                e.preventDefault();
                                $ionicLoading.show({
                                    template: '请输入别名',
                                    noBackdrop: true,
                                    duration: 1000
                                });
                            } else {
                                TV.set_device_name({
                                    deviceId: $scope.tvInfo.deviceId,
                                    dname: $scope.device.nickname
                                }).$promise.then(function (data) {
                                        if (data.success) {
                                            $scope.tvInfo.dname = $scope.device.nickname;
                                        } else {
                                            e.preventDefault();
                                        }
                                    });
                            }
                        }
                    },
                    {
                        text: '关闭'
                    }
                ]
            });
            event.stopPropagation();
            return false;
        }
        /*
         * 删除设备
         * */
        $scope.delDevices = function () {
            var deleteDevicePopup = $ionicPopup.show({
                title: '系统提示',
                template: '确定要删除此连接？',
                scope: $scope,
                buttons: [
                    {
                        text: '确定',
                        type: 'button-positive',
                        onTap: function (e) {
                            $scope.userinfo = User.getCurrentUser();
                            TV.delete_device($scope.tvInfo.deviceId, $scope.userinfo.userId).$promise.then(function (data) {
                                if (data.success) {
                                    $state.go('tab.tv');
                                }
                            }, function (data) {
                                console.log("删除出错啦！");
                            });
                        }
                    },
                    {
                        text: '取消'
                    }
                ]
            });
        }
    })
/**
 * 添加设备页面相关
 * @param  {[type]} $ENV          [description]
 * @param  {[type]} $scope        [description]
 * @param  {[type]} $ionicLoading [description]
 * @param  {[type]} $log          [description]
 * @param  {[type]} TV){                         } [description]
 * @return {[type]}               [description]
 */
    .controller('AddDeviceCtrl', function (ENV, $scope, $state, $ionicLoading, $log, TV, $ionicPopup, $rootScope, barCodeScannerUtil) {
        $scope.device = {};
        $scope.openSysCamera = function () {
            barCodeScannerUtil.openSysCamera();
        }

        $scope.bindingDevice = function () {
            if ($scope.device.code) {
                TV.add_device({
                    deviceCode: $scope.device.code,
                    type: 1
                }).$promise.then(function (data) {
                        if (data.success) {
                            $ionicLoading.show({
                                template: '绑定成功',
                                noBackdrop: true,
                                duration: 1000
                            });
                            $scope.device.nickname = $scope.device.code;
                            var settingPopup = $ionicPopup.show({
                                title: '设置终端别名',
                                template: '<input type="text" ng-model="device.nickname" placeholder="填写一个终端别名">',
                                scope: $scope,
                                buttons: [
                                    {
                                        text: '设置',
                                        type: 'button-positive',
                                        onTap: function (e) {
                                            if (!$scope.device.nickname) {
                                                $ionicLoading.show({
                                                    template: '必须填写、设置终端名称',
                                                    noBackdrop: true,
                                                    duration: 1000
                                                });
                                                e.preventDefault();
                                            } else {
                                                TV.set_device_name({
                                                    deviceId: data.data.deviceId,
                                                    dname: $scope.device.nickname
                                                }).$promise.then(function (data) {
                                                        if (data.success) {
                                                            $rootScope.$broadcast('reload_devices');
                                                            $state.reload("tab.tv");
                                                            $state.go("tab.tv");
                                                        } else {
                                                            e.preventDefault();
                                                        }
                                                    });
                                            }
                                        }
                                    },
                                    {
                                        text: '取消'
                                    }
                                ]
                            });

                        } else {
                            $ionicLoading.show({
                                template: data.msg,
                                noBackdrop: true,
                                duration: 1000
                            });
                        }
                    });
            } else {
                $ionicLoading.show({
                    template: '先填写终端编码',
                    noBackdrop: true,
                    duration: 1000
                });
            }
        }


        $scope.settingNickName = function (index) {
            $scope.device = {};
            var settingPopup = $ionicPopup.show({
                title: '设置终端别名',
                template: '<input type="text" ng-model="device.nickname" placeholder="填写一个终端别名">',
                scope: $scope,
                buttons: [
                    {
                        text: '设置',
                        type: 'button-positive',
                        onTap: function (e) {
                            if (!$scope.device.nickname) {
                                e.preventDefault();
                            } else {
                                TV.set_device_name({
                                    deviceId: $scope.ownerDevices[index].deviceId,
                                    dname: $scope.device.nickname
                                }).$promise.then(function (data) {
                                        if (data.success) {
                                            $scope.ownerDevices[index].dname = $scope.device.nickname;
                                        } else {
                                            e.preventDefault();
                                        }
                                    });
                            }
                        }
                    },
                    {
                        text: '关闭'
                    }
                ]
            });
            event.stopPropagation();
            return false;
        }
        //  //引导图的显示隐藏
        // $scope.isShowGuideImg =true;

    })

// .controller('openCameraForTv', function(ENV, $scope, $ionicPopup, $rootScope, photoService) {
//     /*
//     *拍照电视上传
//     */
//         $scope.openCameraforTv = function() {
//             var myPopup = $ionicPopup.show({
//                 title: '拍照识别',
//                 scope: $scope,
//                 buttons: [{
//                     text: '拍照上传',
//                     onTap: function() {
//                         photoService.takePhotoForTv();
//                     }
//                 }]

//             });
//         }
// })
