/**
 * @description 三边功能页面
 * @author SuperK
 * @date 2015/04/07
 */
rootModule
.controller('PlatformSideCtrl', function(
    ENV, $location,$log, $scope, $cordovaAppVersion, Toast,
    $http, $compile, $templateCache, $timeout, $interval,
    $rootScope, $stateParams, User, InterfaceSide, ThumbImage,
    $ionicScrollDelegate, $ionicLoading, $ionicModal, $ionicPopup,
    VideoStatusCore,$window, Storage, $state, InterfaceDotInfo, MediaSvc,
     UUID, orderDotsBy, toupinLogin, dateTime, Side, Active, $filter,$resource) {
    $scope.commentList=[];
    var Side = InterfaceSide;
    var moviestauts = false;
    var DotInfo = InterfaceDotInfo;
    var chatContent = document.querySelector('#chat-content'),
        labelList = document.querySelector('#label-list'),
        thumbContainer = document.querySelector('#thumb-scroll'),
        thumbScroll = $ionicScrollDelegate.$getByHandle('thumb-image-scroll'),
        SideConstans = {
            video: 0,
            commentRise: 1,
            vote: 2,
            topic: 3,
            repy: 4,
            channel: 5
        },
        bigThumbContainer = document.querySelector('#big-thumb'),
        watchType = 2, //观看类型及ID，直播为1，点播为2
        commonId = $stateParams.videoId,
        time = 0, //当前视频进度
        imagesCache = [], //本地缓存，存放图片
        deviceId = watchType == 1 ? -1 : $stateParams.videoId, //终端ID
        channelId = -1, //频道ID
        videoId = $stateParams.videoId, //视频ID
        localDots = [],
        hasDialog = false,
        pullStatusRespones = true,
        oldPlayTime = 0,
        globalCommentData = [],
        shownDotId = -1,
        globalThumbPath = '';
    $scope.handShow;
    var shouldToInitDots = [];
    $scope.dots = [];
    $scope.dot = {
        dotId: '001',
        inputMode: 0
    }
    var historyids = [];//历史评论id
    if($stateParams.startTime!=""){
        var startTime= $stateParams.startTime; //截止时间
        startTime = new Date(startTime);
    }else{
        startTime = new Date();
    }

    var NowTime = new Date();
    var startedTime = parseInt((NowTime - startTime)/1000);//计算开始时间
    $scope.videocommentList=0
    // $scope.noMoreComment = false

    //绑定电影名字
    $scope.moviename = decodeURIComponent($stateParams.moviename);
    var hasShowThumbList = [];
    $scope.isShow = true;
    // 加载的时候不显示页面内容
    function pageLoading(status){
        var currentcontent = "[delegate-handle='main-content-handler']"
        if(status){
            $ionicLoading.hide()
            // document.querySelector(currentcontent).setAttribute('style',"opacity:1")
            document.querySelector("[commentname='comment']").setAttribute('style',"display:block")
        }else{
            $ionicLoading.show();
            // document.querySelector(currentcontent).setAttribute('style',"opacity:0")
        }
    }
    // pageLoading(false)
    $ionicLoading.show();
    function hasShowThumb(time) {
        hasShow = false;
        if (hasShowThumbList.length > 0) {
            angular.forEach(hasShowThumbList, function(item) {
                if (item == time) {
                    hasShow = true;
                    return false;
                }
            })
        }
        return hasShow;
    }
    //存放数据
    $scope.comments = [];
    $scope.thumbImgs = [];
    $scope.commentText = {
        text: "",
        type: 0, //0:评论，1:回复
        commentId: -1, //回复用ID,
        placeholder: '戳我添加评论'
    }; //存放视频或频道评论列表
    $scope.inputToolVisible =false; //是否显示输入框
    $scope.sbText = {
        text: ''
    }

    $scope.videoInfo = {
        videoId: videoId
    }; //存储节目、视频相关信息
    var isPlay = false; //是否在播放
    var index = 0;
    var globalTimer;

    //排重方法
    function joinWithUUIDFilter(toJoin, fromJoin) {
        angular.forEach(fromJoin, function(it) {
            var hasDump = false;
            angular.forEach(toJoin, function(item) {
                if (item.uuid == it.uuid) {
                    hasDump = true;
                    return false;
                }
            })
            if (!hasDump) {
                toJoin.push(it);
            }
        })
        return toJoin;
    }
    var barragescreen=document.getElementById('H_zoom');
    var slidescreen=document.getElementById('H_zoom-side');
    $scope.isMovieOver = true;
    var ZoomSlideover=function(){
            // barragescreen.style.display='none';
            $scope.isMovieOver = false
            $scope.showsidenav=true;
            $scope.showsidemore=false;
            // slidescreen.style.paddingTop=45+'px';
            // debugger
    }

    function startTimmer() {
        //定时器，定时显示节目或视频快照，如果为频道则不动态加载，直接显示一个频道图片
        globalTimer = $interval(function() {
            var movieLength;
            getDeviceStatus(function(data) {
                movieLength = data.movieLength;
                //这里来判断是否需要获取打点数据
                try {
                    var status = parseInt(data.status);
                    if (status == 1 || status == 2 || status == 3) { //暂停
                        isPlay = false;
                    } else if (status == 0) {
                        isPlay = true;
                    }
                } catch (e) {
                    console.log(e);
                }
            }, true)
            $scope.time = time;
            //测试数据
            //测试数据
            //显示打点信息
            var dot = DotInfo.getShownDotsByTime(time);
            if (dot && dot.length > 0) {
                //到点开始推送
                $timeout(function() {
                    //console.log('加载打点信息:', dot);
                    if (shownDotId == -1) {
                        initDot(dot);
                    } else {
                        //这里需要排重，现在的方式为每次都将所有的需要显示的都取出来了的，
                        shouldToInitDots = joinWithUUIDFilter(shouldToInitDots, dot);
                        $scope.newPointNum = shouldToInitDots.length;
                    }
                }, 10);
            }
            //显示评论信息
            var comts = getShownCommentsByTime(time);
            if (comts && comts.length > 0) {
                $timeout(function() {
                    initNeedShowComments(comts);
                })
            }
            if (isPlay) {
                time++;
            }
            if(time>movieLength){
                var moviestop = false
                $scope.$broadcast("moviestop",moviestop)
                ZoomSlideover();//观影后隐藏弹幕框
                $scope.commentStyle = false

                // debugger
                // pageLoading(true)
            }else{
                $scope.$broadcast("settime",time);
                $scope.commentStyle = true
                // pageLoading(true)
                // ZoomBulletShow();
            }
            //CM.time(time*1000);//弹幕设置时间
            index++;

        }, 1000);

    }

    /*******页面效果及DOM操作*******/
    var ChatEvent = {
            /**
             * 话题聊天窗口滚动到最下端
             * @param  {[type]} dotId [description]
             * @return {[type]}       [description]
             */
            scrollBottom: function(uuid) {
                if (shownDotId && shownDotId == uuid) {
                    var scroll = $ionicScrollDelegate
                        .$getByHandle('chat-scroll-' + uuid);
                    scroll.resize();
                    scroll.scrollBottom(true);
                    $timeout(function() {
                        scroll.resize();
                        scroll.scrollBottom(true);
                    }, 1000)
                }
            }
        }
        /**
         * 负责显示和隐藏卡片，点击标题显示隐藏
         * @param  {[type]} cardId 卡片ID
         * @param  {[type]} shown  是否显示
         * @return {[type]}        [description]
         */

    function _toggleLabel(uuid, shown) {
        var dot = DotInfo.getDotByUUID(uuid);
        dot.userStatus = 1; //用户操作状态
        //当前显示的卡片ID
        var cardId = dot.uuid;
        dot.visible = shown ? shown : !dot.visible;
        $scope.isShowReturnTop = dot.visible;
        if (!dot.visible) { //关闭的时候，
            if (shouldToInitDots.length > 0) {
                initDot(shouldToInitDots);
                //判断一下把最后一个商品展开
                if (shouldToInitDots && shouldToInitDots.length > 0) {
                    for (var i = 0; i < shouldToInitDots.length; i++) {
                        var item = shouldToInitDots[shouldToInitDots.length - 1 - i];
                        if (item.type == 3) {
                            $timeout(function() {
                                _toggleLabel(item.uuid, true);
                            }, 10)
                            break;
                        }
                    }
                }
                shouldToInitDots = [];
                $scope.newPointNum = 0;
            }
        }
        // //将所有的item关闭
        angular.forEach(DotInfo.getShownDots(), function(item) {
            if (!dot.visible) { //如果为关闭当前Item 则将其他所有Item 设置为item-nomal 状态
                item.status = 'item-nomal'
            } else if (item.uuid != cardId) {
                item.visible = false;
                item.status = 'item-hide';
            }
        })
        dot.status = dot.visible ? 'item-show' : 'item-nomal';
        shownDotId = uuid;
        var element = document.querySelector('#card-' + uuid);
        var itemTitle = element.querySelector('.label-title');
        //计算当前屏幕的高度
        var wHeight = $window.innerHeight;
        var scroll = document.querySelector('ion-scroll[delegate-handle="chat-scroll-' + uuid + '"]');
        if (dot.visible) { //手动修改样式,防止Angular监听不及时，出现的滚动条无法计算高度的Bug
            angular.element(element.querySelector('.label-body')).addClass('show');
        }

        /**
         * 这里需要计算有滚动框的内容的高度，
         * 因为在同一个手机屏幕内，每一个主题的滚动框，每次显示的高度应该是一样高的，所以这里做一个判定
         * 如果在Dot对象里面发现有一个参数则不需要计算，没有则计算一个高度出来
         ******/
        if (scroll && scroll != null && dot.visible) {
            var contentEle = document.querySelector('#chat-content');
            var ionicContentHeight = contentEle.offsetHeight;
            if (ionicContentHeight <= 0) {
                ionicContentHeight = contentEle.height;
            }
            var inputHeight = 42;
            var labelTitleHeight = 55;
            var descHeight = 0;
            //判断是否有详情介绍
            var desc = element.querySelector('.label-desc');
            if (desc != null) {
                descHeight = desc.offsetHeight + 1;
            }
            //判断是否为第一个Item,如果为第一个Item 则不需要*2
            // if (dot.uuid == DotInfo.getLastShownDot().uuid) {
            //     labelTitleHeight;
            // } else {
            //     labelTitleHeight = labelTitleHeight * 2 - 15;
            // }
            var sheight = ionicContentHeight - labelTitleHeight - descHeight - inputHeight;

            if (dot.type == -1) {
                sheight += 6;
            }
            //判断为商品不需要减去输入框的高度
            if (dot.type == 3 || dot.type == 2 || dot.type == 5 || dot.type == 10) {
                sheight += inputHeight + 6;
            }
            dot.scrollHeight = sheight; //当前Scroll的高度
            dot.descHeight = descHeight;
            angular.element(scroll).css({
                height: dot.scrollHeight + 'px'
            });
            /*
             * 商品不需要滚动到底部
             */
            if (dot.type != 3) {
                ChatEvent.scrollBottom(uuid);
            }
        }
        var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
        if (dot.visible) { //如果当前是显示元素不是收起元素的话，需要计算当前显示的位置
            //当前元素的位置
            mainScrollResize(); //重新计算整个容器的大小
            var elementTop = element.offsetTop;
            mainScroll.scrollTo(0, elementTop, true);
        } else {
            mainScrollResize();
            mainScroll.scrollTop(true);
            shownDotId = -1;
        }
        /**
         * 投票、竞猜、商品不显示输入框
         * @type {[type]}
         */
        $scope.inputToolVisible = (dot.type != 3 && dot.type != 5 && dot.type != 2 && dot.type != 10) ? dot.visible : false;
    }

    $scope.newDotClickEvent = function() {
        _toggleLabel(shownDotId, false);
    }

    function mainScrollResize() {
        var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
        mainScroll.resize();
    }

    var keyboarShowTime, keyboarHideTime, messageSendTime = 0;
    //显示键盘事件
    // window.addEventListener('native.keyboardshow', keyboardShowHandler);

    function getCurrentTime() {
        return new Date().getTime().valueOf();
    }

    // function keyboardShowHandler(e) {
    //     console.log('keyboardshow')
    //     var cla = getCurrentTime() - messageSendTime;
    //     var keyboardHeight = e.keyboardHeight; //键盘高度
    //     if (cla > 300) {
    //         if (typeof device != 'undefined' && device.platform == 'iOS') {

    //             //修复IOS平台使用键盘后，scroll位置不对的问题
    //             //document.querySelector('#fix-ios-keyboard-ele').style.height = keyboardHeight + 'px';
    //             //判断如果为IOS平台，则需要手动将输入框设置到键盘高度
    //             document.querySelector('.input-tools').style.bottom = keyboardHeight + 'px';
    //         }
    //         var dot = DotInfo.getDotByUUID(shownDotId);

    //         //这里将标题栏，简介条向上滚动
    //         var mainScroll = $ionicScrollDelegate.$getByHandle('main-content-handler');
    //         var scrollTop = mainScroll.getScrollPosition().top;

    //         //当前滚动框的高度
    //         var scroll = document.querySelector('ion-scroll[delegate-handle="chat-scroll-' + shownDotId + '"]');
    //         var titleheight = 55; //标题栏高度
    //         // if (DotInfo.getLastShownDot().uuid == shownDotId) {
    //         //     titleheight = 55;
    //         // }
    //         var scrollHeight = dot.scrollHeight - keyboardHeight + dot.descHeight + titleheight; //原本滚动框高度－键盘高度＋描述的高度+标题
    //         if (typeof device != 'undefined' && device.platform == 'Android') { //修复Android打开键盘底下出现的空白
    //             scrollHeight += 24;
    //         }
    //         angular.element(scroll).css({
    //             height: scrollHeight + 'px'
    //         });

    //         mainScroll.scrollTo(0, scrollTop + dot.descHeight + titleheight, true);
    //         ChatEvent.scrollBottom(shownDotId);
    //     }
    // }
    //隐藏键盘事件
    // window.addEventListener('native.keyboardhide', keyboardHideHandler);

    // function keyboardHideHandler(e) {
    //     var cla = getCurrentTime() - messageSendTime;
    //     if (cla > 300) {
    //         console.log('keyboardhide')
    //         //判断如果为IOS平台，则需要手动将输入框设置到0
    //         if (typeof device != 'undefined' && device.platform == 'iOS') {
    //             document.querySelector('.input-tools').style.bottom = '0px';
    //             document.querySelector('#fix-ios-keyboard-ele').style.height = '0px';
    //         }
    //         _toggleLabel(shownDotId, true);
    //     }
    // }
    /**
     * 重构方法
     * @param  {[type]} cardId [description]
     * @return {[type]}        [description]
     */
    function toggleLabel(cardId) {
        _toggleLabel(cardId, false);
    }
    $scope.toggleLabel = toggleLabel;
    $scope.toggleLabelHandler = toggleLabel;


    /****************用户界面相关位置计算开始****************/


    function initUserIntrface() {
        //IOS版本需要增加一些高度，StatusBar会占用一定的高度
        if (typeof device != 'undefined' && device.platform == 'iOS') {
            // document.querySelector('.thumb-warpper')
            // // .style.top = '64px';
            // console.log(document.querySelector('.thumb-warpper'))
            // document.querySelector('#chat-content')
            // .style.top = '112px';
        }
    }
    /**
     * 存储当前设备对应的一些变量值，如Header 高度，Content高度
     *
     */
    var GlobalParam = {
        contentHeight: chatContent.offsetHeight, //主题框的总高度
        inputHeight: 42, //输入栏的高度
        labelTitleHeight: 50, //主题标签高度,
        currentScrollHeight: 0 //
    }

    $scope.moreFun = function() {
        $ionicPopup.alert({
            title: '更多功能，敬请期待...'
        })
    }

    /***********动态计算Scroll话题聊天框的大小开始*******/

    function dynamicClaScroll(cardId) {
        var wHeight = $window.innerHeight; //屏幕总高度
        var headerHeight = 44; //Header高度
        var inputHeight = 47; //输入框的高度
    }


    /***********动态计算Scroll话题聊天框的大小结束*******/




    /****************用户界面相关位置计算结束****************/


    /**
     * 检测全局滚动事件
     */
     var gobackaim = "platformside"+$stateParams.videoId;//给返回键发消息
     $scope.gobackaim = gobackaim;
     var lastvalue=0;
    function onContentScroll(scrollTop, scrollLeft,showbrainrepair) {
        var data = {
            'scrollTop':scrollTop,
            'scrollLeft':scrollLeft,
            'showbrainrepair':showbrainrepair
        }
        var currentvalue = scrollTop;
        var sl = Math.abs(currentvalue-lastvalue)
        if(sl>25){
          // debugger
          $scope.$broadcast($location.path(),data);//mark1
          lastvalue = currentvalue;
        }

        $scope.isShowReturnTop = false;
        var timer = null;
        var clientHeight = $window.outerHeight;
        if (scrollTop >= clientHeight&&shownDotId==-1) {
            $scope.isShowReturnTop = true;
        } else {
            $scope.isShowReturnTop = false;
        }
        var commentheigth = document.getElementById(gobackaim).offsetTop - window.screen.height+105;

        if(commentheigth<0){
            if (scrollTop >= commentheigth+window.screen.height) {
                $scope.$broadcast(gobackaim+"back",{"status":true})
            } else {
                $scope.$broadcast(gobackaim+"back",{"status":false})
            }
        }else{
            if (scrollTop >= commentheigth+window.screen.height) {
                $scope.$broadcast(gobackaim+"back",{"status":true})
            } else {
                $scope.$broadcast(gobackaim+"back",{"status":false})
            }
        }
    };
    $scope.contentOnScroll = onContentScroll;

    $scope.backTop = function() {
        $ionicScrollDelegate.$getByHandle('main-content-handler').scrollTop();
        _toggleLabel(shownDotId, true);

    }

    //显示评论框


    /**
     * 显示简介详细信息
     * @param  {[type]} dotId [description]
     * @return {[type]}       [description]
     */
    var descEvent = function(dotId,isGoComment) {

        if(dotId=='searchpage'){
            var tempurl = 'templates/side-search.html';

        }else{
            var dot = getShowDotByid(dotId);
            $scope.tempInfo = dot;
            if (dot != null && typeof dot != 'undefined') {
                switch (parseInt(dot.type)) {
                    case 1: //话题
                        var tempurl = 'templates/subjectme/topic-details.html';
                        var msgcall = "topicdetail";
                        $timeout(function(){
                            // var topictitleheight = document.querySelector('#topic-title-height').offsetHeight;
                            // $scope.topictitleheight = topictitleheight;
                        },1000)
                        break;
                    case 10: //简介；
                        var tempurl = 'templates/subjectme/introduce-details.html';
                        var msgcall = "introducedetail";
                        //评论功能，通过滚动控制输入框是否显示<mark3>
                        $timeout(function(){
                            var commentheigth = document.getElementById(msgcall).offsetTop - window.screen.height+105;

                            if(commentheigth<0){
                                  $scope.$broadcast(msgcall,{"status":true})
                            }else{
                                $scope.$broadcast(msgcall,{"status":false})
                            }
                        },100)
                        break;
                    case 4: //知识点
                        var tempurl = 'templates/subjectme/knowlege-details.html';
                        var msgcall = "knowlegedetail";
                        //评论功能，通过滚动控制输入框是否显示<mark3>
                        $timeout(function(){
                            var commentheigth = document.getElementById(msgcall).offsetTop - window.screen.height+105;

                            if(commentheigth<0){
                                  $scope.$broadcast(msgcall,{"status":true})
                            }else{
                                $scope.$broadcast(msgcall,{"status":false})
                            }
                        },100)
                        break;
                }
            }

        }
        $ionicModal.fromTemplateUrl(tempurl, {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.modal = modal;
            modal.show();
            var detailScrollName = "scroll";
            $scope.detailScrollName = detailScrollName;
            $timeout(function(){
               if(isGoComment){
                var itemAim = document.querySelector('#'+msgcall).offsetTop;
                var allScroll = $ionicScrollDelegate.$getByHandle("detailScrollName").scrollTo(0,itemAim)
               }

            },250)
        });
        //获取三边详情页title的高


        //显示评论框
        function showInputBox() {
            var delegate = $ionicScrollDelegate.$getByHandle('detailScrollName');
            var position=delegate.getScrollPosition();
            var scrollTop=position.top;
            var scrollLeft=position.left;
            $scope.$broadcast($location.path(),{
                    'scrollTop':scrollTop,
                    'scrollLeft':scrollLeft,
                    'showbrainrepair':true
                });//默认加载一次图片
            var commentheigth = document.getElementById(msgcall).offsetTop - window.screen.height+105;
            if(commentheigth<0){
                $scope.$broadcast(msgcall,{"status":true})
                if (scrollTop >= commentheigth+window.screen.height) {
                    $scope.$broadcast(msgcall+"back",{"status":true})
                } else {
                    $scope.$broadcast(msgcall+"back",{"status":false})
                }
            }else{
                if (scrollTop >= commentheigth) {
                    $scope.$broadcast(msgcall,{"status":true})
                } else {
                    $scope.$broadcast(msgcall,{"status":false})
                }
                if (scrollTop >= commentheigth+window.screen.height) {
                    $scope.$broadcast(msgcall+"back",{"status":true})
                } else {
                    $scope.$broadcast(msgcall+"back",{"status":false})
                }
            }

        }
        $scope.searchBlurEvent = function () {
            //$ionicHistory.goBack();
        }
        $scope.$watch('keyword', function (value) {
            $scope.results = [];
            search();
        })
        /**
         * 搜索频道或节目列表
         * @return {[type]} [description]
         */
        function search() {
            var keyword = $scope.keyword;
            if (keyword && "" != keyword) {
                Live.searchChannel(keyword).$promise.then(function (result) {
                    if (result.success) {
                        $scope.results = result.data;
                    } else {
                        $ionicLoading.hide();
                        $ionicLoading.show({
                            template: result.msg,
                            duration: 1000,
                            noBackdrop: true
                        });
                    }
                })
            }
        }
        $scope.showInputBox = showInputBox;
        $scope.scrollTop = function() {
            $ionicScrollDelegate.scrollTop();
        }
        $scope.openModal = function() {
          $scope.modal.show();
        };
        $scope.closeModal = function() {
          $scope.modal.remove();
        };
        //Cleanup the modal when we're done with it!
        $scope.$on('$destroy', function() {
          $scope.modal.remove();
        });
        // Execute action on hide modal
        $scope.$on('modal.hidden', function() {
          // Execute action
        });
        // Execute action on remove modal
        $scope.$on('modal.removed', function() {
          // Execute action
        });
    }
    $scope.descEvent = descEvent;
    $scope.descEventHandler = descEvent;


    /**
     * 页面上的各种事件
     * @return {[type]} [description]
     */
    function createEvent() {}
    /**
     * 点赞事件
     * @param  {[type]} cid 评论ID
     * @param  {[type]} type 对谁发表的内容，即谁的评论（0：视频；1：评论点赞；2：投票；3：话题；4：评论(回复)；5：频道
     * @return {[type]}     [description]
     */
    var likeEvent = function(cid, type) {
        //通过CID获取评论信息
        var comment = getLocalCommentByCid(cid);
        if (comment) {
            comment.isLike = true;
        }
        Side.add_theme_talk(SideConstans.commentRise, cid, watchType == 1 ? channelId : videoId, -1, -2, deviceId).$promise.then(function(result) {
            var msg = "";
            if (result.success) {
                msg = "点赞成功";
            } else {
                msg = '点赞失败 ' + result.msg
            }
            $ionicLoading.show({
                template: msg,
                duration: 1000,
                noBackdrop: true
            })
        })
    }
    $scope.likeEvent = likeEvent;
    /******************发表评论事件***************/
    /**
     * 评论或回复
     * @param  {[type]} doType 评论还是回复  0评论，1回复
     * @return {[type]}        [description]
     */
    var sendCommentEvent = function() {
        var value = $scope.commentText.text,
            doType = $scope.commentText.type;
        if (value && "" != value) {
            var sendType = -1;
            var commentId = -1;
            var rootId = watchType == 1 ? channelId : videoId;
            var themeType = watchType == 1 ? -2 : -1;
            switch (doType) {
                case 0:
                    sendType = watchType == 1 ? SideConstans.channel : SideConstans.video;
                    commentId = watchType == 1 ? channelId : videoId;
                    break;
                case 1:
                    sendType = 4;
                    commentId = $scope.commentText.commentId;
                    break;
            }
            sendEvent(sendType, commentId, rootId, themeType, value, function(result) {
                var msg = "";
                if (result.success) {
                    $scope.commentText = {
                        text: Debug.getRandomMsg(),
                        placeholder: '戳我添加评论',
                        type: 0,
                        commentId: -1
                    };
                    document.querySelector('#commentText').value = "";
                    document.querySelector('#commentText').value = Debug.getRandomMsg();
                } else {
                    $ionicLoading.show({
                        template: '发表失败 ' + result.msg,
                        duration: 1000,
                        noBackdrop: true
                    })
                }

            });
        }
    }
    $scope.sendCommentEvent = sendCommentEvent;
    /********发送语音消息****/
    $scope.media = false;
    /**
     * 回复按钮事件
     * @param  {[type]} commentId 评论ID
     * @param  {[type]} nickName  用户昵称戳我添加评论
     * @return {[type]}           [description]
     */
    function repyEvent(commentId, nickName) {
        var commentInput = angular.element(document.querySelector('#commentText'));
        $scope.commentText.text = "";
        $scope.commentText.type = 1;
        $scope.commentText.commentId = commentId;
        $scope.commentText.placeholder = '@回复' + nickName;
        $timeout(function() {
            commentInput[0].focus();
        })
        event.stopPropagation();
        return false;
    }
    $scope.repyEvent = repyEvent; //点击回复按钮事件

    /**
     * 显示大图
     */
    function showThumbBig(url) {
        var img = new Image();
        img.src = url;
        img.onload = function() {
            bigThumbContainer.appendChild(img);
        }
    }
    $scope.showThumbBig = showThumbBig;

    /********投票事件******/
    /**
     * 投票
     * @param  {[type]} dotId 投票ID
     * @param  {[type]} vcId  投票选项ID
     * @return {[type]}       [description]
     */

    function voteEvent(uuid, vcId) {
        if (User.getCurrentUser() != null) {
            var dot = getShowDotByUUID(uuid);
            var choice = [];
            // console.log(dot);
            var canVote = false;
            for (var i = 0; i < dot.choice.length; i++) {
                //第一步判断是否可以投票或竞猜
                var choice = dot.choice[i];
                if (choice.vcId == vcId && (choice.status == 1 || choice.status == 2)) {
                    $ionicLoading.show({
                        template: '您已投过，不可再投！',
                        duration: 1000,
                        noBackdrop: true
                    })
                    canVote = false;
                    break;
                } else {
                    canVote = true;
                }
            }
            if (canVote) { //可以投票
                if (dot.choiceType == 1) { //单选的处理方式
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (dot.choice[i].vcId == vcId) {
                            dot.choice[i].status = 1;
                        } else {
                            dot.choice[i].status = 2;
                        }
                    }

                } else if (dot.choiceType == 2) { //多选的处理方式
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (dot.choice[i].vcId == vcId) {
                            dot.choice[i].status = 1;
                        }
                    }
                }
                sendCommentData(dot.dotId, {
                    content: vcId,
                    inputMode: 0
                });
            }
            //公布答案：
            //这里查找出竞猜的正确答案
            if (dot.type == 5) //竞猜
            {
                //循环选项，找出正确答案
                for (var i = 0; i < dot.choice.length; i++) {
                    if (dot.choice[i].isTrue == 1) {
                        dot.trueAnswer = dot.choice[i].content;
                        break;
                    }
                }
            }

        } else {
            Toast.show('请登录后再来参与吧！')
        }
    }
    $scope.voteEvent = voteEvent;
    $scope.voteEventHandler = voteEvent;

    // // 切换投票按钮颜色
    // function changeVoteBtn($scope){
    //     $scope.isActive = true;
    // }
    /**
     * 发表话题信息
     * @param  {[type]} dotId 话题ID
     * @return {[type]}       [description]
     */
    function sendChat(dotId) {
        var dot = getShowDotByid(dotId);
        var sendType = 3; //话题
        var themeType = 1;
        var commentId = dotId;
        var rootId = dotId;
        if (dot && dot.type == -1) { //为评论信息(1.直播，2.点播)
            sendType = watchType == 1 ? 5 : 0;
            themeType = watchType == 1 ? -2 : -1;
        }
        sendEvent(sendType, commentId, rootId, themeType, dot.commentText, function(result) {
            var msg = "";
            if (result.success) {
                dot.commentText = Debug.getRandomMsg();
            } else {
                msg = '发送失败:' + result.msg;
                $ionicLoading.show({
                    template: msg,
                    duration: 1000,
                    noBackdrop: true
                })
            }

        })
    }

    $scope.sendChatEvent = sendChat;
    $scope.sendChatEventHandler = sendChat;

    /******************发送消息、点赞、评论、投票事件*********************/
    /**
     * 发送消息接口
     * @param  {[type]} type      对谁发表的内容，即谁的评论（0：视频；1：评论点赞；2：投票；3：话题；4：评论(回复)；5：频道
     * @param  {[type]} comentId  被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
     * @param  {[type]} rootId    评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
     * @param  {[type]} themeType 哪种主题,主题类型（1:话题2：投票3：商机-1：视频 -2：频道 ）
     * @param  {[type]} content   发送的内容
     * @return {[type]}           callback(result)
     */
    function sendEvent(type, comentId, rootId, themeType, content, callback) {
        var sendType = watchType == 1 ? SideConstans.channel : SideConstans.video;
        if($scope.time>$stateParams.movieLength){
            var currentplaytime = $stateParams.movieLength;
        }else{
            var currentplaytime = $scope.time;
        }
        Side.add_theme_talk(type, comentId, rootId, themeType, content, deviceId, currentplaytime)
            .$promise.then(function(result) {
                callback && callback(result);
            }, function(error) {
                callback && callback({
                    success: false
                })
            });
    }
    //监听评论框
    var ctInput = angular.element(document.querySelector('#commentText'));
    ctInput.bind('focus', function(e) {
        console.log('focus')
    })
    ctInput.bind('blur', function(e) {
        if ($scope.commentText.type == 1) {
            $scope.commentText.type == 0;
            ctInput.attr('placeholder', '戳我添加评论');
        }
    })
    $scope.dotId = "10000";

    function showMicEvent(dotId) {
        var dot = getShowDotByid(dotId);
        dot.inputMode = 1;
    }
    $scope.showMicEventHandler = showMicEvent;
    $scope.showMicEvent = showMicEvent;
    /**
     * 发送语音消息
     * @param  {[type]} dotId [description]
     * @param  {[type]} data  [description]
     * @return {[type]}       [description]
     */
    function sendVoiceComment(dotId, data) {

        // console.log('dotId,data', dotId, data);
        var dot = getShowDotByid(dotId);
        var sendType = 3; //话题
        var commentId = dotId;
        var rootId = dotId;
        var themeType = 1;
        data = '{"voice":"' + data + '"}';
        if (dot && dot.type == -1) { //为评论信息(1.直播，2.点播)
            sendType = watchType == 1 ? 5 : 0;
            themeType = watchType == 1 ? -2 : -1;
        }
        sendEvent(sendType, commentId, rootId, themeType, data, function(result) {
            var msg = "";
            if (result.success) {

            } else {
                msg = '发送失败:' + result.msg;
                $ionicLoading.show({
                    template: msg,
                    duration: 1000,
                    noBackdrop: true
                })
            }

        })
    }
    $scope.sendVoiceCommentHandler = sendVoiceComment;
    $scope.sendVoiceComment = sendVoiceComment;
    window.sendVoiceCommentHandler = sendVoiceComment;
    window.sendVoiceComment = sendVoiceComment;

    function sendCommentData(dotId, data) {
        //发送消息的时候记录一个时间用于处理IOS键盘失去焦点，出现的位置计算错误问题。
        messageSendTime = getCurrentTime();
        var content = data.content;
        var inputMode = data.mode;
        if (inputMode == 1) { //语音输入
            content = '{"voice":"' + content + '","voiceLength":"'+data.voiceLength+'"}';
        }
        var dot = getShowDotByid(dotId);

        var sendType = 3; //话题
        var themeType = 1;
        var commentId = dotId;
        var rootId = dotId;

        if (dot && dot.type == -1) { //为评论信息(1.直播，2.点播)
            sendType = watchType == 1 ? 5 : 0;
            themeType = watchType == 1 ? -2 : -1;
            $scope.videocommentList++//视频评论总数加一
        }
        if (dot && dot.type == 2) {
            sendType = 2;
            themeType = 2;
        }
        if (dot && dot.type == 5) {
            sendType = 6;
            themeType = 5;
        }
        if (dot && dot.type == 4) { //知识点
            themeType = 4;
            sendType = 7;
        }
        if (dot && dot.type == 10) { //简介
            themeType = 10;
            sendType = 10;
        }
        //这里直接把自己发送的内容显示出来
        var user = User.getCurrentUser();
        if($scope.time>=$stateParams.movieLength){
            var playtime = $stateParams.movieLength
        }else{
            var playtime = $scope.time
        }
        addCommentData({
            "cid": UUID.newuuid(),
            "userId": user.userId,
            "nickname": user.nickName,
            "headImg": user.headImg,
            "rootId": dotId,
            "themeType": themeType,
            "content": content,
            "type": sendType,
            "commentTime": dateTime.getDateTime(),
            "targetId": rootId,
            "playTime": playtime
        }, false)
        sendEvent(sendType, commentId, rootId, themeType, content, function(result) {
            var msg = "";
            if (result.success) {

            } else {

            }
        })
    }
    /**
     * 拉取初始化评论信息
     */
    function initComments() {
        var themeType = watchType == 1 ? 5 : 0;
        //查询历史的评论信息
        Side.getAllHistoryComments(watchType == 1 ? channelId : videoId, watchType == 1 ? -2 : -1, function(result) {
            if (result.success) {
                if (result.data && result.data.length > 0) {
                    var ids = [];
                    angular.forEach(result.data, function(item, index) {
                        //解析出需要显示的数据
                        if (parseInt(item.playTime) < time) {
                            ids.push(item.cid);
                        } else {
                            globalCommentData.push(angular.extend({
                                hasShow: false
                            }, item));
                        }
                    })
                    // debugger
                    getCommentById(ids.join(','));
                }
            }
        });
    }

    /**
     * 界面系统初始化
     * @return {[type]} [description]
     */
    function init() {
        console.info('开始初始化框架');
        //window.CM = new CommentManager(document.getElementById('tvhelper-comment-stage'));
        resetData();
        Side.resetData(); //重置数据
        getDotInfo();
        startTimmer();
        createEvent();
        initUserIntrface();
        /**
         * 获取监听端口进入聊天室
         * @param  {[type]} ){                         getWatchInfo();        } [description]
         * @return {[type]}     [description]
         */
        Side.getListenerPort(videoId, watchType).$promise.then(function() {
            getWatchInfo();
        })
        //加载活动列表
        loadActivity();

        //CM.init(); // 初始化
        // 启动播放弹幕（在未启动状态下弹幕不会移动）
        //CM.start();
    }

    function loadActivity() {
        var type = 0;
        var page = 1;
        var starttime = new Date();
        var endtime = new Date();
        starttime.setMonth(endtime.getMonth() - 1);
        starttime = $filter('date')(starttime, 'yyyy-MM-dd HH:mm:ss');
        endtime = $filter('date')(endtime, 'yyyy-MM-dd HH:mm:ss');
        Active.getActivitys(type, page, starttime, endtime, function(list) {
            $scope.activeList = list;
        });
    }

    $scope.getClicky = function(link) {
        window.open(link, '_blank', 'location=yes');
    }


    /**
     * 重置所有数据
     * @return {[type]} [description]
     */
    $rootScope.$on('reset_side_data', function() {
        $scope.dots = [];
        globalCommentData = [];
    })

    function resetData() {
        $rootScope.$broadcast('reset_side_data');
    }
    /**过滤时间**/
    function switchDate(time){
        if(/-/g.test(time)){
            time = time.replace(/-/g, "/");
            if(/\.\d/.test(time)){
                time = new Date(Date.parse(time.replace(/\.\d/g,"")));
                return time
            }else{
                time = new Date(Date.parse(time));
                return time
            }
        }else{
            return time;
        }
    }
    /**
     * 初始化显示打点信息
     * @param  {[type]} dot 打点信息,数组
     * @return {[type]}     [description]
     */
    function initDot(dots) {
        //使用手机震动提示,评论不提示，第一次不提示
        if(typeof HSPlugin!='undefined'&&Math.abs(dots[0].timePoint-$scope.time)<60){
            console.log('震动提示...')
            HSPlugin.execFunc("showVibration",[],function(){}, function(){});
        }else{
            //不处理
        }

        /**
         * 这里做一次排重
         */
        angular.forEach(dots, function(dot) {
            var hasDump = false;
            angular.forEach($scope.dots, function(item) {
                if (item.uuid == dot.uuid) {
                    hasDump = true;
                    return false;
                }
            })
            if (!hasDump) {
                dot.msgs = [];
                dot.inputMode = 0;
                $scope.dots.push(dot);
                if (!$scope.$$phase) {
                    $scope.$apply();
                }
                var rootId = dot.dotId;
                var type = 1; //
                if (dot && dot.type == -1) { //为评论信息(1.直播，2.点播)
                    rootId = videoId;
                    type = watchType == 1 ? -2 : -1;
                }
                if (dot.type == 2) {
                    type = 2;
                }
                if (dot.type == 5) {
                    type = 5;
                }
                if (dot.type == 4) {
                    type = 4;
                }
                if (dot.type == 10){
                    type = 10
                }
                //使用新版拉取话题聊天信息，与评论一样
                // debugger
                (function(themeType, rootId, type) {
                    Side.getAllHistoryComments(rootId, type, function(result) {
                        if (result.success) {
                            if (result.data && result.data.length > 0) {
                                //批量查询
                                var ids = [];
                                // debugger给视频评论按观看时间排序
                                if(dot.type==-1){
                                    // debugger
                                    if(time>$stateParams.movieLength){//观影后
                                        result.data = result.data.sort(function(a,b){
                                            a.commentTime=switchDate(a.commentTime);
                                            b.commentTime=switchDate(b.commentTime);
                                            // debugger
                                            return parseInt(b.commentTime-a.commentTime)
                                            // debugger
                                        })
                                    }else{//观影中
                                        result.data = result.data.sort(function(a,b){
                                            a.commentTime=switchDate(a.commentTime);
                                            b.commentTime=switchDate(b.commentTime);
                                            return parseInt(b.playTime) - parseInt(a.playTime)
                                        })
                                    }

                                }
                                angular.forEach(result.data, function(item, index) {
                                    if (parseInt(item.playTime) < time || themeType == 2 || themeType == 5) {
                                        ids.push(item.cid);
                                    } else {
                                        globalCommentData.push(angular.extend({
                                            hasShow: false
                                        }, item));
                                    }
                                })
                                // debugger
                                if(dot.type==-1){
                                    $scope.videocommentList = ids.length;

                                    historyids = ids
                                    if(historyids.length>10){
                                        document.getElementById("nextPageComment").style.display="block";
                                    }else{
                                        document.getElementById("nextPageComment").style.display="none";
                                    }

                                    // debugger
                                    getCommentById(historyids.slice(0, 9).join(','),false);
                                    historyids = historyids.slice(10)
                                }else{
                                    getCommentById(ids.join(','),false);
                                }

                                // debugger
                            }
                        }else if(!result.success&&type==-1){
                            //视频查询无结果处理
                            document.getElementById("nextPageComment").style.display="none";
                        }
                    });
                })(dot.type, rootId, type)


            }
        })
        //这里来重新设定位置
        $timeout(function() {
            if (shownDotId != -1) {
                _toggleLabel(shownDotId, true);
            }
        }, dots.length * 20)
        if (!$scope.$$phase) {
            $scope.$apply();
        }
        orderDotsBy.orderdotBySomething($scope.dots);
        // pageLoading(true)

        $ionicLoading.hide();
        $timeout(function() {
            $scope.$broadcast($location.path(),{
                    'scrollTop':0,
                    'scrollLeft':0,
                    'showbrainrepair':true
                });//默认加载一次图片
        }, 10);
        // $scope.$watch('dots.length', function(newValue,old){
        //     // debugger
        //     if(newValue == $scope.dots.length){
        //         $scope.dots[0]
        //         debugger
        //         // $timeout(function() {
        //         //     $scope.$broadcast($location.path(),{
        //         //             'scrollTop':0,
        //         //             'scrollLeft':0,
        //         //             'showbrainrepair':true
        //         //         });//默认加载一次图片
        //         // }, 10);

        //     }

        // })

        // debugger
        //console.log('排序', $scope.dots);
    }

    var shouldExsist = false;
    /**
     * 获取当前节目或视频的相关信息、获取推送消息的相关接口
     * @return {[type]} [description]
     */
    function getWatchInfo() {
        Side.longPoll(commonId, watchType,function(result) {
                if (result && result.length > 0) {
                    angular.forEach(result, function(item) {
                        addCommentData(JSON.parse(item.data), true);
                    })
                }
                if (!shouldExsist) {
                    getWatchInfo();
                }
        }, function() {
            if (!shouldExsist) {
                getWatchInfo();
            }
        })
    }

    /**
     * 通过视频评论ID获取评论信息
     * @param  {[type]} commentId [description]
     * @return {[type]}           [description]
     */
    function getCommentById(commentId, isNew) {
        Side.getCommentById(commentId).$promise.then(function(result) {
            if (result.success && result.data && typeof result.data != 'undefined') {
                angular.forEach(result.data, function(item) {
                    if(!isNew){
                        item.isoldcomment = true
                    }else{
                        item.isoldcomment = false
                    }
                    item.playTime = parseInt(item.playTime);
                    addCommentData(item, isNew);
                })
                $ionicScrollDelegate.resize();
            } else {

            }
        })
    }
    /***语音的重复播放**/
    var currentPlayComment;
    var mediaPlayer=null;
    /**
     * 语音播放功能
     * @param  {[type]} comment     评论信息
     * @return {[type]}           [description]
     */
    function playAudio(comment) {
        if (currentPlayComment) {
            currentPlayComment.playing = false;
        }
        if(mediaPlayer!=null){
            mediaPlayer.pause();
        }
        //判断URL是否存在
        if (comment && comment.voice) {
            var url = comment.voice;
            if (url && url.indexOf('m4a') > -1) {
                comment.playing = true; //修改当前状态
                MediaSvc.play(url, function() {
                      //开始播放
                      console.log('play success end')
                      $timeout(function(){comment.playing = false});
                    }, function(err) {
                        $timeout(function(){comment.playing = false});
                    },function(player){
                        mediaPlayer=player;
                    },function(status){
                      if(status==4){
                        $timeout(function(){comment.playing = false});
                      }
                    })
            }
        }
        currentPlayComment = comment;

    }
    window.playAudio = playAudio;
    $scope.playAudio = playAudio;

    /**
     * 添加数据到页面中
     * @param {[type]} data [description]
     * @param {[type]} isNew 是否为新消息,
     */
    function addCommentData(data, isNew) {
        //解析数据
        if (data.playTime && data.playTime == 'null') {
            data.playTime = 0;
        }
        var user = User.getCurrentUser();
        if (user && user.userId == data.userId) {
            data.me = true;
        } else {
            data.me = false;
        }
        data.playTime = parseInt(data.playTime);
        data.commentTime=switchDate(data.commentTime);
        //识别语音消息
        if ((typeof(data.content)) == 'string') {
            // debugger
            if (data.content.indexOf("voice") > -1) {
                //播放语音
                var url = JSON.parse(data.content).voice;
                data.voice = url;
                data.playing = false;
            }
        }
        if (user && user.userId == data.userId && isNew == true) { //当收到的为即时消息并且消息是自己的时，更新数据
            return;
        }


        var dot = getShowDotByIdAndType(data.rootId, data.themeType);
        if (dot != null && typeof dot != 'undefined') {
            switch (parseInt(data.type)) {
                case 0: //视频；
                    if (filterCommentDump(dot.msgs, data)) {
                        dot.msgs.push(angular.extend({}, data));
                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    ChatEvent.scrollBottom(dot.uuid);
                    // debugger

                    // var commenttime = data.commentTime.replace(/-/g, "/")
                    // if(/\.\d/.test(commenttime)){
                    //     data.commentTime = new Date(Date.parse(commenttime.replace(/\.\d/g,"")))
                    // }else{
                    //     data.commentTime = new Date(Date.parse(commenttime))
                    // }

                    // debugger判断是否是历史评论
                    if(data.isoldcomment){
                        //历史
                        $scope.commentList.push(data)
                    }else{
                        //新消息
                        if((data.type=="0"||data.type==0) && data.content.indexOf("voice")<0 && data.playTime < $stateParams.movieLength){
                             data.playTime = $scope.time + 2;
                            $scope.$broadcast("addNewComment",data)//mark
                        }
                        $scope.commentList.unshift(data)
                    }

                    // console.log($scope.commentList)
                    break;
                case 1: //评论点赞；
                    //获取到Root

                    break;
                case 2: //投票；
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (data.content == dot.choice[i].vcId) { //当前选中的项
                            dot.choice[i].count++;
                            if (user && user.userId == data.userId) {
                                if (dot.choiceType == 1) { //单选类型
                                    dot.choice[i].status = 1;
                                    for (var j = 0; j < dot.choice.length; j++) {
                                        if (i != j) {
                                            dot.choice[j].status = 2;
                                        }
                                    }
                                } else if (dot.choiceType == 2) { //多选类型
                                    dot.choice[i].status = 1;
                                }
                            }
                        }

                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    break;

                case 3: //话题；
                    if (filterCommentDump(dot.msgs, data)) {
                        if(data.isoldcomment){
                            //历史
                            // $scope.commentList.push(data);
                            dot.msgs.push(angular.extend({}, data));
                        }else{
                            //新消息
                            // $scope.commentList.unshift(data);
                            dot.msgs.unshift(angular.extend({}, data));
                        }

                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    ChatEvent.scrollBottom(dot.uuid);
                    break;
                case 4: //评论(回复)；
                    if (data.themeType) {

                    }
                    break;
                case 5: //频道
                    if (filterCommentDump(dot.msgs, data)) {
                        dot.msgs.push(angular.extend({}, data));
                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    ChatEvent.scrollBottom(dot.uuid);
                    break;

                case 6: //竞猜
                    for (var i = 0; i < dot.choice.length; i++) {
                        if (data.content == dot.choice[i].vcId) { //当前选中的项
                            dot.choice[i].count++;
                            if (user && user.userId == data.userId) {
                                if (dot.choiceType == 1) { //单选类型
                                    dot.choice[i].status = 1;
                                    for (var j = 0; j < dot.choice.length; j++) {
                                        if (i != j) {
                                            dot.choice[j].status = 2;
                                        }
                                    }
                                } else if (dot.choiceType == 2) { //多选类型
                                    dot.choice[i].status = 1;
                                }
                            }
                        }

                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    break;
                case 7: //知识点
                    if (filterCommentDump(dot.msgs, data)) {
                        if(data.isoldcomment){
                            //历史
                            dot.msgs.push(angular.extend({}, data));
                        }else{
                            //新消息
                            dot.msgs.unshift(angular.extend({}, data));
                        }
                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    ChatEvent.scrollBottom(dot.uuid);
                    break;
                case 10://简介
                    if (filterCommentDump(dot.msgs, data)) {
                        if(data.isoldcomment){
                            //历史
                            dot.msgs.push(angular.extend({}, data));
                        }else{
                            //新消息
                            dot.msgs.unshift(angular.extend({}, data));
                        }
                    }
                    if (!$scope.$$phase) {
                        $scope.$apply();
                    }
                    ChatEvent.scrollBottom(dot.uuid);
                    break;
            }
        }
        //插入弹幕


    }
    $scope.loadMore = function(){
        // debugger
        var ids = [];
        if(historyids.length>9){
            ids = historyids.slice(0, 9)
            historyids = historyids.slice(10)
        }else if(historyids.length==0){
            // document.getElementById("nextPageComment").setAttribute("style","disabled:disabled !important")
            document.getElementById("nextPageComment").innerHTML = "无更多数据"
            // $scope.noMoreComment = true
        }else{
            ids = historyids;
            historyids = []
            $scope.noMoreItemsAvailable = true
            document.getElementById("nextPageComment").innerHTML = "无更多数据"
        }

        getCommentById(ids.join(','),false);
        // $ionicScrollDelegate.resize();
    }

    /**
     * 对评论数据排重
     * @param  {[type]} datas [description]
     * @param  {[type]} data  [description]
     * @return {[type]}       [description]
     */
    function filterCommentDump(datas, data) {
        var insertStatus = true;
        if (datas && data) {
            angular.forEach(datas, function(item) {
                if (item.cid == data.cid) {
                    insertStatus = false;
                }
            })
        }
        return insertStatus;
    }


    /**
     * 解析出评论中的点赞与评论
     * @param  {[type]} data [description]
     * @return {[type]}      [description]
     */
    function filterCommentData(data) {
        var user = User.getCurrentUser();
        var likeList = [],
            repyList = [];
        if (data && data.sunList) {
            angular.forEach(data.sunList, function(item) {
                switch (parseInt(item.type)) {
                    case 0: //视频；
                        break;
                    case 1: //评论点赞；
                        //判断是否点赞
                        if (user && item.userId == user.userId) {
                            data.isLike = true;
                        }
                        likeList.push(item);
                        break;
                    case 2: //投票；

                        break;
                    case 3: //话题；

                        break;
                    case 4: //评论(回复)；
                        repyList.push(item);
                        if (user && item.userId == user.userId) {
                            data.isRepy = true;
                        }
                        break;
                    case 5: //频道

                        break;
                }
            })
        }
        data.likeList = likeList;
        data.repyList = repyList;
    }

    /**
     * 获取需要显示的评论信息
     * @param  {[type]} currentTime [description]
     * @return {[type]}             [description]
     */
    function getShownCommentsByTime(currentTime) {
        var tempComments = [];
        if (globalCommentData && globalCommentData.length > 0) {
            if (globalCommentData && globalCommentData.length > 0) {
                angular.forEach(globalCommentData, function(item, index) {
                    //将之前未显示的内容直接显示
                    if (!item.hasShow && time > parseInt(item.playTime)) { //表示视频已经播放过了。
                        tempComments.push(item);
                        item.hasShow = true;
                    }
                });
            }
        }
        return tempComments;
    }
    /**
     * 初始化需要显示的信息
     * @param  {[type]} comments [description]
     * @return {[type]}          [description]
     */
    function initNeedShowComments(comments) {
        if (comments && comments.length > 0) {
            var ids = [];
            angular.forEach(comments, function(item) {
                ids.push(item.cid)
            })
            getCommentById(ids.join(','), false); //是否是新消息
        }
    }


    /**
     * 本地获取评论信息
     * @return {[type]} [description]
     */
    function getLocalCommentByCid(cid) {
        var comment;
        if ($scope.comments && $scope.comments.length > 0) {
            angular.forEach($scope.comments, function(item) {
                if (cid == item.cid) {
                    comment = item;
                    return false;
                }
            })
        }
        return comment;
    }
    /**
     * 根据打点ID获取打点信息
     * @param  {[type]} dotId [description]
     * @return {[type]}       [description]
     */
    function getShowDotByid(dotId) {
        var dot;
        angular.forEach($scope.dots, function(item, index) {
            if (dotId == item.dotId) {
                dot = item;
                return false;
            }
        });
        return dot;
    }
    /**
     * 根据UUID查找当前显示的Point 信息
     * @param  {[type]} uuid [description]
     * @return {[type]}      [description]
     */
    function getShowDotByUUID(uuid) {
        var dot;
        angular.forEach($scope.dots, function(item, index) {
            if (uuid == item.uuid) {
                dot = item;
                return false;
            }
        });
        return dot;
    }


    /**
     * [getShowDotByIdAndType description]
     * @param  {[type]} dotId [description]
     * @param  {[type]} type  [description]
     * @return {[type]}       [description]
     */
    function getShowDotByIdAndType(dotId, type) {
        var dot;
        angular.forEach($scope.dots, function(item, index) {
            if (dotId == item.dotId && type == item.type) {
                dot = item;
                return false;
            }
        });
        return dot;
    }
    /**
     * 获取打点信息CommentID
     * @param  {[type]} dotId     [description]
     * @param  {[type]} commentId [description]
     * @return {[type]}           [description]
     */
    function getCommentByDotAndId(dotId, commentId) {
        var dot = getShowDotByid(dotId);
        var comment;
        if (dot && dot.msgs && dot.msgs.length > 0) {
            angular.forEach(dot.msgs, function(item, index) {
                if (commentId == item.cid) {
                    comment = item;
                    return false;
                }
            });
        }
        return comment;
    }
    var oldVideoId, needLoadPoint = true;
    var initData = {};
    var beforeData = "";

    try {
        // console.log(DataInterface.getString())
        var itvId = JSON.parse(DataInterface.getString()).itvid;
        var pwd = 123456;
        var verifyCode = "-1";
        //toupinLogin.check(itvId, verifyCode, pwd, $scope);//不要自己登陆
    } catch (e) {
        $scope.errMsg = e.message;
    }
    var useplatform=3; //默认直接从插件获取进度
    var showtimeId;

    if($stateParams.tvhelper=='tvhelper'){
        useplatform=4;
        showtimeId = {
            "startedTime":startedTime,
            "movieLength":$stateParams.movieLength,
            "videoId":$stateParams.videoId,
            "moviename":decodeURIComponent($stateParams.moviename),
            "status":0//当前播放状态
        }
    }
    // id = $stateParams.id mark
    window.getPlatformStatus = function(callback) {
        //默认使用插件获取进度
        VideoStatusCore.getStatus({type:useplatform,showtimeId:showtimeId},function(HSData){
            if(useplatform==3){
                useplatform=HSData.play_screen==3?1:3
            }
            callback&&callback(HSData);
        },function(err){
            console.log('err'+err);
        });
    }
    var programtype = -1;
    /**
     * 获取设备当前状态信息
     * @param {[type]} [background] [是否显示正在加载]
     * @return {[type]} [description]
     */
    function getDeviceStatus(callback, background) {
        getPlatformStatus(function(data) {  //markt
            //记录上一次播放的类型，直播还是回看
            var videoStartTime = data.video_start_time;
            if (programtype != -1 && programtype != data.programtype + videoStartTime) {
                programtype = data.programtype;
                window.location.reload();
            } else {
                programtype = data.programtype + videoStartTime; //和时间组合起来判断
            }
            $scope.debugData = JSON.stringify(data);
            $scope.deviceStatus = data;
            videoId = data.programid;
            $scope.videoInfo = data;
            $scope.time = parseInt(data.relTime);
            time = $scope.time;
            callback && callback(data);
        });

    }
    var statusError = function() {
        if (!hasDialog) {
            var alertPopup = $ionicPopup.alert({
                title: '设备未开机？？',
                template: '请尝试打开电视播放视频',
                buttons: [{
                    text: '<b>重试</b>',
                    type: 'button-positive',
                    onTap: function(e) {

                    }
                }, {
                    text: '取消',
                    onTap: function(e) {
                        $rootScope.$broadcast('reload_devices');
                        $state.go('tab.tv');
                    }
                }]
            });
            hasDialog = true;
        }
    };
    $scope.statusErrorEvent = statusError;
    /**
     * 1.从后台获取打点信息列表
     * @return {[type]} [description]
     */
    function getDotInfo() {
        //如果为直播，或录播，需要查询的参数增多
        var id = videoId;
        var startTime, endTime;
        if (typeof DataInterface != 'undefined') {
            var obj = JSON.parse(DataInterface.getString());
            if (obj.programtype == "1") { //直播
                //获取当前北京时间
                var calcTime = new Date(); //北京时间到1970年1月1日秒数,模拟测试
                calcTime.setHours(calcTime.getHours() - 5);
                startTime = $filter('date')(calcTime, "yyyy-MM-dd HH:mm:ss"); //开始时间
                endTime = $filter('date')(calcTime.setHours(calcTime.getHours() + 10), "yyyy-MM-dd HH:mm:ss"); //在开始时间基础上加5小时
                //videoID为频道ID
                id = obj.programid;
                watchType = 1;
            } else if (obj.programtype == "2") { //回看
                var t = DataInterface.get('video_start_time');
                var calcTime = new Date(t.substring(0, 4), parseInt(t.substring(4, 6)) - 1, t.substring(6, 8), t.substring(8, 10), t.substring(10, 12), t.substring(12, 14));
                calcTime.setMinutes(calcTime.getMinutes()-1); //时间减去一分钟，防止主题时间为负值，取不到完整主题列表
                startTime = $filter('date')(calcTime, "yyyy-MM-dd HH:mm:ss"); //开始时间
                endTime = $filter('date')(calcTime.setHours(calcTime.getHours() + 5), "yyyy-MM-dd HH:mm:ss"); //在开始时间基础上加5小时
                id = obj.programid;
                watchType = 1;
            }
        }
        DotInfo.init($scope, watchType, id, startTime, endTime, function() {
            //重置数据，
            console.log('加载影片清空数据。。')
            $scope.thumbImgs = [];
            shouldToInitDots = [];
            shownDotId = -1;
            $scope.inputToolVisible = false;
            $scope.newPointNum = 0;
            if (!$scope.$$phase) {
                $scope.$apply();
            }
            mainScrollResize(); //重新计算输入框
        });
    }


    //消息显示方法
    function showMsg(msg) {
        $ionicLoading.hide();
        $ionicLoading.show({
            template: msg,
            duration: 1000,
            noBackdrop: true
        });
    }
    $scope.$on('$destroy', function(event) {
        time=0;
        VideoStatusCore.restore();
        $interval.cancel(globalTimer); //marktime

    })
    $scope.$on('side.msg', function(e, data) {
        //这里来发送消息
        sendCommentData(data.itemId, data);
    })
    $scope.$on('send.data', function(e, data) {
        if(data.dotidno&&data.dotidno!=""){
            sendCommentData(data.dotidno, data)
        }else{
            sendCommentData(videoId, data);
        }

        //sendCommentData(getShowDotByUUID(shownDotId).dotId, data);
    })
    init();

    /*给三边增加导航*/
    var movieovernavList=[
    {"title": "活动公开", "active": "H_font-color ion-activity", "not": "ion-activity"},
    {"title": "影后脑补", "active": "H_font-color ion-crown", "not": "ion-crown"},
    {"title": "猜你喜欢", "active": "H_font-color ion-address", "not": "ion-address"},
    ]
    $scope.movieovernavList=movieovernavList;
    angular.forEach($scope.movieovernavList,function(item,index){
        item.activated=index==1?true:false;
    })
     /*活动、脑补、猜你喜欢的显示隐藏*/
    $scope.showsidemore=true;
    $scope.showbrainrepair=true;
    $scope.showactivity=false;
    $scope.showyoulike=false;
    $scope.anwsers =[]
    $scope.showcommentbox=true;
    $scope.SwitchMovieoverNav=function(nownavitem,index){

        if(nownavitem.activated){

        }else{
            angular.forEach($scope.movieovernavList,function(item){
            item.activated=false;
            })

            nownavitem.activated=true;
            switch(index){
                 case 0:
                 {
                    if($scope.anwsers.length ==0){
                        $scope.anwsers = DotInfo.getActivityAnwsers()
                        // console.log($scope.anwsers)
                    }
                    $scope.inputToolVisible =false;
                    $scope.showbrainrepair=false;
                    $scope.showactivity=true;
                    $scope.showyoulike=false;
                    $scope.showcommentbox=false; //评论框的显示隐藏
                    break;
                 }
                 case 1:
                 {
                    $scope.inputToolVisible =true;
                    $scope.showbrainrepair=true;
                    $scope.showactivity=false;
                    $scope.showyoulike=false;
                    $scope.showcommentbox=true;
                    break;
                 }
                 case 2:
                 {
                    $scope.inputToolVisible =false;
                    $scope.showbrainrepair=false;
                    $scope.showactivity=false;
                    $scope.showyoulike=true;
                    $scope.showcommentbox=false;
                    break;
                 }
            }
        }
        $timeout(function(){
             $ionicScrollDelegate.resize();
             $scope.$broadcast(gobackaim+"back",{"status":false})
        },300);

    }
    /*弹幕屏缩放按钮状态*/
    $scope.ZoomStatus=1;
    /*三边缩放按钮状态*/
    $scope.ZoomSlideStatus=1;
    /*控制弹幕屏全屏半屏*/
    $scope.ZoomScreen=function(){
        $scope.ZoomStatus++;
        if($scope.ZoomStatus>2){
            $scope.ZoomStatus=1;
        }
            var screenheight=document.documentElement.clientHeight;
            var barragescreen=document.getElementById('H_zoom');
            if($scope.ZoomStatus==1)
            {
                barragescreen.style.height=200+'px';
                var data = 200;
                $scope.$broadcast("commentHalfScreen",data)
             }else{
                   if(device.platform == 'iOS'){
                      barragescreen.style.height=(screenheight-147)+'px';
                      var data = (screenheight-147)
                      $scope.$broadcast("commentFullScreen",data)
                   }else{
                      barragescreen.style.height=(screenheight-127)+'px';
                      var data = (screenheight-127)
                      $scope.$broadcast("commentFullScreen",data)
                   }

                   }
        }
         /*控制三边全屏半屏*/
    var barragescreen=document.getElementById('H_zoom');
    var slidescreen=document.getElementById('H_zoom-side');
    $scope.ZoomSlideScreen=function(){
         $scope.ZoomSlideStatus++;
        if($scope.ZoomSlideStatus>2)
        {
             $scope.ZoomSlideStatus=1;
        }
        if( $scope.ZoomSlideStatus==1){
            barragescreen.style.display='block';
            $scope.showsidenav=false;

    }else{
            barragescreen.style.display='none';
            $scope.showsidenav=false;
        }
    }

    /*控制导航栏的显示*/
  $scope.showsidenav=false;
  /*猜你喜欢页面*/

  //这里查询猜你喜欢相关信息


  var longitude=$rootScope.userlocation.locations.longitude;
  var latitude=$rootScope.userlocation.locations.latitude;
  InterfaceSide.selectPointInfo(8,videoId,longitude,latitude).$promise.then(function(result){
    if(result.success){
        $scope.nearLikeList=result.data;
    }else{
        console.log('猜你喜欢查询失败')
    }
  },function(err){

  })

  /**
   * @description ｛三边搜索｝
   * @author Vivian
   * @date 2015/05/23
   */
          var indexId = 0;
          var uuid = '';
          var isEnd = false;
          var desFlag = true;
          $scope.data = {
              searchQuery: ''
          }

          // $scope.searchResult = [];

          $scope.genResults = []; // 泛搜索结果
          $scope.shopResults = []; //商品的结果
          $scope.baikeResult = []; //百科的结果

          var search = function(keyword, indexId, uuid) {
              // $scope.searchResult = [];
              var keyword = $scope.data.searchQuery;
              Side.sideSearch(keyword, indexId, uuid).$promise.then(function(result) {
                  if (result.success) {
                      // console.log(result.data);
                      if(result.data&&result.data.objects&&result.data.objects.length>0){
                          $ionicLoading.hide();
                          for (var i = 0; i < result.data.objects.length; i++) {
                              var item = result.data.objects[i];
                              switch (parseInt(item.searchTypeId)) {
                                  case 1: //泛搜索
                                  angular.forEach(JSON.parse(item.json),function(items){
                                          $scope.genResults.push(items);
                                          for(var i=0;i<$scope.genResults.length;i++){
                                              $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                          }
                                      })
                                      // $scope.genResultList=$scope.genResults.concat(JSON.parse(item.json));
                                      break;
                                  case 15://商品搜索
                                      angular.forEach(JSON.parse(item.json),function(items){
                                          $scope.shopResults.push(items);
                                          for(var i=0;i<$scope.genResults.length;i++){
                                              $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                          }
                                      })
                                      break;
                                  case 17://百科搜索
                                      angular.forEach(JSON.parse(item.json),function(items){
                                          $scope.baikeResult.push(items);
                                          for(var i=0;i<$scope.genResults.length;i++){
                                              $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                          }
                                      })
                                      break;
                              }
                          }
                      }
                      isEnd = JSON.parse(result.data.isEnd);
                      if(!isEnd && desFlag){
                          search($scope.data.searchQuery,result.data.index,result.data.uuid);
                      }
                  }else if(!result.success){
                          $ionicLoading.show({
                              template: '请求超时',
                              noBackdrop: true,
                              duration: 1000
                          });
                      }else{
                          $ionicLoading.show({
                              template: '无数据，换个词搜搜？',
                              noBackdrop: true,
                              duration: 1000
                          });
                      }
              })

          }


          $scope.searchEvent = function() {
              var keyword = $scope.data.searchQuery;
              if (keyword && "" != keyword) {
                  $ionicLoading.show();
                  ////清空还原数组
                  $scope.genResults=[];
                  $scope.shopResults=[];
                  $scope.baikeResult=[];
                  $ionicScrollDelegate.resize();
                  search($scope.data.searchQuery, indexId, uuid);
              }
          }

          $scope.$on('$destroy',function(){
              desFlag = false;
            if(mediaPlayer!=null){
                mediaPlayer.pause();
            }
          })

          // $scope.linkUrl = function(url){
          //     window.open(url,'_system');
          // }
          $scope.linkUrl = function(url){
              window.open(url,'_blank','location=yes','closebuttoncaption=Done');
          }
      // .filter('replace',function(){
      //     // String.prototype.replaceAll = function(reallyDo, replaceWith, ignoreCase) {
      //     //     if (!RegExp.prototype.isPrototypeOf(reallyDo)) {
      //     //         return this.replace(new RegExp(reallyDo, (ignoreCase ? "gi": "g")), replaceWith);
      //     //     } else {
      //     //         return this.replace(reallyDo, replaceWith);
      //     //     }
      //     // }
      //     String.prototype.replaceAll=function(s2, s3){
      //           var r = new RegExp(s2.replace(/([\(\)\[\]\{\}\^\$\+\-\*\?\.\"\'\|\/\\])/g, "\\$1"), "ig");

      //    }
      //     var replace = function(keyword,content){
      //         for(var i=0;i<$scope.genResults.length;i++){
      //             content = $scope.genResults[i].title;
      //             $scope.genResults[i].title=content.replaceAll(keyword,"<span class='positive'>"+keyword+"</span>");
      //         }
      //         // content.replace('<span class="positive">keyword</span>','keyword');
      //     }
      //     return replace;
      // })


})
