'use strict';
/**
 * 评论功能输入框
 */
rootModule
    .directive('commentInput',function($compile,Toast,$timeout,$ionicPopup,$rootScope,$stateParams, User, $state, $ionicScrollDelegate, InterfaceSide){
      var linker = function(scope,element,attrs){
        var inputboxtemple =angular.element('<div class="sb-input-warpper inputboxhide showinput" id="inputbox" keyboard-attach>'+
          '<button class="sb-input-warpper ng-hide button button-clear" ng-show="noLogin" on-touch="openLoginPageEvent()" style="height:42px;text-align: center;line-height: 42px;font-size: 1.3rem;color: #888;">登录后可参与互动</button>'+
          '<div class="sb-box" ng-hide="noLogin">'+
          '<textarea type="text" class="sb-input ng-pristine ng-untouched ng-valid commenttext" resize="none" ng-model="inputtext.comment" id="commenttext"></textarea>'+
          '<button class="icon sb-send-btn sb-icon text"  ng-click="sendCommentEvent();$event.stopPropagation();"></button>'+
          '</div>'+
          '</div>');
        element.append(inputboxtemple);
        scope.playCommentList = []; // 保存评论数据
        if(attrs.videoid){
          var commentId = attrs.videoid; //被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
          var rootId = attrs.videoid; //评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)

        }else{
          var commentId = $stateParams.id; //被评论人ID(视频ID或话题ID或评论ID或投票ID或频道ID)
          var rootId = $stateParams.id; //评论时的根主题Id：(视频ID或话题ID或投票ID或频道ID)
        }

        /**
         * 添加成果评论（用户发送）
         * @return {[type]} [description]
         */
        scope.sendCommentEvent = function(){
          var user =  User.userIsLogin();//判断用户是否登录
          if (user) {
              //2.判断用户是否输入了内容
              if (scope.inputtext.comment != "") {

                  //3.组织数据type, commentId, rootId, themeType, content, deviceId, playTime
                  var type = attrs.typeno; //8标识为乐配评论 0视屏 对谁发表的内容，即谁的评论


                  var themeType = attrs.themetype; //乐配类型
                  var content = scope.inputtext.comment; //发送的内容
                  var deviceId = -1; //设备ID，仅在三边观看情况有
                  var playTime = 0; //当前视频播放的时间
                  console.log(type)
                  console.log(attrs.typeno)
                  console.log(commentId+"kjdfjsdkdkjfdfskjdf")
                  //4.将数据发送到服务器
                  InterfaceSide.add_theme_talk(type, commentId, rootId, themeType, content, deviceId, playTime).$promise.then(function(result) {
                      if (result.success) {

                          //4.发送评论数据成功，发送消息
                          $rootScope.$broadcast(commentId,{
                            comment:{
                              type: type,
                              comentId: commentId,
                              rootId: rootId,
                              content: content,
                              deviceId: -1,
                              themeType: type,
                              playTime: 0,
                              userId: user.userId,
                              nickname: user.nickName,
                              headImg: user.headImg,
                              commentTime: new Date()
                          }
                          })
                          scope.inputtext.comment = ""; //清空输入框
                          $ionicScrollDelegate.resize();
                      } else {
                          Toast.show('发送评论失败')
                      }
                  }, function(err) {
                      Toast.show('发送评论失败')
                  })
              } else {
                  Toast.show('发送的内容不能为空')
              }
          } else {
              Toast.show('请登录后再来吐槽吧！');
          }
        }
        scope.openLoginPageEvent = function() {
            $state.go('login');//跳转登录页面ma
            if (typeof LaunchMode != 'undefined') {
                LaunchMode.log();
            }
        }
        scope.noLogin=false;
        $timeout(function() {
            //判断用户是否登录
            if (User.getCurrentUser() == null) {
                scope.noLogin = true;
            } else {
                scope.noLogin = false;
            }
        }, 1000)
        // 监听页面滚动事件
        var eventname = attrs.elementid
        scope.$on(attrs.elementid,function(e,data){
            if(data.status){
              element[0].querySelector(".showinput").className = "sb-input-warpper inputboxshow showinput"
            }else{
              element[0].querySelector(".showinput").className = "sb-input-warpper inputboxhide showinput"
              element[0].querySelector(".commenttext").value = ""
            }


        })
        $compile(element.contents())(scope);
      }

      return{
        restrict:"AE",
        link:linker,
        replace:false
      }

    })