'use strict';
/**
 * 全局搜索
 * @author  SuperK
 * @link http://www.woaiso.com
 * @date 2015/05/06
 */
rootModule
    .directive('searchPage', function($compile,$templateCache,$ionicModal,Side,$ionicLoading,$ionicScrollDelegate) {
        var linker = function($scope, element, attrs) {
            // debugger
            element.on("click", function() {
                //判断加载类型
                // debugger
                // $templateCache.put('templates/side-search.html');
                $ionicModal.fromTemplateUrl('templates/side-search.html', {
                    scope: $scope,
                    animation: 'slide-in-up'
                }).then(function(modal) {
                    $scope.modal = modal;
                    modal.show();
                });

            })


            $scope.closeModal = function() {
                $scope.modal.remove();
                $scope.genResults = []; // 泛搜索结果
                $scope.shopResults = []; //商品的结果
                $scope.baikeResult = []; //百科的结果
                $scope.data.searchQuery = [];

            };
            var indexId = 0;
            var uuid = '';
            var isEnd = false;
            var desFlag = true;
            $scope.data = {
                searchQuery: ''
            }

            // $scope.searchResult = [];

            $scope.genResults = []; // 泛搜索结果
            $scope.shopResults = []; //商品的结果
            $scope.baikeResult = []; //百科的结果

            var search = function(keyword, indexId, uuid) {
                // $scope.searchResult = [];
                var keyword = $scope.data.searchQuery;
                Side.sideSearch(keyword, indexId, uuid).$promise.then(function(result) {
                    if (result.success) {
                        console.log(result.data);
                        if(result.data&&result.data.objects&&result.data.objects.length>0){
                            $ionicLoading.hide();
                            for (var i = 0; i < result.data.objects.length; i++) {
                                var item = result.data.objects[i];
                                switch (parseInt(item.searchTypeId)) {
                                    case 1: //泛搜索
                                    angular.forEach(JSON.parse(item.json),function(items){
                                            $scope.genResults.push(items);
                                            for(var i=0;i<$scope.genResults.length;i++){
                                                $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                            }
                                        })
                                        // $scope.genResultList=$scope.genResults.concat(JSON.parse(item.json));
                                        break;
                                    case 15://商品搜索
                                        angular.forEach(JSON.parse(item.json),function(items){
                                            $scope.shopResults.push(items);
                                            for(var i=0;i<$scope.genResults.length;i++){
                                                $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                            }
                                        })
                                        break;
                                    case 17://百科搜索
                                        angular.forEach(JSON.parse(item.json),function(items){
                                            $scope.baikeResult.push(items);
                                            for(var i=0;i<$scope.genResults.length;i++){
                                                $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                            }
                                        })
                                        break;
                                }
                            }
                        }
                        isEnd = JSON.parse(result.data.isEnd);
                        if(!isEnd && desFlag){
                            search($scope.data.searchQuery,result.data.index,result.data.uuid);
                        }
                    }else if(!result.success){
                            $ionicLoading.show({
                                template: '请求超时',
                                noBackdrop: true,
                                duration: 1000
                            });
                        }else{
                            $ionicLoading.show({
                                template: '无数据，换个词搜搜？',
                                noBackdrop: true,
                                duration: 1000
                            });
                        }
                })

            }


            $scope.searchEvent = function() {
                var keyword = $scope.data.searchQuery;
                if (keyword && "" != keyword) {
                    $ionicLoading.show();
                    ////清空还原数组
                    $scope.genResults=[];
                    $scope.shopResults=[];
                    $scope.baikeResult=[];
                    $ionicScrollDelegate.resize();
                    search($scope.data.searchQuery, indexId, uuid);
                }
            }

            $scope.$on('$destroy',function(){
                desFlag = false;
            })

            // $scope.linkUrl = function(url){
            //     window.open(url,'_system');
            // }
            $scope.linkUrl = function(url){
                window.open(url,'_blank','location=yes','closebuttoncaption=Done');
            }
        }
        return {
            restrict: "EA",
            link: linker,
            replace: true,
        };
    });