/**
 * @description ｛搜索｝
 * @author Vivian
 * @date 2015/05/23
 */
rootModule
    .controller('SideSearchCtrl', function($scope,$resource, Side, $ionicLoading,$ionicScrollDelegate) {

        var indexId = 0;
        var uuid = '';
        var isEnd = false;
        var desFlag = true;
        $scope.data = {
            searchQuery: ''
        }

        // $scope.searchResult = [];

        $scope.genResults = []; // 泛搜索结果
        $scope.shopResults = []; //商品的结果
        $scope.baikeResult = []; //百科的结果

        var search = function(keyword, indexId, uuid) {
            // $scope.searchResult = [];
            var keyword = $scope.data.searchQuery;
            Side.sideSearch(keyword, indexId, uuid).$promise.then(function(result) {
                if (result.success) {
                    console.log(result.data);
                    if(result.data&&result.data.objects&&result.data.objects.length>0){
                        $ionicLoading.hide();
                        for (var i = 0; i < result.data.objects.length; i++) {
                            var item = result.data.objects[i];
                            switch (parseInt(item.searchTypeId)) {
                                case 1: //泛搜索
                                angular.forEach(JSON.parse(item.json),function(items){
                                        $scope.genResults.push(items);
                                        for(var i=0;i<$scope.genResults.length;i++){
                                            $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                        }
                                    })
                                    // $scope.genResultList=$scope.genResults.concat(JSON.parse(item.json));
                                    break;
                                case 15://商品搜索
                                    angular.forEach(JSON.parse(item.json),function(items){
                                        $scope.shopResults.push(items);
                                        for(var i=0;i<$scope.genResults.length;i++){
                                            $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                        }
                                    })
                                    break;
                                case 17://百科搜索
                                    angular.forEach(JSON.parse(item.json),function(items){
                                        $scope.baikeResult.push(items);
                                        for(var i=0;i<$scope.genResults.length;i++){
                                            $scope.genResults[i].title = $scope.genResults[i].title.replace(keyword,"<span class='positive'>"+keyword+"</span>");
                                        }
                                    })
                                    break;
                            }
                        }
                    }
                    isEnd = JSON.parse(result.data.isEnd);
                    if(!isEnd && desFlag){
                        search($scope.data.searchQuery,result.data.index,result.data.uuid);
                    }
                }else if(!result.success){
                        $ionicLoading.show({
                            template: '请求超时',
                            noBackdrop: true,
                            duration: 1000
                        });
                    }else{
                        $ionicLoading.show({
                            template: '无数据，换个词搜搜？',
                            noBackdrop: true,
                            duration: 1000
                        });
                    }
            })

        }


        $scope.searchEvent = function() {
            var keyword = $scope.data.searchQuery;
            if (keyword && "" != keyword) {
                $ionicLoading.show();
                ////清空还原数组
                $scope.genResults=[];
                $scope.shopResults=[];
                $scope.baikeResult=[];
                $ionicScrollDelegate.resize();
                search($scope.data.searchQuery, indexId, uuid);
            }
        }

        $scope.$on('$destroy',function(){
            desFlag = false;
        })

        // $scope.linkUrl = function(url){
        //     window.open(url,'_system');
        // }
        $scope.linkUrl = function(url){
            window.open(url,'_blank','location=yes','closebuttoncaption=Done');
        }
    })
    // .filter('replace',function(){
    //     // String.prototype.replaceAll = function(reallyDo, replaceWith, ignoreCase) {  
    //     //     if (!RegExp.prototype.isPrototypeOf(reallyDo)) {  
    //     //         return this.replace(new RegExp(reallyDo, (ignoreCase ? "gi": "g")), replaceWith);  
    //     //     } else {  
    //     //         return this.replace(reallyDo, replaceWith);  
    //     //     }  
    //     // }  
    //     String.prototype.replaceAll=function(s2, s3){
    //           var r = new RegExp(s2.replace(/([\(\)\[\]\{\}\^\$\+\-\*\?\.\"\'\|\/\\])/g, "\\$1"), "ig");
       
    //    }
    //     var replace = function(keyword,content){
    //         for(var i=0;i<$scope.genResults.length;i++){
    //             content = $scope.genResults[i].title;
    //             $scope.genResults[i].title=content.replaceAll(keyword,"<span class='positive'>"+keyword+"</span>");
    //         }
    //         // content.replace('<span class="positive">keyword</span>','keyword');
    //     }
    //     return replace;
    // })