rootModule
    .service('TemplateSvc', function($http, $q) {
        function getTemplate(pageId) {
            var deferred = $q.defer();

            $http.get(pageId).success(function(response, status, headers, config) {
                deferred.resolve(response);
            })
                .error(function(errResp) {
                    deferred.reject({
                        message: "Really bad"
                    });
                });
            return deferred.promise;
        }
        return {
            getTemplate: getTemplate
        }
    })